(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Capnp = Npm.require("capnp");                                                                                     // 18
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 19
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                              // 20
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 22
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 27
                                                                                                                      //
Meteor.methods({                                                                                                      // 29
  newFrontendRef: function newFrontendRef(sessionId, frontendRef) {                                                   // 30
    // Completes a powerbox request for a frontendRef capability.                                                     //
    check(sessionId, String);                                                                                         // 32
    // frontendRef is type-checked by frontendRefRegistry.validate(), below.                                          //
                                                                                                                      //
    var db = this.connection.sandstormDb;                                                                             // 35
    var frontendRefRegistry = this.connection.frontendRefRegistry;                                                    // 36
                                                                                                                      //
    var session = db.collections.sessions.findOne({ _id: sessionId, userId: this.userId || { $exists: false } });     // 38
    if (!session) {                                                                                                   // 40
      throw new Meteor.Error(403, "Invalid session ID");                                                              // 41
    }                                                                                                                 // 42
                                                                                                                      //
    var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRef);                               // 30
                                                                                                                      //
    var descriptor = _frontendRefRegistry$.descriptor;                                                                // 30
    var requirements = _frontendRefRegistry$.requirements;                                                            // 30
                                                                                                                      //
    descriptor = encodePowerboxDescriptor(descriptor);                                                                // 45
                                                                                                                      //
    var grainId = session.grainId;                                                                                    // 47
    var apiTokenOwner = {                                                                                             // 48
      clientPowerboxRequest: {                                                                                        // 49
        grainId: grainId,                                                                                             // 50
        introducerIdentity: session.identityId,                                                                       // 51
        sessionId: session._id                                                                                        // 52
      }                                                                                                               // 49
    };                                                                                                                // 48
                                                                                                                      //
    var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                              // 56
    var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                        // 57
    cap.close();                                                                                                      // 58
    return { sturdyRef: sturdyRef, descriptor: descriptor };                                                          // 59
  },                                                                                                                  // 60
  fulfillUiViewRequest: function fulfillUiViewRequest(sessionId, identityId, grainId, petname, roleAssignment, ownerGrainId) {
    var db = this.connection.sandstormDb;                                                                             // 63
    check(sessionId, String);                                                                                         // 64
    check(identityId, String);                                                                                        // 65
    check(grainId, String);                                                                                           // 66
    check(roleAssignment, db.roleAssignmentPattern);                                                                  // 67
    check(petname, String);                                                                                           // 68
    check(ownerGrainId, String);                                                                                      // 69
                                                                                                                      //
    if (!this.userId || !db.userHasIdentity(this.userId, identityId)) {                                               // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                              // 72
    }                                                                                                                 // 73
                                                                                                                      //
    var provider = {                                                                                                  // 75
      identityId: identityId,                                                                                         // 76
      accountId: this.userId                                                                                          // 77
    };                                                                                                                // 75
                                                                                                                      //
    var title = db.userGrainTitle(grainId, this.userId, identityId);                                                  // 80
                                                                                                                      //
    var descriptor = encodePowerboxDescriptor({                                                                       // 82
      tags: [{ id: Grain.UiView.typeId,                                                                               // 83
        value: Capnp.serialize(Grain.UiView.PowerboxTag, { title: title })                                            // 85
      }]                                                                                                              // 84
    });                                                                                                               // 82
                                                                                                                      //
    var owner = {                                                                                                     // 90
      clientPowerboxRequest: {                                                                                        // 91
        grainId: ownerGrainId,                                                                                        // 92
        introducerIdentity: identityId,                                                                               // 93
        sessionId: sessionId                                                                                          // 94
      }                                                                                                               // 91
    };                                                                                                                // 90
                                                                                                                      //
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);       // 98
                                                                                                                      //
    return {                                                                                                          // 101
      sturdyRef: result.token,                                                                                        // 102
      descriptor: descriptor                                                                                          // 103
    };                                                                                                                // 101
  }                                                                                                                   // 105
});                                                                                                                   // 29
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 109
    _classCallCheck(this, PowerboxOption);                                                                            // 109
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 110
  }                                                                                                                   // 111
                                                                                                                      //
  PowerboxOption.prototype.intersect = function intersect(other) {                                                    //
    // Intersect two options with the same ID. Used when combining matches from multiple tags                         //
    // in the same descriptor. The tags are a conjunction.                                                            //
    //                                                                                                                //
    // Returns true if there was any overlap, or false if there was no overlap and therefore the                      //
    // option should be dropped.                                                                                      //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 122
      throw new Error("can only merge options with the same ID");                                                     // 123
    }                                                                                                                 // 124
                                                                                                                      //
    if (other.grainId) {                                                                                              // 126
      if (this.uiView && !other.uiView) delete this.uiView;                                                           // 127
      if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                         // 128
      return !!(this.uiView || this.hostedObject);                                                                    // 129
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 130
      // Try to hint which verifierId matched.                                                                        //
      if (this.frontendRef.verifiedEmail.verifierId) {                                                                // 132
        if (other.frontendRef.verifiedEmail.verifierId) {                                                             // 133
          // Can't match multiple verifiers at once.                                                                  //
          return false;                                                                                               // 135
        }                                                                                                             // 136
      } else if (other.frontendRef.verifiedEmail.verifierId) {                                                        // 137
        // One request did not specify any verifierId, the other did, and both matched, so use                        //
        // the verifierId.                                                                                            //
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 140
      }                                                                                                               // 141
                                                                                                                      //
      return true;                                                                                                    // 143
    } else {                                                                                                          // 144
      // No intersection logic needed for other types.                                                                //
      return true;                                                                                                    // 146
    }                                                                                                                 // 147
  };                                                                                                                  // 148
                                                                                                                      //
  PowerboxOption.prototype.union = function union(other) {                                                            //
    // Union two options with the same ID. Used when combining matches from multiple descriptors.                     //
    // The descriptors are a disjunction.                                                                             //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 156
      throw new Error("can only merge options with the same ID");                                                     // 157
    }                                                                                                                 // 158
                                                                                                                      //
    if (other.grainId) {                                                                                              // 160
      if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                   // 161
      if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                           // 162
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 163
      // If this doesn't have a verifierId but other does, copy it over.                                              //
      if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {                 // 165
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 167
      }                                                                                                               // 168
    }                                                                                                                 // 169
  };                                                                                                                  // 170
                                                                                                                      //
  PowerboxOption.prototype.subtract = function subtract(other) {                                                      //
    // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                       //
    // if there's anything left, false otherwise.                                                                     //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 176
      throw new Error("can only merge options with the same ID");                                                     // 177
    }                                                                                                                 // 178
                                                                                                                      //
    if (other.grainId) {                                                                                              // 180
      if (this.uiView && other.uiView) delete this.uiView;                                                            // 181
      if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                          // 182
      return !!(this.uiView || this.hostedObject);                                                                    // 183
    } else {                                                                                                          // 184
      return false;                                                                                                   // 185
    }                                                                                                                 // 186
  };                                                                                                                  // 187
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 190
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                //
                                                                                                                      //
  frontendRefRegistry.register({                                                                                      // 193
    typeId: Grain.UiView.typeId,                                                                                      // 194
                                                                                                                      //
    query: function query(db, userId, value) {                                                                        // 196
      if (!userId) return [];                                                                                         // 197
                                                                                                                      //
      // TODO(someday): Allow `value` to specify app IDs to filter for.                                               //
                                                                                                                      //
      var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                            // 201
        return token.grainId;                                                                                         // 201
      });                                                                                                             // 201
      var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                                // 202
        return grain._id;                                                                                             // 202
      });                                                                                                             // 202
                                                                                                                      //
      return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                    // 204
        return new PowerboxOption({                                                                                   // 205
          _id: "grain-" + grainId,                                                                                    // 206
          grainId: grainId,                                                                                           // 207
          uiView: {},                                                                                                 // 208
          cardTemplate: "grainPowerboxCard",                                                                          // 209
          configureTemplate: "uiViewPowerboxConfiguration"                                                            // 210
        });                                                                                                           // 205
      });                                                                                                             // 212
    }                                                                                                                 // 213
  });                                                                                                                 // 193
}                                                                                                                     // 215
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 217
  var _this = this;                                                                                                   // 217
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             //
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           //
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               //
  // `powerboxOptions`. Each item has the following fields:                                                           //
  //                                                                                                                  //
  //   _id: Unique identifier string.                                                                                 //
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    //
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     //
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  //
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               //
  //        to be either a string or an `ObjectID`.                                                                   //
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       //
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            //
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        //
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      //
  //       of the field is the same as ApiTokens.frontendRef.                                                         //
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        //
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        //
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     //
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     //
  //       object with the fields:                                                                                    //
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     //
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      //
  //         permissions when requesting a plain UiView.                                                              //
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      //
  //       match the query. If selected, a request session to the grain embedded should be shown                      //
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    //
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     //
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       //
  //       template's data context will be a "card" object as returned by                                             //
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      //
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       //
  //       and returns the URL of the icon to display next to the option.                                             //
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       //
  //       client-side template for that dialog.                                                                      //
  //   ...: Other fields may be added for consumption by the client-side template.                                    //
                                                                                                                      //
  var results = {};                                                                                                   // 255
  var db = this.connection.sandstormDb;                                                                               // 256
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 257
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 259
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 260
      // Decode the descriptor.                                                                                       //
      // TODO(now): Also single-segment? Canonical?                                                                   //
                                                                                                                      //
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           //
      var descriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });
                                                                                                                      //
      if (!descriptor.tags || descriptor.tags.length === 0) return {};                                                // 270
                                                                                                                      //
      // Expand each tag into a match map.                                                                            //
      var tagMatches = descriptor.tags.map(function (tag) {                                                           // 273
        var result = {};                                                                                              // 274
                                                                                                                      //
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 276
          result[option._id] = new PowerboxOption(option);                                                            // 277
        });                                                                                                           // 278
                                                                                                                      //
        return result;                                                                                                // 280
      });                                                                                                             // 281
                                                                                                                      //
      // Intersect two tags' matches.                                                                                 //
      var matches = tagMatches.reduce(function (a, b) {                                                               // 284
        for (var id in a) {                                                                                           // 285
          if (id in b) {                                                                                              // 286
            if (!a[id].intersect(b[id])) {                                                                            // 287
              // Empty intersection.                                                                                  //
              delete a[id];                                                                                           // 289
            }                                                                                                         // 290
          } else {                                                                                                    // 291
            // This match only exists in a, not b, so delete it.                                                      //
            delete a[id];                                                                                             // 293
          }                                                                                                           // 294
        }                                                                                                             // 295
                                                                                                                      //
        return a;                                                                                                     // 297
      });                                                                                                             // 298
                                                                                                                      //
      return { descriptor: descriptor, matches: matches };                                                            // 300
    });                                                                                                               // 301
                                                                                                                      //
    // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                    //
    //   supposed to compare descriptors to determine which ones are more specific than which                         //
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   //
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           //
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        //
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        //
    //   list.                                                                                                        //
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 311
      if (clause.matchQuality === "unacceptable") {                                                                   // 312
        // Remove b's matches from a.                                                                                 //
        for (var id in clause.matches) {                                                                              // 314
          if (id in finalMatches) {                                                                                   // 315
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 316
              delete finalMatches[id];                                                                                // 317
            }                                                                                                         // 318
          }                                                                                                           // 319
        }                                                                                                             // 320
                                                                                                                      //
        return finalMatches;                                                                                          // 322
      } else {                                                                                                        // 323
        for (var _id in clause.matches) {                                                                             // 324
          if (_id in finalMatches) {                                                                                  // 325
            finalMatches[_id].union(clause.matches[_id]);                                                             // 326
          } else {                                                                                                    // 327
            finalMatches[_id] = clause.matches[_id];                                                                  // 328
          }                                                                                                           // 329
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 331
            finalMatches[_id].matchQuality = "preferred";                                                             // 332
          }                                                                                                           // 333
        }                                                                                                             // 334
                                                                                                                      //
        return finalMatches;                                                                                          // 336
      }                                                                                                               // 337
    }, {});                                                                                                           // 338
                                                                                                                      //
    for (var id in matches) {                                                                                         // 340
      if (!matches[id].matchQuality) {                                                                                // 341
        matches[id].matchQuality = "acceptable";                                                                      // 342
      }                                                                                                               // 343
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 345
      this.added("powerboxOptions", id, matches[id]);                                                                 // 346
    }                                                                                                                 // 347
  }                                                                                                                   // 348
                                                                                                                      //
  // TODO(someday): Make reactive? Seems annoying.                                                                    //
                                                                                                                      //
  this.ready();                                                                                                       // 352
});                                                                                                                   // 353
                                                                                                                      //
SandstormPowerbox = { registerUiViewQueryHandler: registerUiViewQueryHandler };                                       // 355
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
