var require = meteorInstall({"imports":{"server":{"accounts":{"ldap.js":["babel-runtime/helpers/typeof","ldapjs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/ldap.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({LDAP:function(){return LDAP}});var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var ldapjs;module.import("ldapjs",{"default":function(v){ldapjs=v}});
var Future = Npm.require("fibers/future");                                                                             // 1
                                                                                                                       // 2
                                                                                                                       //
// At a minimum, set up LDAP_DEFAULTS.url and .dn according to                                                         //
// your needs. url should appear as 'ldap://your.url.here'                                                             //
// dn should appear in normal ldap format of comma separated attribute=value                                           //
// e.g. 'uid=someuser,cn=users,dc=somevalue'                                                                           //
LDAP_DEFAULTS = {                                                                                                      // 8
  url: false,                                                                                                          // 9
  port: "389",                                                                                                         // 10
  dn: false,                                                                                                           // 11
  searchDN: false,                                                                                                     // 12
  searchCredentials: false,                                                                                            // 13
  createNewUser: true,                                                                                                 // 14
  defaultDomain: false,                                                                                                // 15
  searchResultsProfileMap: false,                                                                                      // 16
  base: null,                                                                                                          // 17
  search: "(objectclass=*)",                                                                                           // 18
  ldapsCertificate: false                                                                                              // 19
};                                                                                                                     // 8
                                                                                                                       //
/**                                                                                                                    //
 @class LDAP                                                                                                           //
 @constructor                                                                                                          //
 */                                                                                                                    //
function LDAP() {                                                                                                      // 26
  // Set options                                                                                                       //
  this.options = _.clone(LDAP_DEFAULTS);                                                                               // 28
};                                                                                                                     // 29
                                                                                                                       //
/**                                                                                                                    //
 * Attempt to bind (authenticate) ldap                                                                                 //
 * and perform a dn search if specified                                                                                //
 *                                                                                                                     //
 * @method ldapCheck                                                                                                   //
 *                                                                                                                     //
 * @param {Object} options  Object with username, ldapPass and overrides for LDAP_DEFAULTS object.                     //
 * Additionally the searchBeforeBind parameter can be specified, which is used to search for the DN                    //
 * if not provided.                                                                                                    //
 */                                                                                                                    //
LDAP.prototype.ldapCheck = function (db, options) {                                                                    // 41
                                                                                                                       //
  var _this = this;                                                                                                    // 43
                                                                                                                       //
  options = options || {};                                                                                             // 45
                                                                                                                       //
  if (options.hasOwnProperty("username") && options.hasOwnProperty("ldapPass") || options.hasOwnProperty("searchUsername")) {
    var _ret = function () {                                                                                           // 48
      _this.options.base = db.getLdapBase();                                                                           // 49
      _this.options.url = db.getLdapUrl();                                                                             // 50
      _this.options.searchBeforeBind = {};                                                                             // 51
      _this.options.searchBeforeBind[db.getLdapSearchUsername()] = options.searchUsername || options.username;         // 52
      _this.options.filter = db.getLdapFilter() || "(objectclass=*)";                                                  // 54
      _this.options.searchBindDn = db.getLdapSearchBindDn();                                                           // 55
      _this.options.searchBindPassword = db.getLdapSearchBindPassword();                                               // 56
                                                                                                                       //
      var resolved = false;                                                                                            // 58
      var ldapAsyncFut = new Future();                                                                                 // 59
                                                                                                                       //
      // Create ldap client                                                                                            //
      var fullUrl = db.getLdapUrl();                                                                                   // 62
      var client = null;                                                                                               // 63
                                                                                                                       //
      var errorFunc = function errorFunc(err) {                                                                        // 65
        if (err) {                                                                                                     // 66
          if (resolved) return;                                                                                        // 67
          resolved = true;                                                                                             // 68
          ldapAsyncFut["return"]({                                                                                     // 69
            error: err                                                                                                 // 70
          });                                                                                                          // 69
        }                                                                                                              // 72
      };                                                                                                               // 73
                                                                                                                       //
      if (fullUrl.indexOf("ldaps://") === 0) {                                                                         // 75
        client = ldapjs.createClient({                                                                                 // 76
          url: fullUrl,                                                                                                // 77
          tlsOptions: {                                                                                                // 78
            ca: [_this.options.ldapsCertificate]                                                                       // 79
          }                                                                                                            // 78
        }, errorFunc);                                                                                                 // 76
      } else {                                                                                                         // 82
        client = ldapjs.createClient({                                                                                 // 83
          url: fullUrl                                                                                                 // 84
        }, errorFunc);                                                                                                 // 83
      }                                                                                                                // 86
                                                                                                                       //
      client.on("error", errorFunc);                                                                                   // 88
                                                                                                                       //
      var username = options.username;                                                                                 // 90
      var domain = _this.options.defaultDomain;                                                                        // 91
                                                                                                                       //
      if (!options.hasOwnProperty("searchUsername")) {                                                                 // 93
        // Slide @xyz.whatever from username if it was passed in                                                       //
        // and replace it with the domain specified in defaults                                                        //
        var emailSliceIndex = options.username.indexOf("@");                                                           // 96
                                                                                                                       //
        // If user appended email domain, strip it out                                                                 //
        // And use the defaults.defaultDomain if set                                                                   //
        if (emailSliceIndex !== -1) {                                                                                  // 100
          username = options.username.substring(0, emailSliceIndex);                                                   // 101
          domain = domain || options.username.substring(emailSliceIndex + 1, options.username.length);                 // 102
        } else {                                                                                                       // 103
          username = options.username;                                                                                 // 104
        }                                                                                                              // 105
      }                                                                                                                // 106
                                                                                                                       //
      if (_this.options.searchBindDn) {                                                                                // 108
        var _ret2 = function () {                                                                                      // 108
          var ldapBindFut = new Future();                                                                              // 109
          client.bind(_this.options.searchBindDn, _this.options.searchBindPassword, function (err) {                   // 110
            if (err) {                                                                                                 // 112
              ldapBindFut["throw"](err);                                                                               // 113
            } else {                                                                                                   // 114
              ldapBindFut["return"]();                                                                                 // 115
            }                                                                                                          // 116
          });                                                                                                          // 117
                                                                                                                       //
          try {                                                                                                        // 120
            ldapBindFut.wait();                                                                                        // 121
          } catch (err) {                                                                                              // 122
            return {                                                                                                   // 123
              v: {                                                                                                     // 123
                v: { error: err }                                                                                      // 123
              }                                                                                                        // 123
            };                                                                                                         // 123
          }                                                                                                            // 124
        }();                                                                                                           // 108
                                                                                                                       //
        if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                // 108
      }                                                                                                                // 125
      // initialize result                                                                                             //
      var retObject = {                                                                                                // 127
        username: username,                                                                                            // 128
        email: domain ? username + "@" + domain : false,                                                               // 129
        emptySearch: true,                                                                                             // 130
        searchResults: {}                                                                                              // 131
      };                                                                                                               // 127
                                                                                                                       //
      var filter = _this.options.filter;                                                                               // 134
      Object.keys(_this.options.searchBeforeBind).forEach(function (searchKey) {                                       // 135
        filter = "&" + filter + "(" + searchKey + "=" + _this.options.searchBeforeBind[searchKey] + ")";               // 136
      });                                                                                                              // 137
                                                                                                                       //
      var searchOptions = {                                                                                            // 139
        scope: "sub",                                                                                                  // 140
        sizeLimit: 1,                                                                                                  // 141
        filter: filter                                                                                                 // 142
      };                                                                                                               // 139
                                                                                                                       //
      // perform LDAP search to determine DN                                                                           //
      client.search(_this.options.base, searchOptions, function (err, res) {                                           // 146
        if (err) {                                                                                                     // 147
          if (resolved) return;                                                                                        // 148
          resolved = true;                                                                                             // 149
          ldapAsyncFut["return"]({                                                                                     // 150
            error: err                                                                                                 // 151
          });                                                                                                          // 150
          return;                                                                                                      // 153
        }                                                                                                              // 154
                                                                                                                       //
        retObject.emptySearch = true;                                                                                  // 156
        res.on("searchEntry", function (entry) {                                                                       // 157
          retObject.dn = entry.objectName;                                                                             // 158
          retObject.username = retObject.dn;                                                                           // 159
          retObject.emptySearch = false;                                                                               // 160
                                                                                                                       //
          retObject.searchResults = _.omit(entry.object, "userPassword");                                              // 162
                                                                                                                       //
          if (options.hasOwnProperty("searchUsername")) {                                                              // 164
            // This was only a search, return immediately                                                              //
            resolved = true;                                                                                           // 166
            ldapAsyncFut["return"](retObject);                                                                         // 167
            return;                                                                                                    // 168
          }                                                                                                            // 169
                                                                                                                       //
          // use the determined DN to bind                                                                             //
          client.bind(entry.objectName, options.ldapPass, function (err) {                                             // 172
            try {                                                                                                      // 173
              if (err) {                                                                                               // 174
                throw new Meteor.Error(err.code, err.message);                                                         // 175
              } else {                                                                                                 // 176
                resolved = true;                                                                                       // 177
                ldapAsyncFut["return"](retObject);                                                                     // 178
              }                                                                                                        // 179
            } catch (e) {                                                                                              // 180
              if (resolved) return;                                                                                    // 182
              resolved = true;                                                                                         // 183
              ldapAsyncFut["return"]({                                                                                 // 184
                error: e                                                                                               // 185
              });                                                                                                      // 184
            }                                                                                                          // 187
          });                                                                                                          // 188
        });                                                                                                            // 189
                                                                                                                       //
        res.on("error", errorFunc);                                                                                    // 191
                                                                                                                       //
        // If no dn is found, return as is.                                                                            //
        res.on("end", function (result) {                                                                              // 194
          if (retObject.dn === undefined) {                                                                            // 195
            resolved = true;                                                                                           // 196
            ldapAsyncFut["return"](retObject);                                                                         // 197
          }                                                                                                            // 198
        });                                                                                                            // 199
      });                                                                                                              // 200
                                                                                                                       //
      return {                                                                                                         // 202
        v: ldapAsyncFut.wait()                                                                                         // 202
      };                                                                                                               // 202
    }();                                                                                                               // 48
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 48
  } else {                                                                                                             // 204
    throw new Meteor.Error(403, "Missing LDAP Auth Parameter");                                                        // 205
  }                                                                                                                    // 206
};                                                                                                                     // 208
                                                                                                                       //
LDAP.prototype.updateUserQuota = function (db, user) {                                                                 // 210
  var fallback = {                                                                                                     // 211
    storage: user.cachedStorageQuota || 0,                                                                             // 212
    grains: Infinity,                                                                                                  // 213
    compute: Infinity                                                                                                  // 214
  };                                                                                                                   // 211
                                                                                                                       //
  var setting = db.collections.settings.findOne({ _id: "quotaLdapAttribute" });                                        // 217
  if (!setting) return fallback;                                                                                       // 218
                                                                                                                       //
  // TODO(someday): don't just assume the first login identity is the primary identity?                                //
  var email = db.getPrimaryEmail(user._id, user.loginIdentities[0].id);                                                // 221
  if (!email) return fallback;                                                                                         // 222
                                                                                                                       //
  var ldapUser = void 0;                                                                                               // 224
  try {                                                                                                                // 225
    ldapUser = this.ldapCheck(db, { searchUsername: email });                                                          // 226
  } catch (err) {                                                                                                      // 227
    console.error("Error looking up quota from LDAP");                                                                 // 228
    return fallback;                                                                                                   // 229
  }                                                                                                                    // 230
                                                                                                                       //
  if (!ldapUser || !ldapUser.searchResults) return fallback;                                                           // 232
                                                                                                                       //
  var newStorageQuota = +ldapUser.searchResults[setting.value];                                                        // 234
  if (newStorageQuota !== user.cachedStorageQuota) {                                                                   // 235
    Meteor.users.update({ _id: user._id }, { $set: { cachedStorageQuota: newStorageQuota } });                         // 236
  }                                                                                                                    // 237
                                                                                                                       //
  // TODO(someday): cache timestamp as well and only check/update if greater than 60s ago                              //
  return {                                                                                                             // 240
    storage: newStorageQuota,                                                                                          // 241
    grains: Infinity,                                                                                                  // 242
    compute: Infinity                                                                                                  // 243
  };                                                                                                                   // 240
};                                                                                                                     // 245
                                                                                                                       //
                                                                                                                       // 247
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"picture.js":["meteor/http",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/picture.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({userPictureUrl:function(){return userPictureUrl},fetchPicture:function(){return fetchPicture}});var HTTP;module.import("meteor/http",{"HTTP":function(v){HTTP=v}});
                                                                                                                       //
var userPictureUrl = function userPictureUrl(user) {                                                                   // 3
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 4
    // Try to determine user's avatar URL from login service.                                                          //
                                                                                                                       //
    var google = user.services.google;                                                                                 // 7
    if (google && google.picture) {                                                                                    // 8
      return google.picture;                                                                                           // 9
    }                                                                                                                  // 10
                                                                                                                       //
    var github = user.services.github;                                                                                 // 12
    if (github && github.id) {                                                                                         // 13
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 14
    }                                                                                                                  // 15
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          //
    // Github are different because they are actually the identity providers, so they already know                     //
    // the user logged in.                                                                                             //
  }                                                                                                                    // 21
};                                                                                                                     // 22
                                                                                                                       //
var fetchPicture = function fetchPicture(db, url) {                                                                    // 24
  try {                                                                                                                // 25
    var result = HTTP.get(url, {                                                                                       // 26
      npmRequestOptions: { encoding: null },                                                                           // 27
      timeout: 5000                                                                                                    // 28
    });                                                                                                                // 26
                                                                                                                       //
    var metadata = {};                                                                                                 // 31
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 33
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 36
    }                                                                                                                  // 37
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 39
    if (enc && enc !== "identity") {                                                                                   // 40
      metadata.encoding = enc;                                                                                         // 41
    }                                                                                                                  // 42
                                                                                                                       //
    return db.addStaticAsset(metadata, result.content);                                                                // 44
  } catch (err) {                                                                                                      // 45
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 46
  }                                                                                                                    // 47
};                                                                                                                     // 48
                                                                                                                       //
                                                                                                                       // 50
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"saml-utils.js":["crypto","querystring","url","xml2js","xmlbuilder","xml-crypto","xmldom","zlib",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/saml-utils.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SAML:function(){return SAML}});var crypto;module.import("crypto",{"default":function(v){crypto=v}});var querystring;module.import("querystring",{"default":function(v){querystring=v}});var Url;module.import("url",{"default":function(v){Url=v}});var xml2js;module.import("xml2js",{"default":function(v){xml2js=v}});var xmlbuilder;module.import("xmlbuilder",{"default":function(v){xmlbuilder=v}});var xmlCrypto;module.import("xml-crypto",{"default":function(v){xmlCrypto=v}});var xmldom;module.import("xmldom",{"default":function(v){xmldom=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 10
                                                                                                                       //
var SAML = function SAML(options) {                                                                                    // 12
  this.options = this.initialize(options);                                                                             // 13
};                                                                                                                     // 14
                                                                                                                       //
SAML.prototype.initialize = function (options) {                                                                       // 16
  if (!options) {                                                                                                      // 17
    options = {};                                                                                                      // 18
  }                                                                                                                    // 19
                                                                                                                       //
  if (!options.protocol) {                                                                                             // 21
    options.protocol = "https://";                                                                                     // 22
  }                                                                                                                    // 23
                                                                                                                       //
  if (!options.path) {                                                                                                 // 25
    options.path = "/saml/consume";                                                                                    // 26
  }                                                                                                                    // 27
                                                                                                                       //
  if (!options.issuer) {                                                                                               // 29
    options.issuer = "onelogin_saml";                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (options.identifierFormat === undefined) {                                                                        // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return options;                                                                                                      // 37
};                                                                                                                     // 38
                                                                                                                       //
SAML.prototype.generateUniqueID = function () {                                                                        // 40
  var chars = "abcdef0123456789";                                                                                      // 41
  var uniqueID = "";                                                                                                   // 42
  for (var i = 0; i < 20; i++) {                                                                                       // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                       // 44
  }                                                                                                                    // 45
                                                                                                                       //
  return uniqueID;                                                                                                     // 47
};                                                                                                                     // 48
                                                                                                                       //
SAML.prototype.generateInstant = function () {                                                                         // 50
  var date = new Date();                                                                                               // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                     // 53
                                                                                                                       //
SAML.prototype.signRequest = function (xml) {                                                                          // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                          // 56
  signer.update(xml);                                                                                                  // 57
  return signer.sign(this.options.privateCert, "base64");                                                              // 58
};                                                                                                                     // 59
                                                                                                                       //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                             // 61
  var id = "_" + this.generateUniqueID();                                                                              // 62
  var instant = this.generateInstant();                                                                                // 63
                                                                                                                       //
  var callbackUrl = void 0;                                                                                            // 65
  // Post-auth destination                                                                                             //
  if (this.options.callbackUrl) {                                                                                      // 67
    callbackUrl = this.options.callbackUrl;                                                                            // 68
  } else {                                                                                                             // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                        // 70
  }                                                                                                                    // 71
                                                                                                                       //
  if (this.options.id) id = this.options.id;                                                                           // 73
                                                                                                                       //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                       //
  if (this.options.identifierFormat) {                                                                                 // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                    // 85
                                                                                                                       //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                       //
  return request;                                                                                                      // 95
};                                                                                                                     // 96
                                                                                                                       //
SAML.prototype.generateLogoutRequest = function (req) {                                                                // 98
  var id = "_" + this.generateUniqueID();                                                                              // 99
  var instant = this.generateInstant();                                                                                // 100
                                                                                                                       //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                   //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                        //
                                                                                                                       //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                      // 114
};                                                                                                                     // 115
                                                                                                                       //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                                // 117
  var _this = this;                                                                                                    // 118
  zlib.deflateRaw(request, function (err, buffer) {                                                                    // 119
    if (err) {                                                                                                         // 120
      return callback(err);                                                                                            // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var base64 = buffer.toString("base64");                                                                            // 124
    var target = _this.options.entryPoint;                                                                             // 125
                                                                                                                       //
    if (operation === "logout") {                                                                                      // 127
      if (_this.options.logoutUrl) {                                                                                   // 128
        target = _this.options.logoutUrl;                                                                              // 129
      }                                                                                                                // 130
    }                                                                                                                  // 131
                                                                                                                       //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                     // 133
                                                                                                                       //
    var samlRequest = {                                                                                                // 138
      SAMLRequest: base64                                                                                              // 139
    };                                                                                                                 // 138
                                                                                                                       //
    if (_this.options.privateCert) {                                                                                   // 142
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                               // 143
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                   // 144
    }                                                                                                                  // 145
                                                                                                                       //
    target += querystring.stringify(samlRequest);                                                                      // 147
                                                                                                                       //
    callback(null, target);                                                                                            // 149
  });                                                                                                                  // 150
};                                                                                                                     // 151
                                                                                                                       //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                            // 153
  var request = this.generateAuthorizeRequest(req);                                                                    // 154
                                                                                                                       //
  this.requestToUrl(request, "authorize", callback);                                                                   // 156
};                                                                                                                     // 157
                                                                                                                       //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                               // 159
  var request = this.generateLogoutRequest(req);                                                                       // 160
                                                                                                                       //
  this.requestToUrl(request, "logout", callback);                                                                      // 162
};                                                                                                                     // 163
                                                                                                                       //
SAML.prototype.certToPEM = function (cert) {                                                                           // 165
  cert = cert.match(/.{1,64}/g).join("\n");                                                                            // 166
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                       // 167
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                       // 168
  return cert;                                                                                                         // 169
};                                                                                                                     // 170
                                                                                                                       //
SAML.prototype.validateSignature = function (xml, cert) {                                                              // 172
  var _this = this;                                                                                                    // 173
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                               // 174
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                                 // 176
  sig.keyInfoProvider = {                                                                                              // 177
    getKeyInfo: function getKeyInfo(key) {                                                                             // 178
      return "<X509Data></X509Data>";                                                                                  // 179
    },                                                                                                                 // 180
                                                                                                                       //
    getKey: function getKey(keyInfo) {                                                                                 // 182
      return _this.certToPEM(cert);                                                                                    // 183
    }                                                                                                                  // 184
  };                                                                                                                   // 177
  sig.loadSignature(signature.toString());                                                                             // 186
  return sig.checkSignature(xml);                                                                                      // 187
};                                                                                                                     // 188
                                                                                                                       //
SAML.prototype.getElement = function (parentElement, elementName) {                                                    // 190
  if (parentElement["saml:" + elementName]) {                                                                          // 191
    return parentElement["saml:" + elementName];                                                                       // 192
  } else if (parentElement["samlp:" + elementName]) {                                                                  // 193
    return parentElement["samlp:" + elementName];                                                                      // 194
  } else if (parentElement["saml2p:" + elementName]) {                                                                 // 195
    return parentElement["saml2p:" + elementName];                                                                     // 196
  } else if (parentElement["saml2:" + elementName]) {                                                                  // 197
    return parentElement["saml2:" + elementName];                                                                      // 198
  }                                                                                                                    // 199
                                                                                                                       //
  return parentElement[elementName];                                                                                   // 201
};                                                                                                                     // 202
                                                                                                                       //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                                  // 204
  var _this = this;                                                                                                    // 205
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                       // 206
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 207
  parser.parseString(xml, function (err, doc) {                                                                        // 208
    // Verify signature                                                                                                //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                     // 210
      return callback(new Error("Invalid signature"), null, false);                                                    // 211
    }                                                                                                                  // 212
                                                                                                                       //
    var response = _this.getElement(doc, "Response");                                                                  // 214
    if (response) {                                                                                                    // 215
      var assertion = _this.getElement(response, "Assertion");                                                         // 216
      if (!assertion) {                                                                                                // 217
        return callback(new Error("Missing SAML assertion"), null, false);                                             // 218
      }                                                                                                                // 219
                                                                                                                       //
      profile = {};                                                                                                    // 221
                                                                                                                       //
      if (response.$ && response.$.InResponseTo) {                                                                     // 223
        profile.inResponseToId = response.$.InResponseTo;                                                              // 224
      }                                                                                                                // 225
                                                                                                                       //
      if (response.$ && response.$.Destination) {                                                                      // 227
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                                // 228
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination));    // 229
        }                                                                                                              // 231
      }                                                                                                                // 232
                                                                                                                       //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                           // 234
      if (issuer) {                                                                                                    // 235
        profile.issuer = issuer[0];                                                                                    // 236
      }                                                                                                                // 237
                                                                                                                       //
      var subject = _this.getElement(assertion[0], "Subject");                                                         // 239
      if (subject) {                                                                                                   // 240
        var nameID = _this.getElement(subject[0], "NameID");                                                           // 241
        if (nameID) {                                                                                                  // 242
          profile.nameID = nameID[0]._;                                                                                // 243
                                                                                                                       //
          if (nameID[0].$.Format) {                                                                                    // 245
            profile.nameIDFormat = nameID[0].$.Format;                                                                 // 246
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                      // 247
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."));
            }                                                                                                          // 251
          }                                                                                                            // 252
        }                                                                                                              // 253
                                                                                                                       //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                                 // 255
        if (subjectConfirmation) {                                                                                     // 256
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];        // 257
          if (subjectConfirmationData) {                                                                               // 259
            var recipient = subjectConfirmationData.$.Recipient;                                                       // 260
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                            // 261
              return callback(new Error("SAML sent to wrong recipient"));                                              // 262
            }                                                                                                          // 263
                                                                                                                       //
            var nowMs = Date.now();                                                                                    // 265
            var notBefore = subjectConfirmationData.$.NotBefore;                                                       // 266
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                          // 267
              return callback(new Error("SAML assertion was signed for the future."));                                 // 268
            }                                                                                                          // 269
                                                                                                                       //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                                 // 271
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                   // 272
              return callback(new Error("SAML assertion was signed for the past."));                                   // 273
            }                                                                                                          // 274
          }                                                                                                            // 275
        }                                                                                                              // 276
      }                                                                                                                // 277
                                                                                                                       //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                                // 279
      if (conditions) {                                                                                                // 280
        for (var key in conditions) {                                                                                  // 281
          if (conditions.hasOwnProperty(key)) {                                                                        // 282
            var value = conditions[key];                                                                               // 283
            if (key === "$") {                                                                                         // 284
              var _nowMs = Date.now();                                                                                 // 285
              var _notBefore = value.NotBefore;                                                                        // 286
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                     // 287
                return callback(new Error("SAML condition NotBefore is in the future."));                              // 288
              }                                                                                                        // 289
                                                                                                                       //
              var _notOnOrAfter = value.NotOnOrAfter;                                                                  // 291
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                              // 292
                return callback(new Error("SAML condition notOnOrAfter is in the past."));                             // 293
              }                                                                                                        // 294
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                                // 298
              // Do nothing.                                                                                           //
              // We already check both Destination and SubjectConfirmation.Recipient, so                               //
              // the Audience constraint isn't as important, and is tricky to handle                                   //
              // correctly.                                                                                            //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                              //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                           //
              // we would probably need to stuff it in Mongo to make it robust across multiple                         //
              // front-ends. It is a very rarely used constraint anyways.                                              //
              // ProxyRestriction constraints only govern the future use of the assertion by the                       //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                         //
              // spec, it is always considered valid.                                                                  //
            } else {                                                                                                   // 310
                return callback(new Error("Unrecognized SAML constraint: " + key));                                    // 311
              }                                                                                                        // 312
          }                                                                                                            // 313
        }                                                                                                              // 314
      }                                                                                                                // 315
                                                                                                                       //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                   // 317
      if (attributeStatement) {                                                                                        // 318
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                         // 319
                                                                                                                       //
        if (attributes) {                                                                                              // 321
          attributes.forEach(function (attribute) {                                                                    // 322
            var value = _this.getElement(attribute, "AttributeValue");                                                 // 323
            if (typeof value[0] === "string") {                                                                        // 324
              profile[attribute.$.Name] = value[0];                                                                    // 325
            } else {                                                                                                   // 326
              profile[attribute.$.Name] = value[0]._;                                                                  // 327
            }                                                                                                          // 328
          });                                                                                                          // 329
        }                                                                                                              // 330
                                                                                                                       //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                           // 332
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs              //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                                 // 334
        }                                                                                                              // 335
                                                                                                                       //
        if (!profile.email && profile.mail) {                                                                          // 337
          profile.email = profile.mail;                                                                                // 338
        }                                                                                                              // 339
                                                                                                                       //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];            // 341
        if (!profile.email && microsoftEmail) {                                                                        // 342
          profile.email = microsoftEmail;                                                                              // 343
        }                                                                                                              // 344
                                                                                                                       //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];                // 346
        if (!profile.displayName && microsoftDisplayName) {                                                            // 347
          profile.displayName = microsoftDisplayName;                                                                  // 348
        }                                                                                                              // 349
      }                                                                                                                // 350
                                                                                                                       //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                                // 353
      }                                                                                                                // 354
                                                                                                                       //
      callback(null, profile, false);                                                                                  // 356
    } else {                                                                                                           // 357
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                    // 358
                                                                                                                       //
      if (logoutResponse) {                                                                                            // 360
        callback(null, null, true);                                                                                    // 361
      } else {                                                                                                         // 362
        return callback(new Error("Unknown SAML response message"), null, false);                                      // 363
      }                                                                                                                // 364
    }                                                                                                                  // 366
  });                                                                                                                  // 368
};                                                                                                                     // 369
                                                                                                                       //
SAML.prototype.generateServiceProviderMetadata = function () {                                                         // 371
  var entityId = this.options.issuer;                                                                                  // 372
  var metadata = {                                                                                                     // 373
    "EntityDescriptor": {                                                                                              // 374
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                                // 375
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                               // 376
      "@entityID": entityId,                                                                                           // 377
      "@ID": entityId.replace(/\W/g, "_"),                                                                             // 378
      "SPSSODescriptor": {                                                                                             // 379
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                          // 380
      }                                                                                                                // 379
    }                                                                                                                  // 374
  };                                                                                                                   // 373
                                                                                                                       //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                             // 385
  if (decryptionCert) {                                                                                                // 386
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                        // 387
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                          // 388
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                            // 389
                                                                                                                       //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                        // 391
      "ds:KeyInfo": {                                                                                                  // 392
        "ds:X509Data": {                                                                                               // 393
          "ds:X509Certificate": {                                                                                      // 394
            "#text": decryptionCert                                                                                    // 395
          }                                                                                                            // 394
        }                                                                                                              // 393
      },                                                                                                               // 392
      "EncryptionMethod": [                                                                                            // 399
      // this should be the set that the xmlenc library supports                                                       //
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                                 // 391
  }                                                                                                                    // 406
                                                                                                                       //
  if (this.options.logoutCallbackUrl) {                                                                                // 408
    metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                                  // 409
      "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                    // 410
      "@Location": this.options.logoutCallbackUrl                                                                      // 411
    };                                                                                                                 // 409
  }                                                                                                                    // 413
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                              // 415
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                               // 416
    "@index": "1",                                                                                                     // 417
    "@isDefault": "true",                                                                                              // 418
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                      // 419
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                          // 420
  };                                                                                                                   // 416
                                                                                                                       //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                               // 423
};                                                                                                                     // 424
                                                                                                                       //
                                                                                                                       // 426
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"auth.js":["meteor/meteor","meteor/check","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_VARDIR;module.import("/imports/server/constants.js",{"SANDSTORM_VARDIR":function(v){SANDSTORM_VARDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 8
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 9
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 11
  if (tokenIsSetupSession(token)) {                                                                                    // 12
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 13
    globalDb.collections.setupSession.remove({                                                                         // 14
      _id: "current-session",                                                                                          // 15
      hashedSessionId: hash                                                                                            // 16
    });                                                                                                                // 14
  }                                                                                                                    // 18
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 20
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 21
    console.log("Admin token deleted.");                                                                               // 22
  }                                                                                                                    // 23
}                                                                                                                      // 24
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 26
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 27
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 28
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 29
    if (stats.mtime < expireTime) {                                                                                    // 30
      return false;                                                                                                    // 31
    } else {                                                                                                           // 32
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 33
    }                                                                                                                  // 34
  } else {                                                                                                             // 35
    return false;                                                                                                      // 36
  }                                                                                                                    // 37
}                                                                                                                      // 38
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 40
  if (token) {                                                                                                         // 41
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 42
    if (setupSession) {                                                                                                // 43
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 44
      var now = new Date();                                                                                            // 45
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 46
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 47
        return true;                                                                                                   // 48
      }                                                                                                                // 49
    }                                                                                                                  // 50
  }                                                                                                                    // 51
                                                                                                                       //
  return false;                                                                                                        // 53
}                                                                                                                      // 54
                                                                                                                       //
function checkAuth(token) {                                                                                            // 56
  check(token, Match.OneOf(undefined, null, String));                                                                  // 57
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 58
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 59
  }                                                                                                                    // 60
}                                                                                                                      // 61
                                                                                                                       //
                                                                                                                       // 63
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"constants.js":["meteor/meteor","url",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/constants.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SANDSTORM_ALTHOME:function(){return SANDSTORM_ALTHOME},SANDSTORM_LOGDIR:function(){return SANDSTORM_LOGDIR},SANDSTORM_VARDIR:function(){return SANDSTORM_VARDIR},staticAssetHost:function(){return staticAssetHost}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Url;module.import("url",{"default":function(v){Url=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
                                                                                                                       //
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
var SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                       // 22
var SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                         // 23
var SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                   // 24
                                                                                                                       //
// TODO: dedupe this and the equivalent copy in sandstorm-db                                                           //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 27
                                                                                                                       //
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + wildcardHost[0] + "static" + wildcardHost[1];  // 29
                                                                                                                       //
                                                                                                                       // 31
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications.js":["meteor/check",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/desktop-notifications.js                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({createAppActivityDesktopNotification:function(){return createAppActivityDesktopNotification}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var createAppActivityDesktopNotification = function createAppActivityDesktopNotification(options) {                    // 19
  check(options, {                                                                                                     // 20
    userId: String,                                                                                                    // 21
    notificationId: String,                                                                                            // 22
    appActivity: {                                                                                                     // 23
      user: {                                                                                                          // 24
        identityId: String,                                                                                            // 25
        name: String,                                                                                                  // 26
        avatarUrl: String                                                                                              // 27
      },                                                                                                               // 24
      grainId: String,                                                                                                 // 29
      path: String,                                                                                                    // 30
      body: Match.ObjectIncluding({                                                                                    // 31
        defaultText: String                                                                                            // 32
      }),                                                                                                              // 31
      actionText: Match.ObjectIncluding({                                                                              // 34
        defaultText: String                                                                                            // 35
      })                                                                                                               // 34
    }                                                                                                                  // 23
  });                                                                                                                  // 20
                                                                                                                       //
  globalDb.collections.desktopNotifications.insert({                                                                   // 40
    userId: options.userId,                                                                                            // 41
    notificationId: options.notificationId,                                                                            // 42
    creationDate: new Date(),                                                                                          // 43
    appActivity: options.appActivity                                                                                   // 44
  });                                                                                                                  // 40
};                                                                                                                     // 46
                                                                                                                       //
                                                                                                                       // 48
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"email.js":["meteor/meteor","nodemailer","nodemailer-smtp-pool",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/email.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({send:function(){return send},rawSend:function(){return rawSend}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var nodemailer;module.import("nodemailer",{"default":function(v){nodemailer=v}});var smtpPool;module.import("nodemailer-smtp-pool",{"default":function(v){smtpPool=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 5
                                                                                                                       //
var getSmtpConfig = function getSmtpConfig() {                                                                         // 7
  var config = Settings.findOne({ _id: "smtpConfig" });                                                                // 8
  return config && config.value;                                                                                       // 9
};                                                                                                                     // 10
                                                                                                                       //
var makePool = function makePool(mailConfig) {                                                                         // 12
  var auth = false;                                                                                                    // 13
  if (mailConfig.auth && (mailConfig.auth.user || mailConfig.auth.pass)) {                                             // 14
    auth = mailConfig.auth;                                                                                            // 15
  }                                                                                                                    // 16
                                                                                                                       //
  var secure = mailConfig.port === 465;                                                                                // 18
  var tlsOptions = {                                                                                                   // 19
    // Previously, node 0.10 did not attempt to validate certificates received when connecting                         //
    // with STARTTLS, so to avoid regressing we need to preserve that behavior here for now.                           //
    rejectUnauthorized: false                                                                                          // 22
  };                                                                                                                   // 19
                                                                                                                       //
  var pool = nodemailer.createTransport(smtpPool({                                                                     // 25
    host: mailConfig.hostname,                                                                                         // 26
    port: mailConfig.port,                                                                                             // 27
    secure: secure,                                                                                                    // 28
    tls: tlsOptions,                                                                                                   // 29
    auth: auth                                                                                                         // 30
  }));                                                                                                                 // 25
                                                                                                                       //
  // TODO(someday): allow maxConnections to be configured?                                                             //
  pool._futureWrappedSendMail = _.bind(Future.wrap(pool.sendMail), pool);                                              // 34
  return pool;                                                                                                         // 35
};                                                                                                                     // 36
                                                                                                                       //
// We construct the SMTP pool at the first call to Email.send, so that                                                 //
// other code like migrations can modify the SMTP configuration.                                                       //
var pool = void 0;                                                                                                     // 40
var configured = false;                                                                                                // 41
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 43
  Settings.find({ _id: "smtpConfig" }).observeChanges({                                                                // 44
    removed: function removed() {                                                                                      // 45
      configured = false;                                                                                              // 46
    },                                                                                                                 // 47
                                                                                                                       //
    changed: function changed() {                                                                                      // 49
      configured = false;                                                                                              // 50
    },                                                                                                                 // 51
                                                                                                                       //
    added: function added() {                                                                                          // 53
      configured = false;                                                                                              // 54
    }                                                                                                                  // 55
  });                                                                                                                  // 44
});                                                                                                                    // 57
                                                                                                                       //
var getPool = function getPool(smtpConfig) {                                                                           // 59
  if (smtpConfig) {                                                                                                    // 60
    return makePool(smtpConfig);                                                                                       // 61
  } else if (!configured) {                                                                                            // 62
    configured = true;                                                                                                 // 63
    var config = getSmtpConfig();                                                                                      // 64
    if (config) {                                                                                                      // 65
      pool = makePool(config);                                                                                         // 66
    }                                                                                                                  // 67
  }                                                                                                                    // 68
                                                                                                                       //
  return pool;                                                                                                         // 70
};                                                                                                                     // 71
                                                                                                                       //
var smtpSend = function smtpSend(pool, mailOptions) {                                                                  // 73
  pool._futureWrappedSendMail(mailOptions).wait();                                                                     // 74
};                                                                                                                     // 75
                                                                                                                       //
var rawSend = function rawSend(mailOptions, smtpConfig) {                                                              // 77
  // Sends an email mailOptions object structured as described in                                                      //
  // https://github.com/nodemailer/mailcomposer#e-mail-message-fields                                                  //
  // across the transport described by smtpConfig.                                                                     //
  var pool = getPool(smtpConfig);                                                                                      // 81
  if (pool) {                                                                                                          // 82
    smtpSend(pool, mailOptions);                                                                                       // 83
  } else {                                                                                                             // 84
    throw new Error("SMTP pool is misconfigured.");                                                                    // 85
  }                                                                                                                    // 86
};                                                                                                                     // 87
                                                                                                                       //
// Old comment below                                                                                                   //
/**                                                                                                                    //
 * Send an email.                                                                                                      //
 *                                                                                                                     //
 * Connects to the mail server configured via the MAIL_URL environment                                                 //
 * variable. If unset, prints formatted message to stdout. The "from" option                                           //
 * is required, and at least one of "to", "cc", and "bcc" must be provided;                                            //
 * all other options are optional.                                                                                     //
 *                                                                                                                     //
 * @param options                                                                                                      //
 * @param options.from {String} RFC5322 "From:" address                                                                //
 * @param options.to {String|String[]} RFC5322 "To:" address[es]                                                       //
 * @param options.cc {String|String[]} RFC5322 "Cc:" address[es]                                                       //
 * @param options.bcc {String|String[]} RFC5322 "Bcc:" address[es]                                                     //
 * @param options.replyTo {String|String[]} RFC5322 "Reply-To:" address[es]                                            //
 * @param options.subject {String} RFC5322 "Subject:" line                                                             //
 * @param options.text {String} RFC5322 mail body (plain text)                                                         //
 * @param options.html {String} RFC5322 mail body (HTML)                                                               //
 * @param options.headers {Object} custom RFC5322 headers (dictionary)                                                 //
 */                                                                                                                    //
                                                                                                                       //
// New API doc comment below                                                                                           //
/**                                                                                                                    //
 * @summary Send an email. Throws an `Error` on failure to contact mail server                                         //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} options                                                                                             //
 * @param {String} options.from "From:" address (required)                                                             //
 * @param {String|String[]} options.to,cc,bcc,replyTo                                                                  //
 *   "To:", "Cc:", "Bcc:", and "Reply-To:" addresses                                                                   //
 * @param {String} [options.subject]  "Subject:" line                                                                  //
 * @param {String} [options.text|html] Mail body (in plain text or HTML)                                               //
 * @param {Object} [options.headers] Dictionary of custom headers                                                      //
 * @param {Object} [options.smtpConfig] SMTP server to use. Otherwise defaults to configured one.                      //
 * @param {String} [options.smtpConfig.hostname] SMTP server hostname.                                                 //
 * @param {Number} [options.smtpConfig.port] SMTP server port.                                                         //
 * @param {Object} [options.smtpConfig.auth] SMTP server authentication tokens.  Optional.                             //
 * @param {String} [options.smtpConfig.auth.user] Username of user to log in to SMTP server as.  Optional.             //
 * @param {String} [options.smtpConfig.auth.pass] Password of user to log in to SMTP server as.  Optional.             //
 * @param {Object} [options.attachments] Attachments. See:                                                             //
 *   https://github.com/nodemailer/mailcomposer/tree/v0.1.15#add-attachments                                           //
 * @param {String} [options.envelopeFrom] Envelope sender.                                                             //
 */                                                                                                                    //
var send = function send(options) {                                                                                    // 133
  // Unpack options                                                                                                    //
  var from = options.from;                                                                                             // 133
  var to = options.to;                                                                                                 // 133
  var cc = options.cc;                                                                                                 // 133
  var bcc = options.bcc;                                                                                               // 133
  var replyTo = options.replyTo;                                                                                       // 133
  var subject = options.subject;                                                                                       // 133
  var text = options.text;                                                                                             // 133
  var html = options.html;                                                                                             // 133
  var envelopeFrom = options.envelopeFrom;                                                                             // 133
  var headers = options.headers;                                                                                       // 133
  var attachments = options.attachments;                                                                               // 133
  var smtpConfig = options.smtpConfig;                                                                                 // 133
                                                                                                                       //
                                                                                                                       //
  var opts = {                                                                                                         // 150
    from: from,                                                                                                        // 151
    to: to,                                                                                                            // 152
    cc: cc,                                                                                                            // 153
    bcc: bcc,                                                                                                          // 154
    replyTo: replyTo,                                                                                                  // 155
    subject: subject,                                                                                                  // 156
    text: text,                                                                                                        // 157
    html: html,                                                                                                        // 158
    headers: headers,                                                                                                  // 159
    attachments: attachments                                                                                           // 160
  };                                                                                                                   // 150
                                                                                                                       //
  if (envelopeFrom) {                                                                                                  // 163
    opts.envelope = {                                                                                                  // 164
      from: envelopeFrom,                                                                                              // 165
      to: to,                                                                                                          // 166
      cc: cc,                                                                                                          // 167
      bcc: bcc                                                                                                         // 168
    };                                                                                                                 // 164
  }                                                                                                                    // 170
                                                                                                                       //
  rawSend(opts, smtpConfig);                                                                                           // 172
};                                                                                                                     // 173
                                                                                                                       //
                                                                                                                       // 175
                                                                                                                       //
// TODO(cleanup): Remove this once BlackrockPayments code finds a better way to import it.                             //
global.SandstormEmail = { send: send };                                                                                // 178
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function create(db, frontendRef, requirements) {                              //
    // Construct a fresh capability based on a `frontendRef` value.                                                    //
                                                                                                                       //
    checkRequirements(requirements);                                                                                   // 28
                                                                                                                       //
    var saveTemplate = { frontendRef: frontendRef };                                                                   // 30
    if (requirements) {                                                                                                // 31
      saveTemplate.requirements = requirements;                                                                        // 32
    }                                                                                                                  // 33
                                                                                                                       //
    return this.restore(db, saveTemplate, frontendRef);                                                                // 35
  };                                                                                                                   // 36
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function restore(db, saveTemplate, frontendRef) {                            //
    // Restores a frontendRef capability using the appropriate registered handler.                                     //
                                                                                                                       //
    var keys = Object.keys(frontendRef);                                                                               // 41
    if (keys.length != 1) {                                                                                            // 42
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var key = keys[0];                                                                                                 // 46
    var handler = this._frontendRefHandlers[key];                                                                      // 47
    if (!handler) {                                                                                                    // 48
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return handler.restore(db, saveTemplate, frontendRef[key]);                                                        // 52
  };                                                                                                                   // 53
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function query(db, userAccountId, tag) {                                       //
    // Performs a powerbox query using the appropriate registered handler.                                             //
                                                                                                                       //
    var handler = this._typeIdHandlers[tag.id];                                                                        // 58
    if (handler) {                                                                                                     // 59
      return handler.query(db, userAccountId, tag.value);                                                              // 60
    } else {                                                                                                           // 61
      return []; // no matches                                                                                         // 62
    }                                                                                                                  // 63
  };                                                                                                                   // 64
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function validate(db, session, mutableFrontendRef) {                        //
    // Validates a powerbox request on the given `session` (a record from the Sessions table)                          //
    // requesting the creation of the given frontendRef type. `mutableFrontendRef` is expected to                      //
    // come directly from the client; calling validate() verifies that it has a valid type, and                        //
    // may modify the value to add bits that need to be generated server-side. `validate()` also                       //
    // returns an array of MembraneRequirements that shall apply to the capability. These                              //
    // requirements will not yet have been checked, so the caller should check them before                             //
    // proceeding.                                                                                                     //
                                                                                                                       //
    var keys = Object.keys(mutableFrontendRef);                                                                        // 75
    if (keys.length != 1) {                                                                                            // 76
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 77
    }                                                                                                                  // 78
                                                                                                                       //
    var key = keys[0];                                                                                                 // 80
    var handler = this._frontendRefHandlers[key];                                                                      // 81
    if (!handler) {                                                                                                    // 82
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 83
    }                                                                                                                  // 84
                                                                                                                       //
    if (!handler.validate) {                                                                                           // 86
      throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(mutableFrontendRef));       // 87
    }                                                                                                                  // 89
                                                                                                                       //
    return handler.validate(db, session, mutableFrontendRef[key]);                                                     // 91
  };                                                                                                                   // 92
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function register(object) {                                                 //
    // Register callbacks related to a particular frontendRef type. The object has the fields:                         //
    //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                        //
    //       this type. Only needed if `create` and/or `validate` handlers are defined.                                //
    //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                       //
    //       64-bit integer. Only needed if `query` is defined.                                                        //
    //   `restore`: Callback to construct a capability of this type when restoring a saved                             //
    //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                               //
    //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                      //
    //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                               //
    //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                       //
    //         with whatever other interfaces are appropriate for the ref type.                                        //
    //   `validate`: Callback to validate a powerbox request for a new capability of this type.                        //
    //       Has signature `(db, session, mutableValue) -> {descriptor, requirements}`, where:                         //
    //     `mutableValue` is the value of the single field of `frontendRef` for this capability.                       //
    //         If this is an object value, the callback may optionally modify it, e.g. adding                          //
    //         additional fields that need to be generated server-side. The callback *must*, at                        //
    //         the very least, type-check this value. It should throw an exception if the vaule is                     //
    //         not valid.                                                                                              //
    //     `session` is the record from the Sessions table of the UI session where the powerbox                        //
    //         request occurred.                                                                                       //
    //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                     //
    //         that if the descriptor contains any `tag.value`s, they of course need to be                             //
    //         presented as capnp-encoded Buffers.                                                                     //
    //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                     //
    //         new capability. Note that these requirements will be checked immediately and the                        //
    //         powerbox request will fail if they aren't met.                                                          //
    //    `query`: Callback to populate options for a powerbox request for this type ID. Has                           //
    //        signature `(db, userAccountId, tagValue) -> options`, where:                                             //
    //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                            //
    //      `options` (returned): An array of objects representing the options that should be                          //
    //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                        //
    //          powerbox-server.js for a full description of the fields of each option.                                //
                                                                                                                       //
    if (object.frontendRefField) {                                                                                     // 128
      if (object.frontendRefField in this._frontendRefHandlers) {                                                      // 129
        throw new Error("frontendRef handler already registered: " + object.frontendRefField);                         // 130
      }                                                                                                                // 131
                                                                                                                       //
      this._frontendRefHandlers[object.frontendRefField] = object;                                                     // 133
    }                                                                                                                  // 134
                                                                                                                       //
    if (object.typeId) {                                                                                               // 136
      if (object.typeId in this._typeIdHandlers) {                                                                     // 137
        throw new Error("typeId handler already registered: " + object.typeId);                                        // 138
      }                                                                                                                // 139
                                                                                                                       //
      this._typeIdHandlers[object.typeId] = object;                                                                    // 141
    }                                                                                                                  // 142
  };                                                                                                                   // 143
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 146
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"migrations.js":["meteor/meteor","meteor/underscore","meteor/check","/imports/server/accounts/picture.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/migrations.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({migrateToLatest:function(){return migrateToLatest}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var _;module.import("meteor/underscore",{"_":function(v){_=v}});var Match;module.import("meteor/check",{"Match":function(v){Match=v}});var userPictureUrl,fetchPicture;module.import("/imports/server/accounts/picture.js",{"userPictureUrl":function(v){userPictureUrl=v},"fetchPicture":function(v){fetchPicture=v}});// Minimal tooling for doing run-at-least-once, ordered migrations.
//                                                                                                                     //
// Because migrations can experience partial failure and likely have                                                   //
// side-effects, we should be careful to make sure all migrations are                                                  //
// idempotent and safe to accidentally run multiple times.                                                             //
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       // 9
                                                                                                                       // 10
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 12
var Url = Npm.require("url");                                                                                          // 13
var Crypto = Npm.require("crypto");                                                                                    // 14
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect(db, backend) {                                    // 16
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 17
  ["google", "github"].forEach(function (serviceName) {                                                                // 18
    var config = configurations.findOne({ service: serviceName });                                                     // 19
    if (config && config.loginStyle !== "redirect") {                                                                  // 20
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 21
    }                                                                                                                  // 22
  });                                                                                                                  // 23
};                                                                                                                     // 24
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings(db, backend) {      // 26
  // In the before time, Google and Github login were enabled by default.                                              //
  //                                                                                                                   //
  // This actually didn't make much sense, required the first user to configure                                        //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          //
  // secure.                                                                                                           //
  //                                                                                                                   //
  // Now, we have admin-token, so we wish to disable all logins by default                                             //
  // (since they need to be configured anyway) but since users may have never                                          //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          //
  // we can't just use the value in the Settings collection, since it might                                            //
  // never have been set.                                                                                              //
  //                                                                                                                   //
  // Thus, if the service is configured but absent from Settings, we should                                            //
  // explicitly enable it in Settings, and then the rest of the logic can just                                         //
  // depend on what value is in Settings and default to false without breaking                                         //
  // user installations.                                                                                               //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 43
  ["google", "github"].forEach(function (serviceName) {                                                                // 44
    var config = configurations.findOne({ service: serviceName });                                                     // 45
    var serviceConfig = db.collections.settings.findOne({ _id: serviceName });                                         // 46
    if (config && !serviceConfig) {                                                                                    // 47
      // Only explicitly enable the login service if:                                                                  //
      // 1) the service is already configured                                                                          //
      // 2) there is no sandstorm configuration already present (the user was                                          //
      //    using the previous default behavior).                                                                      //
      db.collections.settings.insert({ _id: serviceName, value: true });                                               // 52
    }                                                                                                                  // 53
  });                                                                                                                  // 54
};                                                                                                                     // 55
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo(db, backend) {                                              // 57
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    //
  // which has more information about the key, namely a freeform note entered by the admin when                        //
  // they created the key. In the case that the email invite form was used, the note has the form                      //
  // "E-mail invite to <address>".                                                                                     //
  //                                                                                                                   //
  // Later, we decided it was useful to indicate in the users table visible to the admin                               //
  // information about the invite terms. Namely, for email invites we want to show the address                         //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        //
  // from the SignupKeys table.                                                                                        //
                                                                                                                       //
  db.collections.users.find().forEach(function (user) {                                                                // 70
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 71
      var signupInfo = db.collections.signupKeys.findOne(user.signupKey);                                              // 72
      if (signupInfo && signupInfo.note) {                                                                             // 73
        var newFields = { signupNote: signupInfo.note };                                                               // 74
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 76
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 77
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 78
        }                                                                                                              // 79
                                                                                                                       //
        db.collections.users.update(user._id, { $set: newFields });                                                    // 81
      }                                                                                                                // 82
    }                                                                                                                  // 83
  });                                                                                                                  // 84
};                                                                                                                     // 85
                                                                                                                       //
var mergeRoleAssignmentsIntoApiTokens = function mergeRoleAssignmentsIntoApiTokens(db, backend) {                      // 87
  db.collections.roleAssignments.find().forEach(function (roleAssignment) {                                            // 88
    db.collections.apiTokens.insert({                                                                                  // 89
      grainId: roleAssignment.grainId,                                                                                 // 90
      userId: roleAssignment.sharer,                                                                                   // 91
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 92
      petname: roleAssignment.petname,                                                                                 // 93
      created: roleAssignment.created,                                                                                 // 94
      owner: {                                                                                                         // 95
        user: {                                                                                                        // 96
          userId: roleAssignment.recipient,                                                                            // 97
          title: roleAssignment.title                                                                                  // 98
        }                                                                                                              // 96
      }                                                                                                                // 95
    });                                                                                                                // 89
  });                                                                                                                  // 102
};                                                                                                                     // 103
                                                                                                                       //
var fixOasisStorageUsageStats = function fixOasisStorageUsageStats(db, backend) {};                                    // 105
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      //
// with a no-op.                                                                                                       //
                                                                                                                       //
var fetchProfilePictures = function fetchProfilePictures(db, backend) {                                                // 110
  db.collections.users.find({}).forEach(function (user) {                                                              // 111
    var url = userPictureUrl(user);                                                                                    // 112
    if (url) {                                                                                                         // 113
      console.log("Fetching user picture:", url);                                                                      // 114
      var assetId = fetchPicture(db, url);                                                                             // 115
      if (assetId) {                                                                                                   // 116
        db.collections.users.update(user._id, { $set: { "profile.picture": assetId } });                               // 117
      }                                                                                                                // 118
    }                                                                                                                  // 119
  });                                                                                                                  // 120
};                                                                                                                     // 121
                                                                                                                       //
var assignPlans = function assignPlans(db, backend) {                                                                  // 123
  if (db.isReferralEnabled() && SandstormDb.paymentsMigrationHook) {                                                   // 124
    SandstormDb.paymentsMigrationHook(db.collections.signupKeys, db.collections.plans.find().fetch());                 // 125
  }                                                                                                                    // 126
};                                                                                                                     // 127
                                                                                                                       //
var removeKeyrings = function removeKeyrings(db, backend) {                                                            // 129
  // These blobs full of public keys were not intended to find their way into mongo and while                          //
  // harmless they slow things down because they're huge. Remove them.                                                 //
  db.collections.packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
};                                                                                                                     // 135
                                                                                                                       //
var useLocalizedTextInUserActions = function useLocalizedTextInUserActions(db, backend) {                              // 137
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 138
    if (field in oldObj) {                                                                                             // 139
      if (typeof oldObj[field] === "string") {                                                                         // 140
        newObj[field] = { defaultText: oldObj[field] };                                                                // 141
      } else {                                                                                                         // 142
        newObj[field] = oldObj[field];                                                                                 // 143
      }                                                                                                                // 144
    }                                                                                                                  // 145
  }                                                                                                                    // 146
                                                                                                                       //
  db.collections.userActions.find({}).forEach(function (userAction) {                                                  // 148
    var fields = {};                                                                                                   // 149
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 150
    toLocalizedText(fields, userAction, "title");                                                                      // 151
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 152
    db.collections.userActions.update(userAction._id, { $set: fields });                                               // 153
  });                                                                                                                  // 154
};                                                                                                                     // 155
                                                                                                                       //
var verifyAllPgpSignatures = function verifyAllPgpSignatures(db, backend) {                                            // 157
  db.collections.packages.find({}).forEach(function (pkg) {                                                            // 158
    try {                                                                                                              // 159
      console.log("checking PGP signature for package:", pkg._id);                                                     // 160
      var info = waitPromise(backend.cap().tryGetPackage(pkg._id));                                                    // 161
      if (info.authorPgpKeyFingerprint) {                                                                              // 162
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 163
        db.collections.packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });  // 164
      } else {                                                                                                         // 166
        console.log("  no signature");                                                                                 // 167
      }                                                                                                                // 168
    } catch (err) {                                                                                                    // 169
      console.error(err.stack);                                                                                        // 170
    }                                                                                                                  // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
var splitUserIdsIntoAccountIdsAndIdentityIds = function splitUserIdsIntoAccountIdsAndIdentityIds(db, backend) {        // 175
  db.collections.users.find().forEach(function (user) {                                                                // 176
    var identity = {};                                                                                                 // 177
    var serviceUserId = void 0;                                                                                        // 178
    if ("devName" in user) {                                                                                           // 179
      identity.service = "dev";                                                                                        // 180
      serviceUserId = user.devName;                                                                                    // 181
    } else if ("expires" in user) {                                                                                    // 182
      identity.service = "demo";                                                                                       // 183
      serviceUserId = user._id;                                                                                        // 184
    } else if (user.services && "google" in user.services) {                                                           // 185
      identity.service = "google";                                                                                     // 186
      if (user.services.google.email && user.services.google.verified_email) {                                         // 187
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          //
        identity.verifiedEmail = user.services.google.email;                                                           // 188
      }                                                                                                                // 189
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 191
    } else if (user.services && "github" in user.services) {                                                           // 192
      identity.service = "github";                                                                                     // 193
      identity.unverifiedEmail = user.services.github.email;                                                           // 194
      serviceUserId = user.services.github.id;                                                                         // 195
    } else if (user.services && "emailToken" in user.services) {                                                       // 196
      identity.service = "emailToken";                                                                                 // 197
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 198
      serviceUserId = user.services.emailToken.email;                                                                  // 199
    }                                                                                                                  // 200
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 202
                                                                                                                       //
    if (user.profile) {                                                                                                // 205
      if (user.profile.name) {                                                                                         // 206
        identity.name = user.profile.name;                                                                             // 207
      }                                                                                                                // 208
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 210
        identity.handle = user.profile.handle;                                                                         // 211
      }                                                                                                                // 212
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 214
        identity.picture = user.profile.picture;                                                                       // 215
      }                                                                                                                // 216
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 218
        identity.pronoun = user.profile.pronoun;                                                                       // 219
      }                                                                                                                // 220
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 222
        identity.unverifiedEmail = user.profile.email;                                                                 // 223
      }                                                                                                                // 224
    }                                                                                                                  // 225
                                                                                                                       //
    identity.main = true;                                                                                              // 227
                                                                                                                       //
    db.collections.users.update(user._id, { $set: { identities: [identity] } });                                       // 229
                                                                                                                       //
    db.collections.grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });        // 231
    db.collections.sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });      // 232
    db.collections.apiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });     // 233
    db.collections.apiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({                                                                           // 243
      "requirements.permissionsHeld.userId": user._id                                                                  // 244
    }, {                                                                                                               // 243
      $set: { "requirements.$.permissionsHeld.identityId": identity.id },                                              // 246
      $unset: { "requirements.$.permissionsHeld.userId": 1 }                                                           // 247
    }, {                                                                                                               // 245
      multi: true                                                                                                      // 249
    }) > 0) {}                                                                                                         // 248
    // The `$` operator modifies the first element in the array that matches the query. Since                          //
    // there may be many matches, we need to repeat until no documents are modified.                                   //
  });                                                                                                                  // 254
                                                                                                                       //
  db.collections.apiTokens.remove({ userInfo: { $exists: true } });                                                    // 256
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              //
  // that this field could show up in the database was in this deprecated, no-longer-functional                        //
  // form of API token.                                                                                                //
};                                                                                                                     // 260
                                                                                                                       //
var appUpdateSettings = function appUpdateSettings(db, backend) {                                                      // 262
  db.collections.settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                         // 263
  db.collections.settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                     // 264
  db.collections.settings.insert({ _id: "appUpdatesEnabled", value: true });                                           // 265
};                                                                                                                     // 266
                                                                                                                       //
var moveDevAndEmailLoginDataIntoIdentities = function moveDevAndEmailLoginDataIntoIdentities(db, backend) {            // 268
  db.collections.users.find().forEach(function (user) {                                                                // 269
    if (user.identities.length !== 1) {                                                                                // 270
      throw new Error("User does not have exactly one identity: ", user);                                              // 271
    }                                                                                                                  // 272
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 274
    if (Match.test(identity.service, Object)) {                                                                        // 275
      return;                                                                                                          // 275
    } // Already migrated.                                                                                             // 275
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 277
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 278
                                                                                                                       //
    var serviceObject = {};                                                                                            // 280
    var fieldsToUnset = {};                                                                                            // 281
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 283
      serviceObject.name = user.devName;                                                                               // 284
      fieldsToUnset.devName = 1;                                                                                       // 285
    } else if (identity.service === "emailToken") {                                                                    // 286
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 287
      serviceObject.email = user.services.emailToken.email;                                                            // 288
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 289
    }                                                                                                                  // 290
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 292
    newIdentity.service[identity.service] = serviceObject;                                                             // 293
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 295
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 296
      modifier.$unset = fieldsToUnset;                                                                                 // 297
    }                                                                                                                  // 298
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, modifier);                                                          // 300
  });                                                                                                                  // 301
};                                                                                                                     // 302
                                                                                                                       //
var repairEmailIdentityIds = function repairEmailIdentityIds(db, backend) {                                            // 304
  db.collections.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {             // 305
    if (user.identities.length !== 1) {                                                                                // 306
      throw new Error("User does not have exactly one identity: ", user);                                              // 307
    }                                                                                                                  // 308
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 310
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 311
    newIdentity.service = { email: identity.service.emailToken };                                                      // 313
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 314
                                                                                                                       //
    db.collections.grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                           // 333
  });                                                                                                                  // 334
};                                                                                                                     // 335
                                                                                                                       //
var splitAccountUsersAndIdentityUsers = function splitAccountUsersAndIdentityUsers(db, backend) {                      // 337
  db.collections.users.find({ identities: { $exists: true } }).forEach(function (user) {                               // 338
    if (user.identities.length !== 1) {                                                                                // 339
      throw new Error("User does not have exactly one identity: ", user);                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 343
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 344
    identityUser._id = identity.id;                                                                                    // 345
    identityUser.profile = identity.profile;                                                                           // 346
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 347
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 348
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        //
    // contains subfields that are constrained to be unique by Mongo indices.                                          //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 352
    if (identity.service.dev) {                                                                                        // 353
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 354
    } else if (identity.service.email) {                                                                               // 355
      identityUser.stagedServices.email = identity.service.email;                                                      // 356
    }                                                                                                                  // 357
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 363
    accountUser.nonloginIdentities = [];                                                                               // 364
    if (user.services && user.services.resume) {                                                                       // 365
      accountUser.services = { resume: user.services.resume };                                                         // 366
    }                                                                                                                  // 367
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 369
                                                                                                                       //
    db.collections.apiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });
                                                                                                                       //
    db.collections.users.upsert({ _id: identityUser._id }, identityUser);                                              // 376
    db.collections.users.update({ _id: user._id }, accountUser);                                                       // 377
  });                                                                                                                  // 378
                                                                                                                       //
  db.collections.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                       // 380
    db.collections.users.update({ _id: identity._id }, {                                                               // 381
      $unset: { stagedServices: 1 },                                                                                   // 382
      $set: { services: identity.stagedServices }                                                                      // 383
    });                                                                                                                // 381
  });                                                                                                                  // 385
};                                                                                                                     // 386
                                                                                                                       //
var populateContactsFromApiTokens = function populateContactsFromApiTokens(db, backend) {                              // 388
  db.collections.apiTokens.find({                                                                                      // 389
    "owner.user.identityId": { $exists: 1 },                                                                           // 390
    accountId: { $exists: 1 }                                                                                          // 391
  }).forEach(function (token) {                                                                                        // 389
    var identityId = token.owner.user.identityId;                                                                      // 393
    var identity = db.getIdentity(identityId);                                                                         // 394
    if (identity) {                                                                                                    // 395
      var profile = identity.profile;                                                                                  // 396
      db.collections.contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                           // 397
        ownerId: token.accountId,                                                                                      // 398
        petname: profile && profile.name,                                                                              // 399
        created: new Date(),                                                                                           // 400
        identityId: identityId,                                                                                        // 401
        profile: profile                                                                                               // 402
      });                                                                                                              // 397
    }                                                                                                                  // 404
  });                                                                                                                  // 405
};                                                                                                                     // 406
                                                                                                                       //
var cleanUpApiTokens = function cleanUpApiTokens(db, backend) {                                                        // 408
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       //
  // where the user still existed in the database.                                                                     //
  db.collections.apiTokens.remove({                                                                                    // 411
    userId: { $exists: true },                                                                                         // 412
    identityId: { $exists: false }                                                                                     // 413
  });                                                                                                                  // 411
  db.collections.apiTokens.remove({                                                                                    // 415
    "owner.user.userId": { $exists: true },                                                                            // 416
    "owner.user.identityId": { $exists: false }                                                                        // 417
  });                                                                                                                  // 415
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             //
  db.collections.apiTokens.find({                                                                                      // 421
    "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true }                                                  // 422
  }).forEach(function (apiToken) {                                                                                     // 421
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 424
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 425
      $set: { "owner.user.denormalizedGrainMetadata.icon": icon },                                                     // 426
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true }                                                 // 427
    });                                                                                                                // 425
  });                                                                                                                  // 429
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    //
  function repairChain(parentToken) {                                                                                  // 432
    db.collections.apiTokens.find({                                                                                    // 433
      parentToken: parentToken._id,                                                                                    // 434
      grainId: { $exists: true },                                                                                      // 435
      identityId: { $exists: false }                                                                                   // 436
    }).forEach(function (childToken) {                                                                                 // 433
      db.collections.apiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });      // 438
      repairChain(childToken);                                                                                         // 439
    });                                                                                                                // 440
  }                                                                                                                    // 441
                                                                                                                       //
  db.collections.apiTokens.find({                                                                                      // 443
    grainId: { $exists: true },                                                                                        // 444
    identityId: { $exists: true },                                                                                     // 445
    parentToken: { $exists: false }                                                                                    // 446
  }).forEach(repairChain);                                                                                             // 443
};                                                                                                                     // 448
                                                                                                                       //
var initServerTitleAndReturnAddress = function initServerTitleAndReturnAddress(db, backend) {                          // 450
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 451
  db.collections.settings.insert({ _id: "serverTitle", value: hostname });                                             // 452
  db.collections.settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                             // 453
};                                                                                                                     // 454
                                                                                                                       //
var sendReferralNotifications = function sendReferralNotifications(db, backend) {                                      // 456
  if (db.isReferralEnabled()) {                                                                                        // 457
    db.collections.users.find({                                                                                        // 458
      loginIdentities: { $exists: true },                                                                              // 459
      expires: { $exists: false }                                                                                      // 460
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 458
      db.sendReferralProgramNotification(user._id);                                                                    // 462
    });                                                                                                                // 463
  }                                                                                                                    // 464
};                                                                                                                     // 465
                                                                                                                       //
var assignBonuses = function assignBonuses(db, backend) {                                                              // 467
  if (db.isReferralEnabled() && SandstormDb.bonusesMigrationHook) {                                                    // 468
    SandstormDb.bonusesMigrationHook();                                                                                // 469
  }                                                                                                                    // 470
};                                                                                                                     // 471
                                                                                                                       //
var splitSmtpUrl = function splitSmtpUrl(db, backend) {                                                                // 473
  var smtpUrlSetting = db.collections.settings.findOne({ _id: "smtpUrl" });                                            // 474
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 475
  var returnAddress = db.collections.settings.findOne({ _id: "returnAddress" });                                       // 476
                                                                                                                       //
  // Default values.                                                                                                   //
  var smtpConfig = {                                                                                                   // 479
    hostname: "localhost",                                                                                             // 480
    port: "25",                                                                                                        // 481
    auth: undefined,                                                                                                   // 482
    returnAddress: returnAddress.value                                                                                 // 483
  };                                                                                                                   // 479
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 486
  try {                                                                                                                // 487
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 488
  } catch (e) {}                                                                                                       // 489
                                                                                                                       //
  if (parsed) {                                                                                                        // 491
    // If there was a SMTP URL previously defined, import its data.                                                    //
    var auth = undefined;                                                                                              // 493
    if (parsed.auth) {                                                                                                 // 494
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 495
      var user = undefined;                                                                                            // 496
      var pass = undefined;                                                                                            // 497
      if (colonIndex !== -1) {                                                                                         // 498
        user = parsed.auth.slice(0, colonIndex);                                                                       // 499
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 500
      }                                                                                                                // 501
                                                                                                                       //
      auth = {                                                                                                         // 503
        user: user,                                                                                                    // 504
        pass: pass                                                                                                     // 505
      };                                                                                                               // 503
    }                                                                                                                  // 507
                                                                                                                       //
    // Override defaults with previous config's values.                                                                //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 510
    smtpConfig.port = parsed.port || "25";                                                                             // 511
    smtpConfig.auth = auth;                                                                                            // 512
  }                                                                                                                    // 513
                                                                                                                       //
  db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                        // 515
  db.collections.settings.remove({ _id: "returnAddress" });                                                            // 516
  db.collections.settings.remove({ _id: "smtpUrl" });                                                                  // 517
};                                                                                                                     // 518
                                                                                                                       //
var smtpPortShouldBeNumber = function smtpPortShouldBeNumber(db, backend) {                                            // 520
  var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                  // 521
  if (entry) {                                                                                                         // 522
    var setting = entry.value;                                                                                         // 523
    if (setting.port) {                                                                                                // 524
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 525
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: setting });                                       // 526
    }                                                                                                                  // 527
  }                                                                                                                    // 528
};                                                                                                                     // 529
                                                                                                                       //
var consolidateOrgSettings = function consolidateOrgSettings(db, backend) {                                            // 531
  var settings = db.collections.settings;                                                                              // 532
  var orgGoogleDomain = settings.findOne({ _id: "organizationGoogle" });                                               // 533
  var orgEmailDomain = settings.findOne({ _id: "organizationEmail" });                                                 // 534
  var orgLdap = settings.findOne({ _id: "organizationLdap" });                                                         // 535
  var orgSaml = settings.findOne({ _id: "organizationSaml" });                                                         // 536
                                                                                                                       //
  var orgMembership = {                                                                                                // 538
    google: {                                                                                                          // 539
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 540
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 541
    },                                                                                                                 // 539
    email: {                                                                                                           // 543
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 544
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 545
    },                                                                                                                 // 543
    ldap: {                                                                                                            // 547
      enabled: orgLdap ? orgLdap.value : false                                                                         // 548
    },                                                                                                                 // 547
    saml: {                                                                                                            // 550
      enabled: orgSaml ? orgSaml.value : false                                                                         // 551
    }                                                                                                                  // 550
  };                                                                                                                   // 538
                                                                                                                       //
  settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 555
  settings.remove({ _id: "organizationGoogle" });                                                                      // 556
  settings.remove({ _id: "organizationEmail" });                                                                       // 557
  settings.remove({ _id: "organizationLdap" });                                                                        // 558
  settings.remove({ _id: "organizationSaml" });                                                                        // 559
};                                                                                                                     // 560
                                                                                                                       //
var unsetSmtpDefaultHostnameIfNoUsersExist = function unsetSmtpDefaultHostnameIfNoUsersExist(db, backend) {            // 562
  // We don't actually want to have the default hostname "localhost" set.                                              //
  // If the user has already finished configuring their server, then this migration should do                          //
  // nothing (since we might break their deployment), but for new installs (which will have no users                   //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     //
  // default value.                                                                                                    //
  var hasUsers = db.collections.users.findOne();                                                                       // 568
  if (!hasUsers) {                                                                                                     // 569
    var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                // 570
    var smtpConfig = entry.value;                                                                                      // 571
    if (smtpConfig.hostname === "localhost") {                                                                         // 572
      smtpConfig.hostname = "";                                                                                        // 573
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                    // 574
    }                                                                                                                  // 575
  }                                                                                                                    // 576
};                                                                                                                     // 577
                                                                                                                       //
var extractLastUsedFromApiTokenOwner = function extractLastUsedFromApiTokenOwner(db, backend) {                        // 579
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     //
  // itself.                                                                                                           //
  db.collections.apiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                        // 583
    var lastUsed = token.owner.user.lastUsed;                                                                          // 584
    db.collections.apiTokens.update({ _id: token._id }, {                                                              // 585
      $set: { lastUsed: lastUsed },                                                                                    // 586
      $unset: { "owner.user.lastUsed": true }                                                                          // 587
    });                                                                                                                // 585
  });                                                                                                                  // 589
};                                                                                                                     // 590
                                                                                                                       //
var setUpstreamTitles = function setUpstreamTitles(db, backend) {                                                      // 592
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    //
                                                                                                                       //
  var apiTokensRaw = db.collections.apiTokens.rawCollection();                                                         // 595
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 596
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            //
  // for each of these, so we'd like to skip those which have nothing to update.                                       //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 603
  });                                                                                                                  // 603
                                                                                                                       //
  var count = 0;                                                                                                       // 605
  db.collections.grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {          // 606
    if (count % 100 == 0) {                                                                                            // 607
      console.log(count + " / " + grainIds.length);                                                                    // 608
    }                                                                                                                  // 609
                                                                                                                       //
    ++count;                                                                                                           // 611
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      //
    // copy post-sharaing. We assume it was the owner, because:                                                        //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      //
    //    owner who renamed post-sharing.                                                                              //
    db.collections.apiTokens.update({                                                                                  // 624
      grainId: grain._id,                                                                                              // 625
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 626
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 624
  });                                                                                                                  // 628
};                                                                                                                     // 629
                                                                                                                       //
var markAllRead = function markAllRead(db, backend) {                                                                  // 631
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             //
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           //
                                                                                                                       //
  db.collections.grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                         // 635
  db.collections.apiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
};                                                                                                                     // 639
                                                                                                                       //
var clearAppIndex = function clearAppIndex(db, backend) {                                                              // 641
  // Due to a bug in the app update code, some app update notifications that the user accepted                         //
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      //
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     //
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      //
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            //
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      //
  // click "dismiss" again easily enough.                                                                              //
                                                                                                                       //
  db.collections.appIndex.remove({});                                                                                  // 650
};                                                                                                                     // 651
                                                                                                                       //
var assignEmailVerifierIds = function assignEmailVerifierIds(db, backend) {                                            // 653
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       //
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    //
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      //
  // to the fact that powerbox selections always involve a restore(), but a different problem                          //
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       //
  // and restore()ing that capability, the ID would be different, because the new capability would                     //
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      //
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          //
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          //
                                                                                                                       //
  db.collections.apiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {         // 664
    db.collections.apiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });               // 665
  });                                                                                                                  // 666
};                                                                                                                     // 667
                                                                                                                       //
var startPreinstallingApps = function startPreinstallingApps(db, backend) {                                            // 669
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        //
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 //
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 673
    db.updateAppIndex();                                                                                               // 674
                                                                                                                       //
    var preinstalledApps = db.collections.appIndex.find({ _id: {                                                       // 676
        $in: db.getProductivitySuiteAppIds() }                                                                         // 677
    }).fetch();                                                                                                        // 676
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 679
      return {                                                                                                         // 680
        appId: app.appId,                                                                                              // 681
        packageId: app.packageId                                                                                       // 682
      };                                                                                                               // 680
    });                                                                                                                // 684
                                                                                                                       //
    db.setPreinstalledApps(appAndPackageIds);                                                                          // 686
  };                                                                                                                   // 687
                                                                                                                       //
  if (!Meteor.settings["public"].isTesting && !db.allowDevAccounts()) {                                                // 689
    // We want preinstalling apps to run async and not block startup.                                                  //
    Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                // 691
  }                                                                                                                    // 692
};                                                                                                                     // 693
                                                                                                                       //
var setNewServer = function setNewServer(db, backend) {                                                                // 695
  // This migration only applies to "old" servers. New servers will set                                                //
  // new_server_migrations_applied to false before any migrations run.                                                 //
  if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" })) {                                  // 698
    db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: true });                           // 699
  }                                                                                                                    // 700
};                                                                                                                     // 701
                                                                                                                       //
function backgroundFillInGrainSizes(db, backend) {                                                                     // 703
  // Fill in sizes for all grains that don't have them. Since computing a grain size requires a                        //
  // directory walk, we don't want to do them all at once. Instead, we compute one a second until                      //
  // all grains have sizes.                                                                                            //
                                                                                                                       //
  try {                                                                                                                // 708
    var grain = db.collections.grains.findOne({ size: { $exists: false } }, { fields: { _id: 1, userId: 1 } });        // 709
                                                                                                                       //
    if (grain) {                                                                                                       // 711
      // Compute size!                                                                                                 //
      try {                                                                                                            // 713
        var result = waitPromise(backend.cap().getGrainStorageUsage(grain.userId, grain._id));                         // 714
        db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: parseInt(result.size) } });
      } catch (err) {                                                                                                  // 718
        if (err.kjType === "failed") {                                                                                 // 719
          // Backend had a problem. Maybe the grain doesn't actually exist on disk and the database                    //
          // is messed up. We'll set the size to zero and move on.                                                     //
          console.error("Error while backfilling grain size for", grain._id, ":", err.stack);                          // 722
          db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: 0 } });           // 723
        } else {                                                                                                       // 724
          // Rethrow on disconnected / overloaded / unimplemented.                                                     //
          throw err;                                                                                                   // 726
        }                                                                                                              // 727
      }                                                                                                                // 728
                                                                                                                       //
      // Do another one in a second.                                                                                   //
      Meteor.setTimeout(backgroundFillInGrainSizes.bind(this, db, backend), 1000);                                     // 731
    }                                                                                                                  // 732
  } catch (err) {                                                                                                      // 733
    // We'll just stop for now, to avoid spamming logs if this error persists. Next time the server                    //
    // restarts, the migration will continue.                                                                          //
    console.error("Error while backfilling grain sizes:", err.stack);                                                  // 736
  }                                                                                                                    // 737
}                                                                                                                      // 738
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    //
// Only append to this list!  Do not modify or remove list entries;                                                    //
// doing so is likely change the meaning and semantics of user databases.                                              //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 776
                                                                                                                       //
var migrateToLatest = function migrateToLatest(db, backend) {                                                          // 780
  if (Meteor.settings.replicaNumber) {                                                                                 // 781
    (function () {                                                                                                     // 781
      // This is a replica. Wait for the first replica to perform migrations.                                          //
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 784
                                                                                                                       //
      var done = new Future();                                                                                         // 786
      var change = function change(doc) {                                                                              // 787
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 788
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 789
      };                                                                                                               // 790
                                                                                                                       //
      var observer = db.collections.migrations.find({ _id: "migrations_applied" }).observe({                           // 792
        added: change,                                                                                                 // 793
        changed: change                                                                                                // 794
      });                                                                                                              // 792
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 797
      var newServerChange = function newServerChange(doc) {                                                            // 798
        if (doc.value) {                                                                                               // 799
          console.log("New server migrations applied elsewhere");                                                      // 800
          newServerDone["return"]();                                                                                   // 801
        }                                                                                                              // 802
      };                                                                                                               // 803
                                                                                                                       //
      var newServerObserver = db.collections.migrations.find({ _id: "new_server_migrations_applied" }).observe({       // 805
        added: newServerChange,                                                                                        // 806
        changed: newServerChange                                                                                       // 807
      });                                                                                                              // 805
                                                                                                                       //
      done.wait();                                                                                                     // 810
      observer.stop();                                                                                                 // 811
      newServerDone.wait();                                                                                            // 812
      newServerObserver.stop();                                                                                        // 813
      console.log("Migrations have completed on replica zero.");                                                       // 814
    })();                                                                                                              // 781
  } else {                                                                                                             // 815
    var applied = db.collections.migrations.findOne({ _id: "migrations_applied" });                                    // 816
    var start = void 0;                                                                                                // 817
    if (!applied) {                                                                                                    // 818
      // Migrations table is not yet seeded with a value.  This means it has                                           //
      // applied 0 migrations.  Persist this.                                                                          //
      db.collections.migrations.insert({ _id: "migrations_applied", value: 0 });                                       // 821
      start = 0;                                                                                                       // 822
                                                                                                                       //
      // This also means this is a brand new server                                                                    //
      db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: false });                        // 825
    } else {                                                                                                           // 826
      start = applied.value;                                                                                           // 827
    }                                                                                                                  // 828
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 830
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 832
      // Apply migration i, then record that migration i was successfully run.                                         //
      console.log("Applying migration " + (i + 1));                                                                    // 834
      MIGRATIONS[i](db, backend);                                                                                      // 835
      db.collections.migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                     // 836
      console.log("Applied migration " + (i + 1));                                                                     // 837
    }                                                                                                                  // 838
                                                                                                                       //
    if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                          // 840
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           //
      // ensures it.                                                                                                   //
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 843
        console.log("Running new server startup function " + (_i + 1));                                                // 844
        NEW_SERVER_STARTUP[_i](db, backend);                                                                           // 845
        console.log("Running new server startup function " + (_i + 1));                                                // 846
      }                                                                                                                // 847
                                                                                                                       //
      db.collections.migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });           // 849
    }                                                                                                                  // 850
                                                                                                                       //
    // Start background migrations.                                                                                    //
    backgroundFillInGrainSizes(db, backend);                                                                           // 853
  }                                                                                                                    // 854
};                                                                                                                     // 855
                                                                                                                       //
                                                                                                                       // 857
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"persistent.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 19
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 20
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 21
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 24
    _classCallCheck(this, PersistentImpl);                                                                             // 24
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 25
    this[privateTemplate] = saveTemplate;                                                                              // 26
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      //
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           //
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     //
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             //
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 32
  }                                                                                                                    // 33
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function isSaved() {                                                              //
    // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                    //
    // table representing this capability.                                                                             //
                                                                                                                       //
    return this[privateIsSaved];                                                                                       // 39
  };                                                                                                                   // 40
                                                                                                                       //
  PersistentImpl.prototype.save = function save(params) {                                                              //
    var _this = this;                                                                                                  // 42
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 43
      if (!params.sealFor) {                                                                                           // 44
        throw new Error("must specify 'sealFor'");                                                                     // 45
      }                                                                                                                // 46
                                                                                                                       //
      var db = _this[privateDb];                                                                                       // 48
                                                                                                                       //
      var newToken = _.clone(_this[privateTemplate]);                                                                  // 50
      newToken.owner = params.sealFor;                                                                                 // 51
      if (newToken.owner.user) {                                                                                       // 52
        if (!newToken.identityId) {                                                                                    // 53
          throw new Error("can't save non-UiView with user as owner");                                                 // 54
        }                                                                                                              // 55
                                                                                                                       //
        // Only "identityId" and "title" are allowed to be passed to save().                                           //
        var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                            // 58
                                                                                                                       //
        // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                              //
        userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                           // 61
                                                                                                                       //
        var grain = db.getGrain(newToken.grainId);                                                                     // 63
        if (grain && grain.title !== userOwner.title) {                                                                // 64
          userOwner.upstreamTitle = grain.title;                                                                       // 65
        }                                                                                                              // 66
                                                                                                                       //
        newToken.owner.user = userOwner;                                                                               // 68
      }                                                                                                                // 69
                                                                                                                       //
      var sturdyRef = generateSturdyRef();                                                                             // 71
      newToken._id = hashSturdyRef(sturdyRef);                                                                         // 72
                                                                                                                       //
      newToken.created = new Date();                                                                                   // 74
                                                                                                                       //
      db.collections.apiTokens.insert(newToken);                                                                       // 76
      _this[privateIsSaved] = true;                                                                                    // 77
      return { sturdyRef: new Buffer(sturdyRef) };                                                                     // 78
    });                                                                                                                // 79
  };                                                                                                                   // 80
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 85
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 86
};                                                                                                                     // 87
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 89
  return Random.secret();                                                                                              // 90
}                                                                                                                      // 91
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 93
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      //
  // false otherwise.                                                                                                  //
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        //
  //   Reuse?                                                                                                          //
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    //
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    //
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                //
                                                                                                                       //
  if (!requirements) {                                                                                                 // 104
    return true;                                                                                                       // 105
  }                                                                                                                    // 106
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 108
    if (requirement.tokenValid) {                                                                                      // 109
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 113
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 117
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 119
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 121
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 122
      }                                                                                                                // 123
    } else if (requirement.permissionsHeld) {                                                                          // 124
      var p = requirement.permissionsHeld;                                                                             // 125
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 126
      var vertex = void 0;                                                                                             // 128
      if (p.identityId) {                                                                                              // 129
        vertex = { grain: { _id: p.grainId, identityId: p.identityId } };                                              // 130
      } else {                                                                                                         // 131
        vertex = { token: { _id: p.tokenId, grainId: p.grainId } };                                                    // 132
      }                                                                                                                // 133
                                                                                                                       //
      var currentPermissions = SandstormPermissions.grainPermissions(db, vertex, viewInfo || {}).permissions;          // 135
      if (!currentPermissions) {                                                                                       // 137
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 141
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 143
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 144
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 145
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 149
      }                                                                                                                // 150
    } else if (requirement.userIsAdmin) {                                                                              // 151
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 152
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 156
    } else {                                                                                                           // 157
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 158
    }                                                                                                                  // 159
  });                                                                                                                  // 160
};                                                                                                                     // 161
                                                                                                                       //
                                                                                                                       // 163
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"db-deprecated.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
var quotaManager = void 0;                                                                                             // 26
if (Meteor.isServer) {var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});         // 27
                                                                                                                       // 28
  // Imports are usually not allowed to occur in a block. However, it is the only way to do                            //
  // this under Meteor. Using // jscs:disable doesn't work for what it considers syntax violations,                    //
  // and so we've added this file to .jscsrc's excludedFiles explicitly.                                               //
                                                                                                                       //
  quotaManager = new LDAP();                                                                                           // 33
} else {                                                                                                               // 34
  quotaManager = {                                                                                                     // 35
    updateUserQuota: function updateUserQuota(db, user) {                                                              // 36
      return {                                                                                                         // 37
        storage: user.cachedStorageQuota || 0,                                                                         // 38
        grains: Infinity,                                                                                              // 39
        compute: Infinity                                                                                              // 40
      };                                                                                                               // 37
    }                                                                                                                  // 42
  };                                                                                                                   // 35
}                                                                                                                      // 44
                                                                                                                       //
globalDb = new SandstormDb(quotaManager);                                                                              // 46
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 48
DevPackages = globalDb.collections.devPackages;                                                                        // 49
UserActions = globalDb.collections.userActions;                                                                        // 50
Grains = globalDb.collections.grains;                                                                                  // 51
Contacts = globalDb.collections.contacts;                                                                              // 52
Sessions = globalDb.collections.sessions;                                                                              // 53
SignupKeys = globalDb.collections.signupKeys;                                                                          // 54
ActivityStats = globalDb.collections.activityStats;                                                                    // 55
DeleteStats = globalDb.collections.deleteStats;                                                                        // 56
FileTokens = globalDb.collections.fileTokens;                                                                          // 57
ApiTokens = globalDb.collections.apiTokens;                                                                            // 58
Notifications = globalDb.collections.notifications;                                                                    // 59
StatsTokens = globalDb.collections.statsTokens;                                                                        // 60
Misc = globalDb.collections.misc;                                                                                      // 61
Settings = globalDb.collections.settings;                                                                              // 62
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 64
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 65
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 66
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 67
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 68
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 69
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 70
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 71
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 72
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 73
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 74
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 75
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 76
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"server":{"accounts":{"email-token":{"token-server.js":["crypto","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/email-token/token-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var crypto;module.import("crypto",{"default":function(v){crypto=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
                                                                                                                       //
                                                                                                                       // 3
                                                                                                                       //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                      // 5
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                              // 6
var V1_HASHFUNC = "sha512";                                                                                            // 7
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token                    //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                                 //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                      //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly                     //
// sufficient to reconstruct the output of pbkdf2().                                                                   //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                          // 13
                                                                                                                       //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                              // 15
                                                                                                                       //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                           // 17
  Meteor.users.update({                                                                                                // 18
    "services.email.tokens.createdAt": {                                                                               // 19
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                                  // 20
    }                                                                                                                  // 19
  }, {                                                                                                                 // 18
    $pull: {                                                                                                           // 23
      "services.email.tokens": {                                                                                       // 24
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                                 // 25
      }                                                                                                                // 24
    }                                                                                                                  // 23
  }, {                                                                                                                 // 22
    multi: true                                                                                                        // 29
  });                                                                                                                  // 28
};                                                                                                                     // 31
                                                                                                                       //
Meteor.startup(cleanupExpiredTokens);                                                                                  // 33
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                              //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                                // 35
                                                                                                                       //
var hashToken = function hashToken(token) {                                                                            // 37
  return {                                                                                                             // 38
    digest: SHA256(token),                                                                                             // 39
    algorithm: "sha-256"                                                                                               // 40
  };                                                                                                                   // 38
};                                                                                                                     // 42
                                                                                                                       //
var checkToken = function checkToken(tokens, token) {                                                                  // 44
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.                   //
  // Returns the matching object, if one is found, or undefined if none match.                                         //
  var foundToken = undefined;                                                                                          // 47
  tokens.forEach(function (userToken) {                                                                                // 48
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                                // 49
      foundToken = userToken;                                                                                          // 51
    }                                                                                                                  // 52
  });                                                                                                                  // 53
                                                                                                                       //
  return foundToken;                                                                                                   // 55
};                                                                                                                     // 56
                                                                                                                       //
var consumeToken = function consumeToken(user, token) {                                                                // 58
  var hashedToken = hashToken(token);                                                                                  // 59
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                                // 60
                                                                                                                       //
  if (foundToken !== undefined) {                                                                                      // 62
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                       // 63
  }                                                                                                                    // 64
                                                                                                                       //
  return foundToken;                                                                                                   // 66
};                                                                                                                     // 67
                                                                                                                       //
var makeBox = function makeBox(token, plaintext) {                                                                     // 69
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                            //
  // ciphertext and associated data needed to decrypt later.                                                           //
                                                                                                                       //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                          //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                                     //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole                   //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                      //
  // This would require lengthening the token, which would make the manual-code-entry workflow                         //
  // worse, so I'm punting on that for now.                                                                            //
  var salt = Random.secret(16);                                                                                        // 79
  var key = crypto.pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                                        // 80
  var iv = crypto.randomBytes(16);                                                                                     // 81
  var cipher = crypto.createCipheriv(V1_CIPHER, key, iv);                                                              // 82
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                                     // 83
  return {                                                                                                             // 84
    version: 1,                                                                                                        // 85
    salt: salt,                                                                                                        // 86
    iv: iv.toString("base64"),                                                                                         // 87
    boxedValue: ciphertext.toString("base64")                                                                          // 88
  };                                                                                                                   // 84
};                                                                                                                     // 90
                                                                                                                       //
var tryUnbox = function tryUnbox(box, secret) {                                                                        // 92
  if (box) {                                                                                                           // 93
    if (box.version === 1) {                                                                                           // 94
      var key = crypto.pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                               // 95
      var iv = new Buffer(box.iv, "base64");                                                                           // 96
      var cipher = crypto.createDecipheriv(V1_CIPHER, key, iv);                                                        // 97
      var cipherText = new Buffer(box.boxedValue, "base64");                                                           // 98
      var plaintext = cipher.update(cipherText);                                                                       // 99
      return plaintext.toString("binary");                                                                             // 100
    }                                                                                                                  // 101
  }                                                                                                                    // 102
                                                                                                                       //
  // If no box was provided, or it was of an unknown version, return no data.                                          //
  return;                                                                                                              // 105
};                                                                                                                     // 106
                                                                                                                       //
// Handler to login with a token.                                                                                      //
Accounts.registerLoginHandler("email", function (options) {                                                            // 109
  if (!options.email) {                                                                                                // 110
    return undefined; // don't handle                                                                                  // 111
  }                                                                                                                    // 112
                                                                                                                       //
  if (!Accounts.identityServices.email.isEnabled()) {                                                                  // 114
    throw new Meteor.Error(403, "Email identity service is disabled.");                                                // 115
  }                                                                                                                    // 116
                                                                                                                       //
  options = options.email;                                                                                             // 118
  check(options, {                                                                                                     // 119
    email: String,                                                                                                     // 120
    token: String                                                                                                      // 121
  });                                                                                                                  // 119
                                                                                                                       //
  var user = Meteor.users.findOne({                                                                                    // 124
    "services.email.email": options.email                                                                              // 125
  }, {                                                                                                                 // 124
    fields: {                                                                                                          // 127
      "services.email": 1                                                                                              // 128
    }                                                                                                                  // 127
  });                                                                                                                  // 126
                                                                                                                       //
  if (!user) {                                                                                                         // 132
    console.error("User not found:", options.email);                                                                   // 133
    return {                                                                                                           // 134
      error: new Meteor.Error(403, "User not found")                                                                   // 135
    };                                                                                                                 // 134
  }                                                                                                                    // 137
                                                                                                                       //
  if (!user.services.email.tokens) {                                                                                   // 139
    console.error("User has no token set:", options.email);                                                            // 140
    return {                                                                                                           // 141
      error: new Meteor.Error(403, "User has no token set")                                                            // 142
    };                                                                                                                 // 141
  }                                                                                                                    // 144
                                                                                                                       //
  var tokenString = options.token.trim();                                                                              // 146
  var maybeToken = consumeToken(user, tokenString);                                                                    // 147
  if (!maybeToken) {                                                                                                   // 148
    console.error("Token not found:", options.email);                                                                  // 149
    return {                                                                                                           // 150
      error: new Meteor.Error(403, "Invalid authentication code")                                                      // 151
    };                                                                                                                 // 150
  }                                                                                                                    // 153
                                                                                                                       //
  // Attempt to decrypt the resumePath, if provided.                                                                   //
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                        // 156
                                                                                                                       //
  return {                                                                                                             // 158
    userId: user._id,                                                                                                  // 159
    options: {                                                                                                         // 160
      resumePath: resumePath                                                                                           // 161
    }                                                                                                                  // 160
  };                                                                                                                   // 158
});                                                                                                                    // 164
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 166
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 168
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 169
                                                                                                                       //
var makeTokenUrl = function makeTokenUrl(email, token, linkingIdentity) {                                              // 171
  if (linkingIdentity) {                                                                                               // 172
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                             // 175
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);       // 176
  }                                                                                                                    // 178
};                                                                                                                     // 179
                                                                                                                       //
///                                                                                                                    //
/// EMAIL VERIFICATION                                                                                                 //
///                                                                                                                    //
var sendTokenEmail = function sendTokenEmail(db, email, token, linkingIdentity) {                                      // 184
  var subject = void 0;                                                                                                // 185
  var text = void 0;                                                                                                   // 186
  if (!linkingIdentity) {                                                                                              // 187
    subject = "Log in to " + HOSTNAME;                                                                                 // 188
    text = "To confirm this email address on ";                                                                        // 189
  } else {                                                                                                             // 190
    subject = "Confirm this email address on " + HOSTNAME;                                                             // 191
    text = "To confirm this email address on ";                                                                        // 192
  }                                                                                                                    // 193
                                                                                                                       //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                       //
  var options = {                                                                                                      // 200
    to: email,                                                                                                         // 201
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                                    // 202
    subject: subject,                                                                                                  // 203
    text: text                                                                                                         // 204
  };                                                                                                                   // 200
                                                                                                                       //
  sendEmail(options);                                                                                                  // 207
};                                                                                                                     // 208
                                                                                                                       //
///                                                                                                                    //
/// CREATING USERS                                                                                                     //
///                                                                                                                    //
// returns the user id                                                                                                 //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, linkingIdentity, resumePath) {       // 214
  check(email, String);                                                                                                // 215
  check(linkingIdentity, Boolean);                                                                                     // 216
  check(resumePath, String);                                                                                           // 217
                                                                                                                       //
  var atIndex = email.indexOf("@");                                                                                    // 219
  if (atIndex === -1) {                                                                                                // 220
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                                // 221
  }                                                                                                                    // 222
                                                                                                                       //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });             // 224
  var userId = void 0;                                                                                                 // 226
                                                                                                                       //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                                 //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                         //
  var token = Random.id(12);                                                                                           // 230
  var tokenObj = hashToken(token);                                                                                     // 231
  tokenObj.createdAt = new Date();                                                                                     // 232
  tokenObj.secureBox = makeBox(token, resumePath);                                                                     // 233
                                                                                                                       //
  if (user) {                                                                                                          // 235
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                         // 236
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                                  // 240
                                                                                                                       //
    userId = user._id;                                                                                                 // 242
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                          // 244
  } else {                                                                                                             // 245
    var options = {};                                                                                                  // 246
    user = {                                                                                                           // 247
      services: {                                                                                                      // 248
        email: {                                                                                                       // 249
          tokens: [tokenObj],                                                                                          // 250
          email: email                                                                                                 // 251
        }                                                                                                              // 249
      }                                                                                                                // 248
    };                                                                                                                 // 247
                                                                                                                       //
    userId = Accounts.insertUserDoc(options, user);                                                                    // 256
  }                                                                                                                    // 257
                                                                                                                       //
  sendTokenEmail(db, email, token, linkingIdentity);                                                                   // 259
                                                                                                                       //
  return userId;                                                                                                       // 261
};                                                                                                                     // 262
                                                                                                                       //
Meteor.methods({                                                                                                       // 264
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, linkingIdentity, resumePath) {                // 265
    // method for create user. Requests come from the client.                                                          //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                         //
    // It will always send an email to the user                                                                        //
                                                                                                                       //
    check(email, String);                                                                                              // 270
    check(linkingIdentity, Boolean);                                                                                   // 271
    check(resumePath, String);                                                                                         // 272
                                                                                                                       //
    if (!Accounts.identityServices.email.isEnabled()) {                                                                // 274
      throw new Meteor.Error(403, "Email identity service is disabled.");                                              // 275
    }                                                                                                                  // 276
    // Create user. result contains id and token.                                                                      //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity, resumePath);           // 278
  },                                                                                                                   // 279
                                                                                                                       //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token) {                                      // 281
    // Links the email identity with address `email` and login token `token` to the current account.                   //
    check(email, String);                                                                                              // 283
    check(token, String);                                                                                              // 284
    var account = Meteor.user();                                                                                       // 285
    if (!account || !account.loginIdentities) {                                                                        // 286
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                       // 287
    }                                                                                                                  // 288
                                                                                                                       //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 290
    if (!identity) {                                                                                                   // 292
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 293
    }                                                                                                                  // 294
                                                                                                                       //
    var maybeToken = consumeToken(identity, token.trim());                                                             // 296
    if (!maybeToken) {                                                                                                 // 297
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 298
    }                                                                                                                  // 299
                                                                                                                       //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
                                                                                                                       //
    // Return the resume path, if we have one.                                                                         //
    var resumePath = tryUnbox(maybeToken.secureBox, token);                                                            // 305
    return resumePath;                                                                                                 // 306
  }                                                                                                                    // 307
});                                                                                                                    // 264
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"identity":{"identity-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/identity/identity-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var linkIdentityToAccountInternal = function linkIdentityToAccountInternal(db, backend, identityId, accountId) {       // 17
  // Links the identity to the account and grants it login access if possible. Makes the account                       //
  // durable if it is a demo account.                                                                                  //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 21
  check(backend, SandstormBackend);                                                                                    // 22
  check(identityId, String);                                                                                           // 23
  check(accountId, String);                                                                                            // 24
                                                                                                                       //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                          // 26
  if (!accountUser) {                                                                                                  // 27
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                              // 28
  }                                                                                                                    // 29
                                                                                                                       //
  if (accountUser.profile) {                                                                                           // 31
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                       // 32
  }                                                                                                                    // 33
                                                                                                                       //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");          // 37
  }                                                                                                                    // 39
                                                                                                                       //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                        // 41
                                                                                                                       //
  if (!identityUser) {                                                                                                 // 43
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                            // 44
  }                                                                                                                    // 45
                                                                                                                       //
  if (!identityUser.profile) {                                                                                         // 47
    throw new Meteor.Error(400, "Cannot link an account to another account");                                          // 48
  }                                                                                                                    // 49
                                                                                                                       //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                   // 51
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                              // 52
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                  // 53
  }                                                                                                                    // 55
                                                                                                                       //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                           // 57
                                                                                                                       //
  var pushModifier = alreadyLinked ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                       //
  var modifier = void 0;                                                                                               // 63
  if (accountUser.expires) {                                                                                           // 64
    if (alreadyLinked) {                                                                                               // 65
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                  // 68
                                                                                                                       //
    modifier = {                                                                                                       // 70
      $push: pushModifier,                                                                                             // 71
      $unset: { expires: 1 },                                                                                          // 72
      $set: { upgradedFromDemo: Date.now() }                                                                           // 73
    };                                                                                                                 // 70
    if (db.isReferralEnabled()) {                                                                                      // 75
      // Demo users never got the referral notification. Send it now:                                                  //
      db.sendReferralProgramNotification(accountUser._id);                                                             // 77
    }                                                                                                                  // 78
  } else {                                                                                                             // 80
    modifier = { $push: pushModifier };                                                                                // 81
  }                                                                                                                    // 82
                                                                                                                       //
  // Make sure not to add the same identity twice.                                                                     //
  Meteor.users.update({ _id: accountUser._id,                                                                          // 85
    "nonloginIdentities.id": { $ne: identityUser._id },                                                                // 86
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                      // 87
                                                                                                                       //
  if (accountUser.expires) {                                                                                           // 90
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                               // 91
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                             // 92
      $set: { upgradedFromDemo: Date.now() } });                                                                       // 94
                                                                                                                       //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                      //
    // but to get that to work we would need to adjust the account creation and first login logic.                     //
    Meteor.users.update({ _id: accountUser._id,                                                                        // 98
      "loginIdentities.id": demoIdentityId,                                                                            // 99
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                        // 102
  }                                                                                                                    // 104
};                                                                                                                     // 105
                                                                                                                       //
Meteor.methods({                                                                                                       // 107
  loginWithIdentity: function loginWithIdentity(accountUserId) {                                                       // 108
    // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                       //
    // not an identity user listed in the account's `loginIdentities` field. This method is not                        //
    // intended to be called directly; client-side code should only invoke it through                                  //
    // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                      //
    // login state.                                                                                                    //
                                                                                                                       //
    check(accountUserId, String);                                                                                      // 115
                                                                                                                       //
    var identityUser = Meteor.user();                                                                                  // 117
    if (!identityUser || !identityUser.profile) {                                                                      // 118
      throw new Meteor.Error(403, "Must be already logged in as an identity.");                                        // 119
    }                                                                                                                  // 120
                                                                                                                       //
    var accountUser = Meteor.users.findOne(accountUserId);                                                             // 122
    if (!accountUser) {                                                                                                // 123
      throw new Meteor.Error(404, "No such user found: " + accountUserId);                                             // 124
    }                                                                                                                  // 125
                                                                                                                       //
    var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                           // 127
                                                                                                                       //
    if (!linkedIdentity) {                                                                                             // 129
      throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);            // 130
    }                                                                                                                  // 132
                                                                                                                       //
    return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {                 // 134
      return { userId: accountUserId };                                                                                // 135
    });                                                                                                                // 135
  },                                                                                                                   // 136
                                                                                                                       //
  createAccountForIdentity: function createAccountForIdentity() {                                                      // 138
    // Creates a new account for the currently-logged-in identity.                                                     //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 141
    if (!(user && user.profile)) {                                                                                     // 142
      throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");                  // 143
    }                                                                                                                  // 144
                                                                                                                       //
    if (Meteor.users.findOne({                                                                                         // 146
      $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                                 // 147
    })) {                                                                                                              // 146
      throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
    }                                                                                                                  // 154
                                                                                                                       //
    var newUser = {                                                                                                    // 156
      loginIdentities: [{ id: user._id }],                                                                             // 157
      nonloginIdentities: []                                                                                           // 158
    };                                                                                                                 // 156
    if (user.services.dev) {                                                                                           // 160
      newUser.signupKey = "devAccounts";                                                                               // 161
      if (user.services.dev.isAdmin) {                                                                                 // 162
        newUser.isAdmin = true;                                                                                        // 163
      }                                                                                                                // 164
                                                                                                                       //
      if (user.services.dev.hasCompletedSignup) {                                                                      // 166
        newUser.hasCompletedSignup = true;                                                                             // 167
      }                                                                                                                // 168
    } else if (user.expires) {                                                                                         // 169
      // Demo user.                                                                                                    //
      newUser.expires = user.expires;                                                                                  // 171
      if (!!user.appDemoId) {                                                                                          // 172
        newUser.appDemoId = user.appDemoId;                                                                            // 173
      }                                                                                                                // 174
    }                                                                                                                  // 175
                                                                                                                       //
    var options = {};                                                                                                  // 177
                                                                                                                       //
    // This will throw an error if the identity has been added as a login identity to some                             //
    // other account while we were executing the body of this method.                                                  //
    return Accounts.insertUserDoc(options, newUser);                                                                   // 181
  },                                                                                                                   // 182
                                                                                                                       //
  linkIdentityToAccount: function linkIdentityToAccount(token) {                                                       // 184
    // Links the identity of the current user to the account that has `token` as a resume token.                       //
    // If the account is a demo account, makes the account durable and gives the identity login                        //
    // access to it.                                                                                                   //
                                                                                                                       //
    check(token, String);                                                                                              // 189
                                                                                                                       //
    if (!this.userId) {                                                                                                // 191
      throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                         // 192
    }                                                                                                                  // 193
                                                                                                                       //
    var hashed = Accounts._hashLoginToken(token);                                                                      // 195
    var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                     // 196
                                                                                                                       //
    linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id);
  },                                                                                                                   // 200
                                                                                                                       //
  unlinkIdentity: function unlinkIdentity(accountUserId, identityId) {                                                 // 202
    // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                             //
                                                                                                                       //
    check(identityId, String);                                                                                         // 205
    check(accountUserId, String);                                                                                      // 206
                                                                                                                       //
    if (!this.userId) {                                                                                                // 208
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 209
    }                                                                                                                  // 210
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 212
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 213
    }                                                                                                                  // 214
                                                                                                                       //
    var identityUser = Meteor.users.findOne({ _id: identityId });                                                      // 216
    Meteor.users.update({                                                                                              // 217
      _id: accountUserId                                                                                               // 218
    }, {                                                                                                               // 217
      $pull: {                                                                                                         // 220
        nonloginIdentities: { id: identityId },                                                                        // 221
        loginIdentities: { id: identityId }                                                                            // 222
      }                                                                                                                // 220
    });                                                                                                                // 219
  },                                                                                                                   // 225
                                                                                                                       //
  setIdentityAllowsLogin: function setIdentityAllowsLogin(identityId, allowLogin) {                                    // 227
    // Sets whether the current account allows the identity with ID `identityId` to log in.                            //
                                                                                                                       //
    check(identityId, String);                                                                                         // 230
    check(allowLogin, Boolean);                                                                                        // 231
    if (!this.userId) {                                                                                                // 232
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 233
    }                                                                                                                  // 234
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 236
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 237
    }                                                                                                                  // 238
                                                                                                                       //
    if (allowLogin) {                                                                                                  // 240
      Meteor.users.update({ _id: this.userId,                                                                          // 241
        "nonloginIdentities.id": identityId,                                                                           // 242
        "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },    // 243
        $push: { loginIdentities: { id: identityId } } });                                                             // 245
    } else {                                                                                                           // 246
      Meteor.users.update({ _id: this.userId,                                                                          // 247
        "loginIdentities.id": identityId,                                                                              // 248
        "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },    // 249
        $push: { nonloginIdentities: { id: identityId } } });                                                          // 251
    }                                                                                                                  // 252
  },                                                                                                                   // 253
                                                                                                                       //
  logoutIdentitiesOfCurrentAccount: function logoutIdentitiesOfCurrentAccount() {                                      // 255
    // Logs out all identities that are allowed to log in to the current account.                                      //
    var user = Meteor.user();                                                                                          // 257
    if (user && user.loginIdentities) {                                                                                // 258
      user.loginIdentities.forEach(function (identity) {                                                               // 259
        Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                    // 260
      });                                                                                                              // 261
    }                                                                                                                  // 262
  }                                                                                                                    // 263
});                                                                                                                    // 107
                                                                                                                       //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId) {                                       // 266
  // Links the identity to the account. If the account is a demo account, makes it durable and                         //
  // gives the identity login access to it.                                                                            //
  check(db, SandstormDb);                                                                                              // 269
  check(backend, SandstormBackend);                                                                                    // 270
  check(identityId, String);                                                                                           // 271
  check(accountId, String);                                                                                            // 272
  linkIdentityToAccountInternal(db, backend, identityId, accountId);                                                   // 273
};                                                                                                                     // 274
                                                                                                                       //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                           // 276
  check(identityId, String);                                                                                           // 277
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                              // 278
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var loginIdentities = {};                                                                                            // 281
                                                                                                                       //
  var _this = this;                                                                                                    // 283
  function addIdentitiesOfAccount(account) {                                                                           // 284
    account.loginIdentities.forEach(function (identity) {                                                              // 285
      if (!(identity.id in loginIdentities)) {                                                                         // 286
        var user = Meteor.users.findOne({ _id: identity.id });                                                         // 287
        if (user) {                                                                                                    // 288
          SandstormDb.fillInProfileDefaults(user);                                                                     // 289
          SandstormDb.fillInIntrinsicName(user);                                                                       // 290
          SandstormDb.fillInLoginId(user);                                                                             // 291
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                                // 292
          filteredUser.loginAccountId = account._id;                                                                   // 293
          filteredUser.sourceIdentityId = identityId;                                                                  // 294
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                      // 295
        }                                                                                                              // 296
                                                                                                                       //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function changed(id, fields) {                                                                      // 300
            _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                              // 301
          }                                                                                                            // 302
        });                                                                                                            // 299
      }                                                                                                                // 304
    });                                                                                                                // 305
  }                                                                                                                    // 306
                                                                                                                       //
  var cursor = Meteor.users.find({                                                                                     // 308
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                               // 309
  });                                                                                                                  // 308
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 315
    added: function added(account) {                                                                                   // 316
      addIdentitiesOfAccount(account);                                                                                 // 317
    },                                                                                                                 // 318
                                                                                                                       //
    changed: function changed(newAccount, oldAccount) {                                                                // 320
      addIdentitiesOfAccount(newAccount);                                                                              // 321
    },                                                                                                                 // 322
                                                                                                                       //
    removed: function removed(account) {                                                                               // 324
      account.loginIdentities.forEach(function (identity) {                                                            // 325
        if (identity.id in loginIdentities) {                                                                          // 326
          _this.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                               // 327
          loginIdentities[identity.id].stop();                                                                         // 328
          delete loginIdentities[identity.id];                                                                         // 329
        }                                                                                                              // 330
      });                                                                                                              // 331
    }                                                                                                                  // 332
  });                                                                                                                  // 315
  this.ready();                                                                                                        // 334
                                                                                                                       //
  this.onStop(function () {                                                                                            // 336
    handle.stop();                                                                                                     // 337
    Object.keys(loginIdentities).forEach(function (identityId) {                                                       // 338
      loginIdentities[identityId].stop();                                                                              // 339
      delete loginIdentities[identityId];                                                                              // 340
    });                                                                                                                // 341
  });                                                                                                                  // 342
});                                                                                                                    // 343
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"ldap":{"ldap-server.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/ldap/ldap-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});                               // 1
                                                                                                                       //
// Register login handler with Meteor                                                                                  //
Accounts.registerLoginHandler("ldap", function (loginRequest) {                                                        // 4
  // If 'ldap' isn't set in loginRequest object,                                                                       //
  // then this isn't the proper handler (return undefined)                                                             //
  if (!loginRequest.ldap) {                                                                                            // 7
    return undefined;                                                                                                  // 8
  }                                                                                                                    // 9
                                                                                                                       //
  if (!Accounts.identityServices.ldap.isEnabled()) {                                                                   // 11
    throw new Meteor.Error(403, "LDAP service is disabled.");                                                          // 12
  }                                                                                                                    // 13
                                                                                                                       //
  check(loginRequest, {                                                                                                // 15
    ldap: true,                                                                                                        // 16
    username: String,                                                                                                  // 17
    ldapPass: String                                                                                                   // 18
  });                                                                                                                  // 15
                                                                                                                       //
  // Instantiate LDAP                                                                                                  //
  var ldapObj = new LDAP();                                                                                            // 22
                                                                                                                       //
  // Call ldapCheck and get response                                                                                   //
  var ldapResponse = ldapObj.ldapCheck(this.connection.sandstormDb, loginRequest);                                     // 25
                                                                                                                       //
  if (ldapResponse.error) {                                                                                            // 27
    return {                                                                                                           // 28
      userId: null,                                                                                                    // 29
      error: ldapResponse.error                                                                                        // 30
    };                                                                                                                 // 28
  } else if (ldapResponse.emptySearch) {                                                                               // 32
    return {                                                                                                           // 33
      userId: null,                                                                                                    // 34
      error: new Meteor.Error(403, "User not found in LDAP")                                                           // 35
    };                                                                                                                 // 33
  } else {                                                                                                             // 37
    // Set initial userId and token vals                                                                               //
    return Accounts.updateOrCreateUserFromExternalService("ldap", { id: ldapResponse.dn, username: loginRequest.username,
      rawAttrs: ldapResponse.searchResults }, {});                                                                     // 41
  }                                                                                                                    // 42
});                                                                                                                    // 44
                                                                                                                       //
Meteor.methods({                                                                                                       // 46
  updateQuota: function updateQuota() {                                                                                // 47
    return this.connection.sandstormDb.updateUserQuota(Meteor.user());                                                 // 48
    // This is a no-op if settings aren't enabled                                                                      //
  }                                                                                                                    // 50
});                                                                                                                    // 46
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"saml":{"saml-server.js":["url","/imports/server/accounts/saml-utils.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/saml/saml-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Url;module.import("url",{"default":function(v){Url=v}});var SAML;module.import("/imports/server/accounts/saml-utils.js",{"SAML":function(v){SAML=v}});
                                                                                                                       // 2
                                                                                                                       //
var Fiber = Npm.require("fibers");                                                                                     // 4
                                                                                                                       //
if (!Accounts.saml) {                                                                                                  // 6
  Accounts.saml = {};                                                                                                  // 7
}                                                                                                                      // 8
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 12
                                                                                                                       //
RoutePolicy.declare("/_saml/", "network");                                                                             // 14
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 16
                                                                                                                       //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                            //
//   replicated (but currently Sandstorm for Work is not replicated).                                                  //
var _loginResultForCredentialToken = {};                                                                               // 20
                                                                                                                       //
var retrieveCredential = function retrieveCredential(credentialToken) {                                                // 22
  var result = _loginResultForCredentialToken[credentialToken];                                                        // 23
  delete _loginResultForCredentialToken[credentialToken];                                                              // 24
  return result;                                                                                                       // 25
};                                                                                                                     // 26
                                                                                                                       //
Accounts.registerLoginHandler(function (loginRequest) {                                                                // 28
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                           // 29
    return undefined;                                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                   // 33
    throw new Meteor.Error(403, "SAML service is disabled.");                                                          // 34
  }                                                                                                                    // 35
                                                                                                                       //
  var loginResult = retrieveCredential(loginRequest.credentialToken);                                                  // 37
  if (!loginResult) {                                                                                                  // 38
    throw new Meteor.Error(500, "SAML login did not complete.");                                                       // 39
  } else if (loginResult.profile && loginResult.profile.email) {                                                       // 40
    var user = _.pick(loginResult.profile, "displayName", "email");                                                    // 41
    user.id = loginResult.profile.nameID;                                                                              // 42
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                           // 43
  } else {                                                                                                             // 44
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                      // 45
  }                                                                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
var samlUrlToObject = function samlUrlToObject(url) {                                                                  // 49
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                                //
  if (!url) return null;                                                                                               // 51
                                                                                                                       //
  var splitPath = url.split("/");                                                                                      // 54
                                                                                                                       //
  // Any non-saml request will continue down the default                                                               //
  // middlewares.                                                                                                      //
  if (splitPath[1] !== "_saml") return null;                                                                           // 58
                                                                                                                       //
  return {                                                                                                             // 61
    actionName: splitPath[2],                                                                                          // 62
    serviceName: splitPath[3],                                                                                         // 63
    credentialToken: splitPath[4]                                                                                      // 64
  };                                                                                                                   // 61
};                                                                                                                     // 66
                                                                                                                       //
var closePopup = function closePopup(res, err) {                                                                       // 68
  res.writeHead(200, { "Content-Type": "text/html" });                                                                 // 69
  var content = "<html><head><script>window.close()</script></head></html>";                                           // 70
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a></body></html>';
  res.end(content, "utf-8");                                                                                           // 74
};                                                                                                                     // 75
                                                                                                                       //
var generateService = function generateService() {                                                                     // 77
  var entityId = SandstormDb.prototype.getSamlEntityId();                                                              // 78
  var service = {                                                                                                      // 79
    "provider": "default",                                                                                             // 80
    "entryPoint": SandstormDb.prototype.getSamlEntryPoint(),                                                           // 81
    // TODO(someday): find a better way to inject the DB                                                               //
    "issuer": entityId || HOSTNAME,                                                                                    // 83
    "cert": SandstormDb.prototype.getSamlPublicCert()                                                                  // 84
  };                                                                                                                   // 79
  return service;                                                                                                      // 86
};                                                                                                                     // 87
                                                                                                                       //
var middleware = function middleware(req, res, next) {                                                                 // 89
  // Make sure to catch any exceptions because otherwise we'd crash                                                    //
  // the runner                                                                                                        //
  try {                                                                                                                // 92
    var samlObject = samlUrlToObject(req.url);                                                                         // 93
    if (!samlObject || !samlObject.serviceName) {                                                                      // 94
      next();                                                                                                          // 95
      return;                                                                                                          // 96
    }                                                                                                                  // 97
                                                                                                                       //
    if (samlObject.actionName === "config") {                                                                          // 99
      var _saml = new SAML(generateService());                                                                         // 100
      res.writeHead(200, { "Content-Type": "text/xml" });                                                              // 101
      res.end(_saml.generateServiceProviderMetadata());                                                                // 102
      return;                                                                                                          // 103
    }                                                                                                                  // 104
                                                                                                                       //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                                 // 106
      next();                                                                                                          // 107
      return;                                                                                                          // 108
    }                                                                                                                  // 109
                                                                                                                       //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                                // 111
                                                                                                                       //
    var service = generateService();                                                                                   // 114
                                                                                                                       //
    // Skip everything if there's no service set by the saml middleware                                                //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                       //
    if (samlObject.actionName === "authorize") {                                                                       // 120
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                                  // 121
      service.id = samlObject.credentialToken;                                                                         // 122
      var _saml2 = new SAML(service);                                                                                  // 123
      _saml2.getAuthorizeUrl(req, function (err, url) {                                                                // 124
        if (err) throw new Error("Unable to generate authorize url");                                                  // 125
        res.writeHead(302, { "Location": url });                                                                       // 127
        res.end();                                                                                                     // 128
      });                                                                                                              // 129
    } else if (samlObject.actionName === "validate") {                                                                 // 130
      var _saml3 = new SAML(service);                                                                                  // 131
      _saml3.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut) {                              // 132
        if (err) {                                                                                                     // 133
          console.error("Error validating SAML response", err.toString());                                             // 134
          throw new Error("Unable to validate response url");                                                          // 135
        }                                                                                                              // 136
                                                                                                                       //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                     //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                          // 139
        if (!credentialToken) {                                                                                        // 140
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                              // 145
                                                                                                                       //
        _loginResultForCredentialToken[credentialToken] = {                                                            // 147
          profile: profile                                                                                             // 148
        };                                                                                                             // 147
                                                                                                                       //
        closePopup(res);                                                                                               // 151
      });                                                                                                              // 152
    } else {                                                                                                           // 153
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                              // 154
    }                                                                                                                  // 155
  } catch (err) {                                                                                                      // 156
    closePopup(res, err);                                                                                              // 157
  }                                                                                                                    // 158
};                                                                                                                     // 159
                                                                                                                       //
// Listen to incoming OAuth http requests                                                                              //
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                       // 162
  // Need to create a Fiber since we're using synchronous http calls and nothing                                       //
  // else is wrapping this in a fiber automatically                                                                    //
  Fiber(function () {                                                                                                  // 165
    middleware(req, res, next);                                                                                        // 166
  }).run();                                                                                                            // 167
});                                                                                                                    // 168
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"accounts-server.js":["meteor/accounts-base","/imports/server/accounts/picture.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Accounts;module.import("meteor/accounts-base",{"Accounts":function(v){Accounts=v}});var fetchPicture,userPictureUrl;module.import("/imports/server/accounts/picture.js",{"fetchPicture":function(v){fetchPicture=v},"userPictureUrl":function(v){userPictureUrl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 20
var Future = Npm.require("fibers/future");                                                                             // 21
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 23
  check(handle, String);                                                                                               // 24
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 25
});                                                                                                                    // 26
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 28
  if (user.loginIdentities) {                                                                                          // 29
    // it's an account                                                                                                 //
    check(user, { _id: String,                                                                                         // 31
      createdAt: Date,                                                                                                 // 32
      isAdmin: Match.Optional(Boolean),                                                                                // 33
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 34
      signupKey: Match.Optional(String),                                                                               // 35
      signupNote: Match.Optional(String),                                                                              // 36
      signupEmail: Match.Optional(String),                                                                             // 37
      expires: Match.Optional(Date),                                                                                   // 38
      appDemoId: Match.Optional(String),                                                                               // 39
      loginIdentities: [{ id: String }],                                                                               // 40
      nonloginIdentities: [{ id: String }] });                                                                         // 41
                                                                                                                       //
    if (globalDb.isReferralEnabled()) {                                                                                // 43
      user.experiments = user.experiments || {};                                                                       // 44
      user.experiments = {                                                                                             // 45
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                               // 46
      };                                                                                                               // 45
      if (!("expires" in user)) {                                                                                      // 48
        globalDb.sendReferralProgramNotification(user._id);                                                            // 49
      }                                                                                                                // 50
    }                                                                                                                  // 51
                                                                                                                       //
    globalDb.preinstallAppsForUser(user._id);                                                                          // 53
                                                                                                                       //
    return user;                                                                                                       // 55
  }                                                                                                                    // 56
                                                                                                                       //
  if (globalDb.getOrganizationDisallowGuests() && !globalDb.isIdentityInOrganization(user)) {                          // 58
    throw new Meteor.Error(400, "User not in organization.");                                                          // 60
  }                                                                                                                    // 61
                                                                                                                       //
  // Check profile.                                                                                                    //
  if (options.profile) {                                                                                               // 64
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               //
    check(options.profile, Match.ObjectIncluding({                                                                     // 66
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 67
      handle: Match.Optional(ValidHandle),                                                                             // 68
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 69
    }));                                                                                                               // 66
  }                                                                                                                    // 71
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 73
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 75
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 76
  }                                                                                                                    // 77
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                          // 79
                                                                                                                       //
  // Try downloading avatar.                                                                                           //
  var url = userPictureUrl(user);                                                                                      // 82
  if (url) {                                                                                                           // 83
    var assetId = fetchPicture(globalDb, url);                                                                         // 84
    if (assetId) {                                                                                                     // 85
      user.profile.picture = assetId;                                                                                  // 86
    }                                                                                                                  // 87
  }                                                                                                                    // 88
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 90
  if (user.services && user.services.dev) {                                                                            // 91
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 92
    serviceUserId = user.services.dev.name;                                                                            // 93
    user.profile.service = "dev";                                                                                      // 94
  } else if ("expires" in user) {                                                                                      // 95
    serviceUserId = user._id;                                                                                          // 96
    user.profile.service = "demo";                                                                                     // 97
  } else if (user.services && user.services.email) {                                                                   // 98
    check(user.services.email, {                                                                                       // 99
      email: String,                                                                                                   // 100
      tokens: [{                                                                                                       // 101
        digest: String,                                                                                                // 103
        algorithm: String,                                                                                             // 104
        createdAt: Date,                                                                                               // 105
        secureBox: Match.Optional({                                                                                    // 106
          version: Number,                                                                                             // 107
          salt: String,                                                                                                // 108
          iv: String,                                                                                                  // 109
          boxedValue: String                                                                                           // 110
        })                                                                                                             // 106
      }]                                                                                                               // 102
    });                                                                                                                // 99
    serviceUserId = user.services.email.email;                                                                         // 115
    user.profile.service = "email";                                                                                    // 116
  } else if (user.services && "google" in user.services) {                                                             // 117
    serviceUserId = user.services.google.id;                                                                           // 118
    user.profile.service = "google";                                                                                   // 119
  } else if (user.services && "github" in user.services) {                                                             // 120
    serviceUserId = user.services.github.id;                                                                           // 121
    user.profile.service = "github";                                                                                   // 122
  } else if (user.services && "ldap" in user.services) {                                                               // 123
    serviceUserId = user.services.ldap.id;                                                                             // 124
    user.profile.service = "ldap";                                                                                     // 125
  } else if (user.services && "saml" in user.services) {                                                               // 126
    serviceUserId = user.services.saml.id;                                                                             // 127
    user.profile.service = "saml";                                                                                     // 128
  } else {                                                                                                             // 129
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 130
  }                                                                                                                    // 132
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 134
                                                                                                                       //
  return user;                                                                                                         // 137
});                                                                                                                    // 138
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 140
  if (!attempt.allowed) {                                                                                              // 141
    return false;                                                                                                      // 142
  }                                                                                                                    // 143
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 145
  var user = attempt.user;                                                                                             // 146
  if (user.loginIdentities) {                                                                                          // 147
    // it's an account                                                                                                 //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 149
      throw new Meteor.Error(403, "User not in organization.");                                                        // 151
    }                                                                                                                  // 152
                                                                                                                       //
    db.updateUserQuota(user); // This is a no-op if settings aren't enabled                                            // 154
  } else {                                                                                                             // 155
      if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                  // 156
        throw new Meteor.Error(403, "User not in organization.");                                                      // 158
      }                                                                                                                // 159
    }                                                                                                                  // 160
                                                                                                                       //
  return true;                                                                                                         // 162
});                                                                                                                    // 163
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         //
// client for prediction purposes, on the server for actual execution).                                                //
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function updateProfile(identityId, profile) {                                                         // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                                //
    check(identityId, String);                                                                                         // 28
                                                                                                                       //
    check(profile, {                                                                                                   // 30
      name: String,                                                                                                    // 31
      handle: ValidHandle,                                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                      // 33
      unverifiedEmail: Match.Optional(String)                                                                          // 34
    });                                                                                                                // 30
                                                                                                                       //
    if (!this.userId) {                                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                                    // 38
    }                                                                                                                  // 39
                                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                      // 41
                                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                 // 43
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                            // 45
    }                                                                                                                  // 46
                                                                                                                       //
    var newValues = {                                                                                                  // 48
      "profile.name": profile.name,                                                                                    // 49
      "profile.handle": profile.handle,                                                                                // 50
      "profile.pronoun": profile.pronoun                                                                               // 51
    };                                                                                                                 // 48
                                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                               // 54
                                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                               // 57
    }                                                                                                                  // 58
  },                                                                                                                   // 59
                                                                                                                       //
  testFirstSignup: function testFirstSignup(profile) {                                                                 // 61
    if (!this.userId) {                                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                                    // 63
    }                                                                                                                  // 64
                                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                          // 66
  },                                                                                                                   // 67
                                                                                                                       //
  uploadProfilePicture: function uploadProfilePicture(identityId) {                                                    // 69
    check(identityId, String);                                                                                         // 70
    if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                       // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 72
    }                                                                                                                  // 73
                                                                                                                       //
    return this.connection.sandstormDb.newAssetUpload({                                                                // 75
      profilePicture: { userId: this.userId, identityId: identityId }                                                  // 76
    });                                                                                                                // 75
  },                                                                                                                   // 78
                                                                                                                       //
  cancelUploadProfilePicture: function cancelUploadProfilePicture(id) {                                                // 80
    check(id, String);                                                                                                 // 81
    this.connection.sandstormDb.fulfillAssetUpload(id);                                                                // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setPrimaryEmail: function setPrimaryEmail(email) {                                                                   // 85
    check(email, String);                                                                                              // 86
    if (!this.userId) {                                                                                                // 87
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 88
    }                                                                                                                  // 89
                                                                                                                       //
    var emails = SandstormDb.getUserEmails(Meteor.user());                                                             // 91
    if (!_.findWhere(emails, { email: email, verified: true })) {                                                      // 92
      throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                               // 93
    }                                                                                                                  // 94
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                      // 96
  }                                                                                                                    // 97
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       //
Meteor.users.deny({                                                                                                    // 18
  insert: function insert() {                                                                                          // 19
    return true;                                                                                                       // 19
  },                                                                                                                   // 19
                                                                                                                       //
  update: function update() {                                                                                          // 21
    return true;                                                                                                       // 21
  },                                                                                                                   // 21
                                                                                                                       //
  remove: function remove() {                                                                                          // 23
    return true;                                                                                                       // 23
  },                                                                                                                   // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              //
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 15
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 19
    checkAuth(undefined);                                                                                              // 20
    check(params, personalizationMessageShape);                                                                        // 21
    var db = this.connection.sandstormDb;                                                                              // 22
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 24
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 25
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 26
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 27
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 28
                                                                                                                       //
    db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
    db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
    db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
    db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
  },                                                                                                                   // 38
  getWhitelabelLogoUploadToken: function getWhitelabelLogoUploadToken() {                                              // 40
    checkAuth(undefined);                                                                                              // 41
    var db = this.connection.sandstormDb;                                                                              // 42
    return db.newAssetUpload({ loginLogo: {} });                                                                       // 43
  },                                                                                                                   // 44
  resetWhitelabelLogo: function resetWhitelabelLogo() {                                                                // 46
    checkAuth(undefined);                                                                                              // 47
    var db = this.connection.sandstormDb;                                                                              // 48
    var result = globalDb.collections.settings.findAndModify({                                                         // 49
      query: { _id: "whitelabelCustomLogoAssetId" },                                                                   // 50
      remove: true,                                                                                                    // 51
      fields: { value: 1 }                                                                                             // 52
    });                                                                                                                // 49
                                                                                                                       //
    if (result.ok) {                                                                                                   // 55
      var old = result.value;                                                                                          // 56
      if (old) {                                                                                                       // 57
        db.unrefStaticAsset(old.value);                                                                                // 58
      }                                                                                                                // 59
    } else {                                                                                                           // 60
      throw new Meteor.Error(500, "Couldn't remove whitelabelCustomLogoAssetId");                                      // 61
    }                                                                                                                  // 62
  }                                                                                                                    // 63
});                                                                                                                    // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 9
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 10
};                                                                                                                     // 11
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 15
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 16
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken() {                                          // 19
    var db = this.connection.sandstormDb;                                                                              // 20
    if (!db.isAdminById(this.userId)) {                                                                                // 21
      throw new Meteor.Error(403, "User must be admin to download system log.");                                       // 22
    }                                                                                                                  // 23
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 25
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 26
    setTimeout(function () {                                                                                           // 27
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 28
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 29
      }                                                                                                                // 30
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 31
    return token;                                                                                                      // 32
  }                                                                                                                    // 33
});                                                                                                                    // 18
                                                                                                                       //
Router.map(function () {                                                                                               // 36
  this.route("adminDownloadServerLog", {                                                                               // 37
    where: "server",                                                                                                   // 38
    path: "/admin/status/server-log/:tokenId",                                                                         // 39
    action: function action() {                                                                                        // 40
      var token = this.params.tokenId;                                                                                 // 41
      var response = this.response;                                                                                    // 42
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 43
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 44
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 45
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 49
        return response.end("Invalid server log download token.");                                                     // 50
      }                                                                                                                // 51
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 53
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 54
      var stats = Fs.fstatSync(fd);                                                                                    // 55
      var initialSize = stats.size;                                                                                    // 56
      var readStream = Fs.createReadStream(undefined, {                                                                // 57
        fd: fd,                                                                                                        // 58
        start: 0,                                                                                                      // 59
        end: initialSize                                                                                               // 60
      });                                                                                                              // 57
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 63
        "Content-Length": initialSize,                                                                                 // 64
        "Content-Type": "text/plain",                                                                                  // 65
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 66
      });                                                                                                              // 63
      readStream.pipe(response);                                                                                       // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 37
});                                                                                                                    // 71
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 73
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 76
  if (!db.isAdminById(this.userId)) {                                                                                  // 77
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 78
  }                                                                                                                    // 79
                                                                                                                       //
  var _this = this;                                                                                                    // 81
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 82
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 83
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 85
  var grainIdCount = 0;                                                                                                // 86
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 88
    activeUsers: userIdCount,                                                                                          // 89
    activeGrains: grainIdCount                                                                                         // 90
  });                                                                                                                  // 88
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 93
  var handle = query.observe({                                                                                         // 94
    added: function added(session) {                                                                                   // 95
      var hashedSessionId = hashSessionId(session._id);                                                                // 96
      var changed = {};                                                                                                // 97
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 100
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 101
          userIdToSessionHashes[session.userId] = [];                                                                  // 102
          userIdCount = userIdCount + 1;                                                                               // 103
          changed.activeUsers = userIdCount;                                                                           // 104
        }                                                                                                              // 105
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 107
      }                                                                                                                // 109
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 112
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 113
        grainIdCount = grainIdCount + 1;                                                                               // 114
        changed.activeGrains = grainIdCount;                                                                           // 115
      }                                                                                                                // 116
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 118
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 121
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 122
      }                                                                                                                // 123
    },                                                                                                                 // 124
    removed: function removed(session) {                                                                               // 126
      var hashedSessionId = hashSessionId(session._id);                                                                // 127
      var changed = {};                                                                                                // 128
                                                                                                                       //
      if (session.userId) {                                                                                            // 130
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 131
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 134
          delete userIdToSessionHashes[session.userId];                                                                // 135
          userIdCount = userIdCount - 1;                                                                               // 136
          changed.activeUsers = userIdCount;                                                                           // 137
        }                                                                                                              // 138
      }                                                                                                                // 139
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 141
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 144
        delete grainIdToSessionHashes[session.grainId];                                                                // 145
        grainIdCount = grainIdCount - 1;                                                                               // 146
        changed.activeGrains = grainIdCount;                                                                           // 147
      }                                                                                                                // 148
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 150
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 151
      }                                                                                                                // 152
    }                                                                                                                  // 153
  });                                                                                                                  // 94
                                                                                                                       //
  this.onStop(function () {                                                                                            // 156
    handle.stop();                                                                                                     // 157
  });                                                                                                                  // 158
  this.ready();                                                                                                        // 159
});                                                                                                                    // 160
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 162
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 165
  if (!db.isAdminById(this.userId)) {                                                                                  // 166
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 167
  }                                                                                                                    // 168
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 170
    expires: {                                                                                                         // 171
      $gt: new Date()                                                                                                  // 172
    },                                                                                                                 // 171
    loginIdentities: {                                                                                                 // 174
      $exists: true                                                                                                    // 175
    }                                                                                                                  // 174
  }, {                                                                                                                 // 170
    expires: 1,                                                                                                        // 178
    loginIdentities: 1                                                                                                 // 179
  });                                                                                                                  // 177
});                                                                                                                    // 181
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
var Url = Npm.require("url");                                                                                          // 19
var Http = Npm.require("http");                                                                                        // 20
var Https = Npm.require("https");                                                                                      // 21
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 22
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 24
  function WrappedUiView(token, proxy) {                                                                               // 25
    _classCallCheck(this, WrappedUiView);                                                                              // 25
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 28
    this.proxy = proxy;                                                                                                // 29
  }                                                                                                                    // 30
                                                                                                                       //
  WrappedUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams, retryCount) {
    if (sessionType !== ApiSession.typeId) {                                                                           // 33
      throw new Error("SessionType must be ApiSession.");                                                              // 34
    }                                                                                                                  // 35
                                                                                                                       //
    retryCount = retryCount || 0;                                                                                      // 37
    var _this = this;                                                                                                  // 38
                                                                                                                       //
    return this.proxy.keepAlive().then(function () {                                                                   // 40
      // ignore the passed userInfo and instead use the one associated with this                                       //
      // token TODO(someday): Merge / intersect the two userInfo objects                                               //
      // (especially permissions) rather than only taking the token's user info.                                       //
      // This will allow the caller to request only a subset of the permissions                                        //
      // granted by the token, which is useful to protect against bugs.                                                //
      var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;  // 46
      return { session: session };                                                                                     // 48
    })["catch"](function (error) {                                                                                     // 49
      return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                    // 50
        return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                        // 51
      });                                                                                                              // 52
    });                                                                                                                // 53
  };                                                                                                                   // 54
                                                                                                                       //
  return WrappedUiView;                                                                                                // 24
}();                                                                                                                   // 24
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 57
  var proxyPromise = getProxyForApiToken(token);                                                                       // 58
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 60
    return { view: new WrappedUiView(token, proxy) };                                                                  // 61
  });                                                                                                                  // 62
};                                                                                                                     // 63
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 65
  function ExternalUiView(url, grainId, token) {                                                                       // 66
    _classCallCheck(this, ExternalUiView);                                                                             // 66
                                                                                                                       //
    this.url = url;                                                                                                    // 67
    this.grainId = grainId;                                                                                            // 68
    this.token = token;                                                                                                // 69
  }                                                                                                                    // 70
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 65
    if (sessionType !== ApiSession.typeId) {                                                                           // 73
      throw new Error("SessionType must be ApiSession.");                                                              // 74
    }                                                                                                                  // 75
                                                                                                                       //
    var options = {};                                                                                                  // 77
                                                                                                                       //
    if (this.token) {                                                                                                  // 79
      options.headers = {                                                                                              // 80
        authorization: "Bearer " + this.token                                                                          // 81
      };                                                                                                               // 80
    }                                                                                                                  // 83
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 85
  };                                                                                                                   // 86
                                                                                                                       //
  return ExternalUiView;                                                                                               // 65
}();                                                                                                                   // 65
                                                                                                                       //
var responseCodes = {                                                                                                  // 89
  200: { type: "content", code: "ok" },                                                                                // 90
  201: { type: "content", code: "created" },                                                                           // 91
  202: { type: "content", code: "accepted" },                                                                          // 92
  204: { type: "noContent", shouldResetForm: false },                                                                  // 93
  205: { type: "noContent", shouldResetForm: true },                                                                   // 94
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 99
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 100
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 106
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 107
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 108
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 109
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 110
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 111
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 112
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 113
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 114
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 116
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 117
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 118
  500: { type: "serverError" },                                                                                        // 119
  501: { type: "serverError" },                                                                                        // 120
  502: { type: "serverError" },                                                                                        // 121
  503: { type: "serverError" },                                                                                        // 122
  504: { type: "serverError" },                                                                                        // 123
  505: { type: "serverError" }                                                                                         // 124
};                                                                                                                     // 89
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 127
  function ExternalWebSession(url, grainId, options) {                                                                 // 128
    _classCallCheck(this, ExternalWebSession);                                                                         // 128
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 129
    this.host = parsedUrl.hostname;                                                                                    // 130
    this.port = parsedUrl.port;                                                                                        // 131
    this.protocol = parsedUrl.protocol;                                                                                // 132
    this.grainId = grainId;                                                                                            // 133
    this.options = options || {};                                                                                      // 134
  }                                                                                                                    // 135
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 127
    return this._requestHelper("GET", path, context);                                                                  // 138
  };                                                                                                                   // 139
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 127
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 142
  };                                                                                                                   // 143
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 127
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 146
  };                                                                                                                   // 147
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 127
    return this._requestHelper("DELETE", path, context);                                                               // 150
  };                                                                                                                   // 151
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 164
    var session = _this;                                                                                               // 165
    return new Promise(function (resolve, reject) {                                                                    // 166
      var options = _.clone(session.options);                                                                          // 167
      options.headers = options.headers || {};                                                                         // 168
      options.path = path;                                                                                             // 169
      options.method = method;                                                                                         // 170
      if (contentType) {                                                                                               // 171
        options.headers["content-type"] = contentType;                                                                 // 172
      }                                                                                                                // 173
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 176
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 177
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 178
        }).join(", ");                                                                                                 // 179
      } else if (!("accept" in options.headers)) {                                                                     // 180
        options.headers.accept = "*/*";                                                                                // 181
      }                                                                                                                // 182
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 185
        options.headers.cookies = options.headers.cookies || "";                                                       // 186
        context.cookies.forEach(function (keyVal) {                                                                    // 187
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 188
        });                                                                                                            // 189
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 190
      }                                                                                                                // 191
                                                                                                                       //
      options.host = session.host;                                                                                     // 193
      options.port = session.port;                                                                                     // 194
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 196
      if (session.protocol === "https:") {                                                                             // 197
        requestMethod = Https.request;                                                                                 // 198
      }                                                                                                                // 199
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 201
        var buffers = [];                                                                                              // 202
        var statusInfo = responseCodes[resp.statusCode];                                                               // 203
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 205
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 207
          case "content":                                                                                              // 208
            resp.on("data", function (buf) {                                                                           // 209
              buffers.push(buf);                                                                                       // 210
            });                                                                                                        // 211
                                                                                                                       //
            resp.on("end", function () {                                                                               // 213
              var content = {};                                                                                        // 214
              rpcResponse.content = content;                                                                           // 215
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 217
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 218
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 219
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 220
              if ("content-disposition" in resp.headers) {                                                             // 221
                var disposition = resp.headers["content-disposition"];                                                 // 222
                var parts = disposition.split(";");                                                                    // 223
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 224
                  parts.forEach(function (part) {                                                                      // 225
                    var splitPart = part.split("=");                                                                   // 226
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 227
                      content.disposition = { download: splitPart[1].trim() };                                         // 228
                    }                                                                                                  // 229
                  });                                                                                                  // 230
                }                                                                                                      // 231
              }                                                                                                        // 232
                                                                                                                       //
              content.body = {};                                                                                       // 234
              content.body.bytes = Buffer.concat(buffers);                                                             // 235
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 237
            });                                                                                                        // 238
            break;                                                                                                     // 239
          case "noContent":                                                                                            // 240
            var noContent = {};                                                                                        // 241
            rpcResponse.noContent = noContent;                                                                         // 242
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 243
            resolve(rpcResponse);                                                                                      // 244
            break;                                                                                                     // 245
          case "redirect":                                                                                             // 246
            var redirect = {};                                                                                         // 247
            rpcResponse.redirect = redirect;                                                                           // 248
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 249
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 250
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 251
            resolve(rpcResponse);                                                                                      // 252
            break;                                                                                                     // 253
          case "clientError":                                                                                          // 254
            var clientError = {};                                                                                      // 255
            rpcResponse.clientError = clientError;                                                                     // 256
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 257
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 258
            resolve(rpcResponse);                                                                                      // 259
            break;                                                                                                     // 260
          case "serverError":                                                                                          // 261
            var serverError = {};                                                                                      // 262
            rpcResponse.serverError = serverError;                                                                     // 263
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 264
            resolve(rpcResponse);                                                                                      // 265
            break;                                                                                                     // 266
          default:                                                                                                     // 267
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 268
            reject(err);                                                                                               // 269
            break;                                                                                                     // 270
        }                                                                                                              // 207
      });                                                                                                              // 272
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 274
        reject(e);                                                                                                     // 275
      });                                                                                                              // 276
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 278
        req.abort();                                                                                                   // 279
        err = new Error("Request timed out.");                                                                         // 280
        err.kjType = "overloaded";                                                                                     // 281
        reject(err);                                                                                                   // 282
      });                                                                                                              // 283
                                                                                                                       //
      if (content) {                                                                                                   // 285
        req.end(content);                                                                                              // 286
      } else {                                                                                                         // 287
        req.end();                                                                                                     // 288
      }                                                                                                                // 289
    });                                                                                                                // 290
  };                                                                                                                   // 291
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 127
}();                                                                                                                   // 127
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 24
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 26
  function ByteStreamConnection(connection) {                                                                          // 27
    _classCallCheck(this, ByteStreamConnection);                                                                       // 27
                                                                                                                       //
    this.connection = connection;                                                                                      // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 26
    this.connection.end();                                                                                             // 32
  };                                                                                                                   // 33
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 26
    this.connection.write(data);                                                                                       // 36
  };                                                                                                                   // 37
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 26
}();                                                                                                                   // 26
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 44
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 44
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 44
  }                                                                                                                    // 46
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 49
      var resolved = false;                                                                                            // 50
      var server = Net.createServer(function (connection) {                                                            // 51
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 52
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 53
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 55
          upstream.write(data);                                                                                        // 56
        });                                                                                                            // 57
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 59
          upstream.done();                                                                                             // 60
        });                                                                                                            // 61
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 63
          if (resolved) {                                                                                              // 64
            connection.write = errorWrite;                                                                             // 65
          } else {                                                                                                     // 66
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 68
          }                                                                                                            // 69
        });                                                                                                            // 70
      });                                                                                                              // 71
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 73
        resolved = true;                                                                                               // 74
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 75
      });                                                                                                              // 76
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 78
        if (!resolved) {                                                                                               // 79
          reject(err);                                                                                                 // 80
        }                                                                                                              // 81
      });                                                                                                              // 82
    });                                                                                                                // 83
  };                                                                                                                   // 84
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 87
      var portMap = {};                                                                                                // 88
      var resolved = false;                                                                                            // 89
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 90
      server.bind(portNum);                                                                                            // 91
                                                                                                                       //
      server.on("listening", function () {                                                                             // 93
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 96
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 97
      });                                                                                                              // 98
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 100
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 102
          reject(err);                                                                                                 // 103
        } else {                                                                                                       // 104
          console.error("error in listenUdp: " + err);                                                                 // 105
        }                                                                                                              // 106
      });                                                                                                              // 107
                                                                                                                       //
      var returnMap = {};                                                                                              // 109
      server.on("message", function (msg, rinfo) {                                                                     // 110
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 111
        var returnPort = returnMap[address];                                                                           // 112
                                                                                                                       //
        if (!returnPort) {                                                                                             // 114
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 115
        }                                                                                                              // 116
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 118
      });                                                                                                              // 119
    });                                                                                                                // 120
  };                                                                                                                   // 121
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 122
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 126
  globalFrontendRefRegistry.register({                                                                                 // 127
    frontendRefField: "ipInterface",                                                                                   // 128
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 129
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 131
      return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);                 // 132
    },                                                                                                                 // 134
    validate: function validate(db, session, value) {                                                                  // 136
      check(value, true);                                                                                              // 137
                                                                                                                       //
      if (!session.userId) {                                                                                           // 139
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 140
      }                                                                                                                // 141
                                                                                                                       //
      return {                                                                                                         // 143
        descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                      // 144
        requirements: [{ userIsAdmin: session.userId }]                                                                // 145
      };                                                                                                               // 143
    },                                                                                                                 // 147
    query: function query(db, userId, value) {                                                                         // 149
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 150
        return [{                                                                                                      // 151
          _id: "frontendref-ipinterface",                                                                              // 153
          frontendRef: { ipInterface: true },                                                                          // 154
          cardTemplate: "ipInterfacePowerboxCard"                                                                      // 155
        }];                                                                                                            // 152
      } else {                                                                                                         // 158
        return [];                                                                                                     // 159
      }                                                                                                                // 160
    }                                                                                                                  // 161
  });                                                                                                                  // 127
});                                                                                                                    // 163
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 165
  function BoundUdpPortImpl(server, address, port) {                                                                   // 166
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 166
                                                                                                                       //
    this.server = server;                                                                                              // 167
    this.address = address;                                                                                            // 168
    this.port = port;                                                                                                  // 169
  }                                                                                                                    // 170
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 165
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 176
  };                                                                                                                   // 177
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 165
}();                                                                                                                   // 165
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 180
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 181
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 183
  var part1 = num & 255;                                                                                               // 184
  var part2 = num >> 8 & 255;                                                                                          // 185
  var part3 = num >> 16 & 255;                                                                                         // 186
  var part4 = num >> 24 & 255;                                                                                         // 187
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 189
};                                                                                                                     // 190
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 192
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 193
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 195
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 197
    return intToIpv4(ipv4num);                                                                                         // 198
  }                                                                                                                    // 199
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 201
  var numColons = 0;                                                                                                   // 202
  var out = "";                                                                                                        // 203
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 205
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 208
    if ((i + 1) % 4 === 0) {                                                                                           // 209
      out += ":";                                                                                                      // 210
      ++numColons;                                                                                                     // 211
    }                                                                                                                  // 212
  }                                                                                                                    // 213
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 216
    out += "::";                                                                                                       // 217
  }                                                                                                                    // 218
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 220
};                                                                                                                     // 221
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 223
  var type = "udp4";                                                                                                   // 224
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 228
    type = "udp6";                                                                                                     // 229
  }                                                                                                                    // 230
                                                                                                                       //
  return type;                                                                                                         // 232
};                                                                                                                     // 233
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate) {                                                                           // 236
    _classCallCheck(this, IpNetworkImpl);                                                                              // 236
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 236
  }                                                                                                                    // 238
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 241
  };                                                                                                                   // 242
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 245
  };                                                                                                                   // 246
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 247
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 251
  globalFrontendRefRegistry.register({                                                                                 // 252
    frontendRefField: "ipNetwork",                                                                                     // 253
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 254
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 256
      return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate), IpRpc.PersistentIpNetwork);                     // 257
    },                                                                                                                 // 259
    validate: function validate(db, session, value) {                                                                  // 261
      check(value, true);                                                                                              // 262
                                                                                                                       //
      if (!session.userId) {                                                                                           // 264
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 265
      }                                                                                                                // 266
                                                                                                                       //
      return {                                                                                                         // 268
        descriptor: { tags: [{ id: IpRpc.IpNetwork.typeId }] },                                                        // 269
        requirements: [{ userIsAdmin: session.userId }]                                                                // 270
      };                                                                                                               // 268
    },                                                                                                                 // 272
    query: function query(db, userId, value) {                                                                         // 274
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 275
        return [{                                                                                                      // 276
          _id: "frontendref-ipnetwork",                                                                                // 278
          frontendRef: { ipNetwork: true },                                                                            // 279
          cardTemplate: "ipNetworkPowerboxCard"                                                                        // 280
        }];                                                                                                            // 277
      } else {                                                                                                         // 283
        return [];                                                                                                     // 284
      }                                                                                                                // 285
    }                                                                                                                  // 286
  });                                                                                                                  // 252
});                                                                                                                    // 288
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 290
  function IpRemoteHostImpl(address) {                                                                                 // 291
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 291
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 292
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 294
    } else {                                                                                                           // 295
      this.address = address;                                                                                          // 296
    }                                                                                                                  // 297
  }                                                                                                                    // 298
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 290
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 301
  };                                                                                                                   // 302
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 290
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 305
  };                                                                                                                   // 306
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 290
}();                                                                                                                   // 290
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 309
  function TcpPortImpl(address, portNum) {                                                                             // 310
    _classCallCheck(this, TcpPortImpl);                                                                                // 310
                                                                                                                       //
    this.address = address;                                                                                            // 311
    this.port = portNum;                                                                                               // 312
  }                                                                                                                    // 313
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 309
    var _this = this;                                                                                                  // 316
    var resolved = false;                                                                                              // 317
    return new Promise(function (resolve, reject) {                                                                    // 318
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 319
        resolved = true;                                                                                               // 320
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 321
      });                                                                                                              // 322
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 324
        downstream.write(data);                                                                                        // 325
      });                                                                                                              // 326
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 328
        downstream.done();                                                                                             // 329
      });                                                                                                              // 330
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 332
        if (resolved) {                                                                                                // 333
          client.write = errorWrite;                                                                                   // 334
        } else {                                                                                                       // 335
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 337
        }                                                                                                              // 338
      });                                                                                                              // 339
    });                                                                                                                // 340
  };                                                                                                                   // 341
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 309
}();                                                                                                                   // 309
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 344
  throw new Error("error occurred in connection");                                                                     // 345
};                                                                                                                     // 346
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 348
  function UdpPortImpl(address, portNum) {                                                                             // 349
    _classCallCheck(this, UdpPortImpl);                                                                                // 349
                                                                                                                       //
    this.address = address;                                                                                            // 350
    this.port = portNum;                                                                                               // 351
                                                                                                                       //
    var type = addressType(address);                                                                                   // 353
    this.socket = Dgram.createSocket(type);                                                                            // 354
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 362
                                                                                                                       //
    var _this = this;                                                                                                  // 364
    this.socket.on("message", function (msg, rinfo) {                                                                  // 365
      if (_this.returnPort) {                                                                                          // 366
        _this.returnPort.send(msg, _this);                                                                             // 367
      }                                                                                                                // 368
    });                                                                                                                // 369
  }                                                                                                                    // 370
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 348
    this.returnPort = returnPort;                                                                                      // 373
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 374
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 377
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 348
}();                                                                                                                   // 348
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","smtp-server","mailparser","/imports/server/persistent.js","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var SMTPServer;module.import("smtp-server",{"SMTPServer":function(v){SMTPServer=v}});var MailParser;module.import("mailparser",{"MailParser":function(v){MailParser=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var rawSend;module.import("/imports/server/email.js",{"rawSend":function(v){rawSend=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 27
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 28
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 29
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 33
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 35
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 36
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 38
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 40
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 46
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 47
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 51
}                                                                                                                      // 52
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 54
  var server = new SMTPServer({                                                                                        // 55
    banner: "Sandstorm Mail Server",                                                                                   // 56
    authOptional: true,                                                                                                // 57
    disabledCommands: ["STARTTLS", "AUTH"],                                                                            // 58
    onData: function onData(req, session, callback) {                                                                  // 59
      var mailparser = new MailParser();                                                                               // 60
      req.pipe(mailparser);                                                                                            // 61
                                                                                                                       //
      mailparser.on("end", function (mail) {                                                                           // 63
        // Wrap in outer promise for easier error handling.                                                            //
        Promise.resolve().then(function () {                                                                           // 65
          // Extract the 'from' address.                                                                               //
          var from = void 0;                                                                                           // 67
          if (mail.from && mail.from.length > 0) {                                                                     // 68
            // It's theoretically possible for the message to have multiple 'from' headers, but this                   //
            // never really happens in legitimate practice so we'll just take the first one.                           //
            from = mail.from[0];                                                                                       // 71
          } else {                                                                                                     // 72
            // The mail body is missing a 'From:' header. We'll use the bounce address instead,                        //
            // with the caveat that this is sometimes *not* the original sender                                        //
            // but rather some intermediate agent (e.g. a mailing list daemon). See:                                   //
            //   http://en.wikipedia.org/wiki/Bounce_address                                                           //
            // TODO(someday): Is this really right, or should we report a blank address instead?                       //
            from = { address: session.envelope.mailFrom, name: false };                                                // 78
          }                                                                                                            // 79
                                                                                                                       //
          var attachments = [];                                                                                        // 81
          if (mail.attachments) {                                                                                      // 82
            attachments = mail.attachments.map(function (attachment) {                                                 // 83
              var disposition = attachment.contentDisposition || "attachment";                                         // 84
              disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';          // 85
              return {                                                                                                 // 86
                contentType: attachment.contentType,                                                                   // 87
                contentDisposition: disposition,                                                                       // 88
                contentId: attachment.contentId,                                                                       // 89
                content: attachment.content                                                                            // 90
              };                                                                                                       // 86
            });                                                                                                        // 92
          }                                                                                                            // 93
                                                                                                                       //
          if (mail.replyTo && mail.replyTo.length > 1) {                                                               // 95
            console.error("More than one reply-to address address was received in an email.");                         // 96
          }                                                                                                            // 97
                                                                                                                       //
          var mailMessage = {                                                                                          // 99
            // Note that converting the date to nanoseconds actually goes outside the range of                         //
            // integers that Javascript can represent precisely. But this is OK because dates aren't                   //
            // precise anyway.                                                                                         //
            date: (mail.date || new Date()).getTime() * 1000000,                                                       // 103
            from: from,                                                                                                // 104
            to: mail.to,                                                                                               // 105
            cc: mail.cc || [],                                                                                         // 106
            bcc: mail.bcc || [],                                                                                       // 107
            replyTo: mail.replyTo && mail.replyTo[0] || {},                                                            // 108
            messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                   // 109
            references: mail.references || [],                                                                         // 110
            inReplyTo: mail.inReplyTo || [],                                                                           // 111
            subject: mail.subject || "",                                                                               // 112
            text: mail.text || null,                                                                                   // 113
            html: mail.html || null,                                                                                   // 114
            attachments: attachments                                                                                   // 115
          };                                                                                                           // 99
                                                                                                                       //
          // Get list of grain IDs.                                                                                    //
          var grainPublicIds = _.uniq(session.envelope.rcptTo.map(function (deliverTo) {                               // 119
            // smtp-server already validates that the address contains an @.                                           //
            // To simplify things, we ignore the hostname part of the address and assume that the                      //
            // message would not have been sent here if it weren't intended for our host. Usually                      //
            // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                        //
            // globally unique anyway, so an e-mail meant for another server presumably won't match                    //
            // any ID at this one anyway.                                                                              //
            var address = deliverTo.address;                                                                           // 119
                                                                                                                       //
            return address.slice(0, address.indexOf("@"));                                                             // 127
          }));                                                                                                         // 128
                                                                                                                       //
          // Deliver to each grain in parallel.                                                                        //
          return Promise.all(grainPublicIds.map(function (publicId) {                                                  // 131
            // Wrap in a function so that we can call it recursively to retry.                                         //
            var tryDeliver = function tryDeliver(retryCount) {                                                         // 133
              var grainId = void 0;                                                                                    // 134
              return inMeteor(function () {                                                                            // 135
                var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                    // 136
                if (grain) {                                                                                           // 137
                  grainId = grain._id;                                                                                 // 138
                  return globalBackend.continueGrain(grainId, retryCount > 0);                                         // 139
                } else {                                                                                               // 140
                  // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                //
                  // fails in this case, by adding an onRcptTo() callback.                                             //
                  throw new Error("No such grain: " + publicId);                                                       // 143
                }                                                                                                      // 144
              }).then(function (grainInfo) {                                                                           // 145
                var supervisor = grainInfo.supervisor;                                                                 // 146
                var uiView = supervisor.getMainView().view;                                                            // 147
                                                                                                                       //
                // Create an arbitrary struct to use as the session params. E-mail sessions actually                   //
                // require no params, but node-capnp won't let us pass null and we don't have an                       //
                // EmptyStruct type available, so we just use EmailAddress, but any struct type would                  //
                // work.                                                                                               //
                // TODO(cleanup): Fix node-capnp to accept null.                                                       //
                var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                          // 154
                                                                                                                       //
                // Create a new session of type HackEmailSession. This is a short-term hack until                      //
                // persistent capabilities and the Powerbox are implemented. We need to pass along a                   //
                // HackSessionContext because old versions of sandstorm-http-bridge always use                         //
                // the context of the most recent session; if an old RoundCube grain has a                             //
                // WebSession open, receives an email, and then tries to send an email, the request                    //
                // will go out on the SessionContext associated with the HackEmailSession that                         //
                // delivered the email.                                                                                //
                var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
                return session.send(mailMessage);                                                                      // 167
              })["catch"](function (err) {                                                                             // 168
                if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                            // 169
                  return tryDeliver(retryCount + 1);                                                                   // 170
                } else {                                                                                               // 171
                  throw err;                                                                                           // 172
                }                                                                                                      // 173
              });                                                                                                      // 174
            };                                                                                                         // 175
                                                                                                                       //
            return tryDeliver(0);                                                                                      // 177
          }));                                                                                                         // 178
        }).then(function () {                                                                                          // 179
          callback(null, "Message delivered");                                                                         // 180
        }, function (err) {                                                                                            // 181
          console.error("E-mail delivery failure:", err.stack);                                                        // 182
          var mailErr = new Error(err.message);                                                                        // 183
          err.responseCode = 451;                                                                                      // 184
          callback(err.message);                                                                                       // 185
        });                                                                                                            // 186
      });                                                                                                              // 187
    }                                                                                                                  // 188
  });                                                                                                                  // 55
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 191
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 192
  } else {                                                                                                             // 193
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 195
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 196
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 197
  }                                                                                                                    // 198
});                                                                                                                    // 199
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 201
  return inMeteor(function () {                                                                                        // 202
    var recipientCount = 0;                                                                                            // 203
    recipientCount += email.to ? email.to.length : 0;                                                                  // 204
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 205
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 206
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 207
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 212
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 214
    var userAddress = session._getUserAddress();                                                                       // 215
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 218
      email.from = {                                                                                                   // 219
        address: grainAddress                                                                                          // 220
      };                                                                                                               // 219
    }                                                                                                                  // 222
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 224
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 228
                                                                                                                       //
    // Unpack fields                                                                                                   //
    var from = email.from;                                                                                             // 202
    var to = email.to;                                                                                                 // 202
    var cc = email.cc;                                                                                                 // 202
    var bcc = email.bcc;                                                                                               // 202
    var replyTo = email.replyTo;                                                                                       // 202
    var subject = email.subject;                                                                                       // 202
    var text = email.text;                                                                                             // 202
    var html = email.html;                                                                                             // 202
                                                                                                                       //
                                                                                                                       //
    var options = {                                                                                                    // 233
      from: from,                                                                                                      // 234
      to: to,                                                                                                          // 235
      cc: cc,                                                                                                          // 236
      bcc: bcc,                                                                                                        // 237
      replyTo: replyTo,                                                                                                // 238
      subject: subject,                                                                                                // 239
      text: text,                                                                                                      // 240
      html: html,                                                                                                      // 241
      envelope: {                                                                                                      // 242
        from: grainAddress,                                                                                            // 243
        to: to,                                                                                                        // 244
        cc: cc,                                                                                                        // 245
        bcc: bcc                                                                                                       // 246
      }                                                                                                                // 242
    };                                                                                                                 // 233
                                                                                                                       //
    var headers = {};                                                                                                  // 250
    if (email.messageId) {                                                                                             // 251
      headers["message-id"] = email.messageId;                                                                         // 252
    }                                                                                                                  // 253
                                                                                                                       //
    if (email.references) {                                                                                            // 255
      headers["references"] = email.references; // jscs:ignore requireDotNotation                                      // 256
    }                                                                                                                  // 257
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 259
      headers["in-reply-to"] = email.inReplyTo;                                                                        // 260
    }                                                                                                                  // 261
                                                                                                                       //
    if (email.date) {                                                                                                  // 263
      var date = new Date(email.date / 1000000);                                                                       // 264
      if (!isNaN(date.getTime())) {                                                                                    // 265
        // Check to make sure date is valid                                                                            //
        headers["date"] = date.toUTCString(); // jscs:ignore requireDotNotation                                        // 266
      }                                                                                                                // 267
    }                                                                                                                  // 268
                                                                                                                       //
    options.headers = headers;                                                                                         // 270
                                                                                                                       //
    if (email.attachments) {                                                                                           // 272
      (function () {                                                                                                   // 272
        var attachments = [];                                                                                          // 273
        email.attachments.forEach(function (attachment) {                                                              // 274
          attachments.push({                                                                                           // 275
            cid: attachment.contentId,                                                                                 // 276
            contentType: attachment.contentType,                                                                       // 277
            contentDisposition: attachment.contentDisposition,                                                         // 278
            content: attachment.content                                                                                // 279
          });                                                                                                          // 275
        });                                                                                                            // 281
        options.attachments = attachments;                                                                             // 282
      })();                                                                                                            // 272
    }                                                                                                                  // 283
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 285
    if (!grain) throw new Error("Grain does not exist.");                                                              // 286
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 287
                                                                                                                       //
    rawSend(options);                                                                                                  // 289
  }.bind(_this))["catch"](function (err) {                                                                             // 290
    console.error("Error sending e-mail:", err.stack);                                                                 // 291
    throw err;                                                                                                         // 292
  });                                                                                                                  // 293
};                                                                                                                     // 294
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 297
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 297
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 297
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 299
    _this2._services = params.services;                                                                                // 300
    return _this2;                                                                                                     // 297
  }                                                                                                                    // 301
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 304
  };                                                                                                                   // 305
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this3 = this;                                                                                                 // 307
                                                                                                                       //
    return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                  // 308
      if (verification.tabId !== tabId.toString("hex")) {                                                              // 309
        throw new Error("VerifiedEmail is from a different tab");                                                      // 310
      }                                                                                                                // 311
                                                                                                                       //
      if (_this3._services) {                                                                                          // 313
        // Since this verifier is restricted to specific services, only indicate a match if the                        //
        // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                           //
        // match all services, and therefore all VerifiedEmails.)                                                      //
        if (verification.verifierId !== _this3._id) {                                                                  // 317
          throw new Error("VerifierEmail is for a different EmailVerifier.");                                          // 318
        }                                                                                                              // 319
      }                                                                                                                // 320
                                                                                                                       //
      return verification.address;                                                                                     // 322
    });                                                                                                                // 323
  };                                                                                                                   // 324
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 325
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 328
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 328
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 328
  }                                                                                                                    // 330
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 333
  // Get all of the email addresses verified as belonging to the given user using the given                            //
  // verifier.                                                                                                         //
                                                                                                                       //
  var services = null;                                                                                                 // 337
                                                                                                                       //
  if (verifierId) {                                                                                                    // 339
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 340
    if (!verifier) return []; // invalid verifier                                                                      // 342
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 343
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 345
      // Limit to the listed services.                                                                                 //
      services = {};                                                                                                   // 347
      verifierInfo.services.forEach(function (service) {                                                               // 348
        return services[service] = true;                                                                               // 348
      });                                                                                                              // 348
    }                                                                                                                  // 349
  }                                                                                                                    // 350
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 352
  var emails = {}; // map address -> true, for uniquification                                                          // 353
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 354
    if (!services || services[identity.profile.service]) {                                                             // 355
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 356
        emails[email.email] = true;                                                                                    // 356
      });                                                                                                              // 356
    }                                                                                                                  // 357
  });                                                                                                                  // 358
                                                                                                                       //
  return Object.keys(emails);                                                                                          // 360
}                                                                                                                      // 361
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 365
  globalFrontendRefRegistry.register({                                                                                 // 366
    frontendRefField: "emailVerifier",                                                                                 // 367
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 368
                                                                                                                       //
    restore: function restore(db, saveTemplate, params) {                                                              // 370
      return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
    },                                                                                                                 // 373
    validate: function validate(db, session, value) {                                                                  // 375
      check(value, { services: Match.Optional([String]) });                                                            // 376
                                                                                                                       //
      var services = value.services;                                                                                   // 378
      if (services) {                                                                                                  // 379
        services.forEach(function (service) {                                                                          // 380
          if (!Accounts.identityServices[service]) {                                                                   // 381
            throw new Error("No such identity service: " + service);                                                   // 382
          }                                                                                                            // 383
        });                                                                                                            // 384
      }                                                                                                                // 385
                                                                                                                       //
      value.id = Crypto.randomBytes(16).toString("base64");                                                            // 387
                                                                                                                       //
      return {                                                                                                         // 389
        descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                                 // 390
        requirements: []                                                                                               // 391
      };                                                                                                               // 389
    },                                                                                                                 // 393
    query: function query(db, userId, value) {                                                                         // 395
      var results = [];                                                                                                // 396
                                                                                                                       //
      results.push({                                                                                                   // 398
        _id: "emailverifier-all",                                                                                      // 399
        frontendRef: { emailVerifier: {} },                                                                            // 400
        cardTemplate: "emailVerifierPowerboxCard"                                                                      // 401
      });                                                                                                              // 398
                                                                                                                       //
      for (var name in Accounts.identityServices) {                                                                    // 404
        if (Accounts.identityServices[name].isEnabled()) {                                                             // 405
          results.push({                                                                                               // 406
            _id: "emailverifier-" + name,                                                                              // 407
            frontendRef: { emailVerifier: { services: [name] } },                                                      // 408
            cardTemplate: "emailVerifierPowerboxCard"                                                                  // 409
          });                                                                                                          // 406
        }                                                                                                              // 411
      };                                                                                                               // 412
                                                                                                                       //
      return results;                                                                                                  // 414
    }                                                                                                                  // 415
  });                                                                                                                  // 366
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 418
    frontendRefField: "verifiedEmail",                                                                                 // 419
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 420
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 422
      return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);         // 423
    },                                                                                                                 // 425
    validate: function validate(db, session, value) {                                                                  // 427
      check(value, { verifierId: Match.Optional(String), address: String });                                           // 428
                                                                                                                       //
      if (!session.userId) {                                                                                           // 430
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 431
      }                                                                                                                // 432
                                                                                                                       //
      // Verify that the address actually belongs to the user.                                                         //
                                                                                                                       //
      if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId), value.address)) {                       // 436
        throw new Meteor.Error(403, "User has no such verified address");                                              // 437
      }                                                                                                                // 438
                                                                                                                       //
      // Add the session's tabId.                                                                                      //
      value.tabId = session.tabId;                                                                                     // 441
                                                                                                                       //
      // Build the descriptor, which contains the verifier ID.                                                         //
      var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
      return {                                                                                                         // 448
        descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                                // 449
        requirements: []                                                                                               // 450
      };                                                                                                               // 448
    },                                                                                                                 // 452
    query: function query(db, userId, value) {                                                                         // 454
      var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 455
      return getVerifiedEmails(db, userId, verifierId).map(function (address) {                                        // 457
        return {                                                                                                       // 457
          _id: "email-" + address,                                                                                     // 458
          frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                                // 459
          cardTemplate: "verifiedEmailPowerboxCard"                                                                    // 460
        };                                                                                                             // 457
      });                                                                                                              // 457
    }                                                                                                                  // 462
  });                                                                                                                  // 418
});                                                                                                                    // 464
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js","/imports/server/migrations.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var migrateToLatest;module.import("/imports/server/migrations.js",{"migrateToLatest":function(v){migrateToLatest=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 22
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 24
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 26
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     //
  //   first runs. Move it into an import.                                                                             //
  Meteor.startup(function () {                                                                                         // 29
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 30
  });                                                                                                                  // 32
}                                                                                                                      // 33
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 35
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 37
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           //
  //   packages to actually use the DB, but it's pretty sad.                                                           //
  connection.sandstormDb = globalDb;                                                                                   // 40
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 41
});                                                                                                                    // 42
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 43
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxTokens(globalDb));               // 44
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 46
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 47
});                                                                                                                    // 48
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 50
  migrateToLatest(globalDb, globalBackend);                                                                            // 50
});                                                                                                                    // 50
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","heapdump","/imports/server/constants.js","/imports/server/auth.js","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whitelabelUseServerTitleForHomeText", "quotaEnabled", "quotaLdapEnabled", "billingPromptUrl"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 45
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 49
  hostname: String,                                                                                                    // 50
  port: Number,                                                                                                        // 51
  auth: {                                                                                                              // 52
    user: String,                                                                                                      // 53
    pass: String                                                                                                       // 54
  },                                                                                                                   // 52
  returnAddress: String                                                                                                // 56
};                                                                                                                     // 49
                                                                                                                       //
Meteor.methods({                                                                                                       // 59
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 60
    checkAuth(token);                                                                                                  // 61
    check(serviceName, String);                                                                                        // 62
    check(value, Boolean);                                                                                             // 63
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 68
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 69
    }                                                                                                                  // 71
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 74
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 75
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 76
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 77
      if (!config) {                                                                                                   // 78
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 81
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 83
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 86
    }                                                                                                                  // 87
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 89
    if (value) {                                                                                                       // 90
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 91
    }                                                                                                                  // 92
  },                                                                                                                   // 93
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 95
    checkAuth(token);                                                                                                  // 96
    check(config, smtpConfigShape);                                                                                    // 97
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 99
  },                                                                                                                   // 100
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 102
    checkAuth(token);                                                                                                  // 103
    check(name, String);                                                                                               // 104
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 105
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 107
  },                                                                                                                   // 108
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 110
    checkAuth(token);                                                                                                  // 111
    check(textBlock, Match.OneOf(null, String));                                                                       // 112
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 114
                                                                                                                       //
    if (!textBlock) {                                                                                                  // 116
      // Delete the feature key.                                                                                       //
      db.collections.featureKey.remove("currentFeatureKey");                                                           // 118
      return;                                                                                                          // 119
    }                                                                                                                  // 120
                                                                                                                       //
    // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                      //
    var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                     // 123
      return line.length > 0 && line[0] !== "-";                                                                       // 124
    }).value().join("");                                                                                               // 124
                                                                                                                       //
    var buf = new Buffer(featureKeyBase64, "base64");                                                                  // 128
    if (buf.length < 64) {                                                                                             // 129
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 130
    }                                                                                                                  // 131
                                                                                                                       //
    // loadSignedFeatureKey is provided in feature-key.js                                                              //
    var featureKey = loadSignedFeatureKey(buf);                                                                        // 134
    if (!featureKey) {                                                                                                 // 135
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 136
    }                                                                                                                  // 137
                                                                                                                       //
    // Persist the feature key in the database.                                                                        //
    db.collections.featureKey.upsert("currentFeatureKey", {                                                            // 140
      _id: "currentFeatureKey",                                                                                        // 143
      value: buf                                                                                                       // 144
    });                                                                                                                // 142
  },                                                                                                                   // 147
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 149
    checkAuth(token);                                                                                                  // 150
    check(params, {                                                                                                    // 151
      membership: {                                                                                                    // 152
        emailToken: {                                                                                                  // 153
          enabled: Boolean,                                                                                            // 154
          domain: String                                                                                               // 155
        },                                                                                                             // 153
        google: {                                                                                                      // 157
          enabled: Boolean,                                                                                            // 158
          domain: String                                                                                               // 159
        },                                                                                                             // 157
        ldap: {                                                                                                        // 161
          enabled: Boolean                                                                                             // 162
        },                                                                                                             // 161
        saml: {                                                                                                        // 164
          enabled: Boolean                                                                                             // 165
        }                                                                                                              // 164
      },                                                                                                               // 152
      settings: {                                                                                                      // 168
        disallowGuests: Boolean,                                                                                       // 169
        shareContacts: Boolean                                                                                         // 170
      }                                                                                                                // 168
    });                                                                                                                // 151
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 176
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 178
    checkAuth(token);                                                                                                  // 179
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 180
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 182
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 184
  },                                                                                                                   // 185
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 187
    checkAuth(token);                                                                                                  // 188
    check(serviceName, String);                                                                                        // 189
                                                                                                                       //
    var query = {};                                                                                                    // 191
    query["services." + serviceName] = { $exists: true };                                                              // 192
    Meteor.users.find(query).forEach(function (identity) {                                                             // 193
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 196
      }                                                                                                                // 197
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 199
    });                                                                                                                // 201
  },                                                                                                                   // 202
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 204
    checkAuth(token);                                                                                                  // 205
    check(userInfo, {                                                                                                  // 206
      userId: String,                                                                                                  // 207
      signupKey: Boolean,                                                                                              // 208
      isAdmin: Boolean                                                                                                 // 209
    });                                                                                                                // 206
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 212
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 213
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 214
    }                                                                                                                  // 215
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 217
  },                                                                                                                   // 218
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 220
    checkAuth(token);                                                                                                  // 221
    check(smtpConfig, smtpConfigShape);                                                                                // 222
    check(to, String);                                                                                                 // 223
    var returnAddress = smtpConfig.returnAddress;                                                                      // 220
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 220
                                                                                                                       //
    try {                                                                                                              // 226
      sendEmail({                                                                                                      // 227
        to: to,                                                                                                        // 228
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 229
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 230
        text: "Success! Your outgoing SMTP is working.",                                                               // 231
        smtpConfig: restConfig                                                                                         // 232
      });                                                                                                              // 227
    } catch (e) {                                                                                                      // 234
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 237
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 238
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 240
      } else if (e.syscall === "connect") {                                                                            // 241
        if (e.code === "ECONNREFUSED") {                                                                               // 242
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 244
      } else if (e.name === "AuthError") {                                                                             // 245
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 248
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 251
  },                                                                                                                   // 252
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 254
    checkAuth(token);                                                                                                  // 255
    check(note, String);                                                                                               // 256
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 257
                                                                                                                       //
    var key = Random.id();                                                                                             // 259
    var content = { _id: key, used: false, note: note };                                                               // 260
    if (typeof quota === "number") content.quota = quota;                                                              // 261
    SignupKeys.insert(content);                                                                                        // 262
    return key;                                                                                                        // 263
  },                                                                                                                   // 264
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 266
    checkAuth(token);                                                                                                  // 267
    check([origin, from, list, subject, message], [String]);                                                           // 268
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 269
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 271
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 272
    }                                                                                                                  // 273
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 275
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 276
    }                                                                                                                  // 277
                                                                                                                       //
    this.unblock();                                                                                                    // 279
                                                                                                                       //
    list = list.split("\n");                                                                                           // 281
    for (var i in list) {                                                                                              // 282
      var email = list[i].trim();                                                                                      // 283
                                                                                                                       //
      if (email) {                                                                                                     // 285
        var key = Random.id();                                                                                         // 286
                                                                                                                       //
        var content = {                                                                                                // 288
          _id: key,                                                                                                    // 289
          used: false,                                                                                                 // 290
          note: "E-mail invite to " + email,                                                                           // 291
          email: email,                                                                                                // 292
          definitelySent: false                                                                                        // 293
        };                                                                                                             // 288
        if (typeof quota === "number") content.quota = quota;                                                          // 295
        SignupKeys.insert(content);                                                                                    // 296
        sendEmail({                                                                                                    // 297
          to: email,                                                                                                   // 298
          from: from,                                                                                                  // 299
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 300
          subject: subject,                                                                                            // 301
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 302
        });                                                                                                            // 297
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 304
      }                                                                                                                // 305
    }                                                                                                                  // 306
                                                                                                                       //
    return { sent: true };                                                                                             // 308
  },                                                                                                                   // 309
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 311
    checkAuth(token);                                                                                                  // 312
    check(capId, String);                                                                                              // 313
    check(value, Boolean);                                                                                             // 314
                                                                                                                       //
    if (value) {                                                                                                       // 316
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 317
    } else {                                                                                                           // 318
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 319
    }                                                                                                                  // 320
  },                                                                                                                   // 321
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 323
    checkAuth(token);                                                                                                  // 324
    check(list, String);                                                                                               // 325
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 326
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 328
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 329
    }                                                                                                                  // 330
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 332
    var invalid = [];                                                                                                  // 333
    for (var i in items) {                                                                                             // 334
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 335
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 337
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 338
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 343
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 344
    }                                                                                                                  // 346
  },                                                                                                                   // 347
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 349
    checkAuth(token);                                                                                                  // 350
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 351
  },                                                                                                                   // 352
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 354
    check(token, String);                                                                                              // 355
    checkAuth(token);                                                                                                  // 356
    if (!this.userId) {                                                                                                // 357
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 358
    }                                                                                                                  // 359
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 361
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 362
    }                                                                                                                  // 363
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 365
    clearAdminToken(token);                                                                                            // 366
  },                                                                                                                   // 367
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 369
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 371
    if (tokenIsValid(token)) {                                                                                         // 372
      var sessId = Random.secret();                                                                                    // 373
      var creationDate = new Date();                                                                                   // 374
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 375
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 376
        _id: "current-session"                                                                                         // 377
      }, {                                                                                                             // 376
        creationDate: creationDate,                                                                                    // 379
        hashedSessionId: hashedSessionId                                                                               // 380
      });                                                                                                              // 378
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 383
      return sessId;                                                                                                   // 384
    } else {                                                                                                           // 385
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 386
    }                                                                                                                  // 387
  },                                                                                                                   // 388
  heapdump: function heapdump() {                                                                                      // 390
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 396
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 400
    Heapdump.writeSnapshot(name);                                                                                      // 401
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 402
    return name;                                                                                                       // 403
  },                                                                                                                   // 404
                                                                                                                       //
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 406
    checkAuth();                                                                                                       // 407
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 408
                                                                                                                       //
    this.connection.sandstormDb.setPreinstalledApps(appAndPackageIds);                                                 // 410
  }                                                                                                                    // 411
});                                                                                                                    // 59
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 414
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 417
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 419
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 420
  return Settings.find();                                                                                              // 421
});                                                                                                                    // 422
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 424
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 425
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 426
});                                                                                                                    // 427
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 429
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 430
});                                                                                                                    // 431
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 433
  check(token, String);                                                                                                // 434
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 435
  this.ready();                                                                                                        // 436
});                                                                                                                    // 437
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 439
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 440
  return Meteor.users.find();                                                                                          // 441
});                                                                                                                    // 442
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 444
  var _this2 = this;                                                                                                   // 444
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 445
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 449
  var accountId = userId;                                                                                              // 450
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 452
    if (!identitySubs[identityId]) {                                                                                   // 453
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 456
      return;                                                                                                          // 457
    }                                                                                                                  // 458
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 460
    delete identitySubs[identityId];                                                                                   // 461
    observeHandle.stop();                                                                                              // 462
    _this2.removed("users", identityId);                                                                               // 463
  };                                                                                                                   // 464
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 466
    if (identitySubs[identityId]) {                                                                                    // 467
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 470
      return;                                                                                                          // 471
    }                                                                                                                  // 472
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 474
    var observeHandle = cursor.observe({                                                                               // 475
      added: function added(doc) {                                                                                     // 476
        _this2.added("users", doc._id, doc);                                                                           // 477
      },                                                                                                               // 478
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 480
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 481
      },                                                                                                               // 482
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 484
        _this2.removed("users", oldDoc._id);                                                                           // 485
      }                                                                                                                // 486
    });                                                                                                                // 475
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 489
  };                                                                                                                   // 490
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 492
  var accountSubHandle = accountCursor.observe({                                                                       // 493
    added: function added(newDoc) {                                                                                    // 494
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 495
      newIdentities.forEach(function (identityId) {                                                                    // 496
        refIdentity(identityId);                                                                                       // 497
      });                                                                                                              // 498
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 500
    },                                                                                                                 // 501
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 503
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 504
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 505
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 508
      identitiesAdded.forEach(function (identityId) {                                                                  // 509
        refIdentity(identityId);                                                                                       // 510
      });                                                                                                              // 511
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 514
      identitiesRemoved.forEach(function (identityId) {                                                                // 515
        unrefIdentity(identityId);                                                                                     // 516
      });                                                                                                              // 517
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 519
    },                                                                                                                 // 520
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 522
      _this2.removed("users", oldDoc._id);                                                                             // 523
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 524
      oldIdentities.forEach(function (identityId) {                                                                    // 525
        unrefIdentity(identityId);                                                                                     // 526
      });                                                                                                              // 527
    }                                                                                                                  // 528
  });                                                                                                                  // 493
                                                                                                                       //
  this.onStop(function () {                                                                                            // 531
    accountSubHandle.stop();                                                                                           // 532
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 534
    subs.forEach(function (sub) {                                                                                      // 535
      sub.stop();                                                                                                      // 536
    });                                                                                                                // 537
  });                                                                                                                  // 538
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 542
});                                                                                                                    // 543
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 545
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 546
  return ActivityStats.find();                                                                                         // 547
});                                                                                                                    // 548
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 550
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 551
  return StatsTokens.find();                                                                                           // 552
});                                                                                                                    // 553
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 555
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 556
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 557
      "manifest.actions": 1, "manifest.appTitle": 1, progress: 1, status: 1 } });                                      // 559
});                                                                                                                    // 560
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 562
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 563
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 566
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 569
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 570
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 571
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 575
});                                                                                                                    // 576
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 578
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 579
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 581
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 583
  var startSize = Fs.fstatSync(fd).size;                                                                               // 584
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 587
                                                                                                                       //
  var _this = this;                                                                                                    // 589
  function doTail() {                                                                                                  // 590
    for (;;) {                                                                                                         // 591
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 592
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 593
      if (n <= 0) break;                                                                                               // 594
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 595
      offset += n;                                                                                                     // 596
    }                                                                                                                  // 597
  }                                                                                                                    // 598
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 601
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 604
    watcher.close();                                                                                                   // 605
    Fs.closeSync(fd);                                                                                                  // 606
  });                                                                                                                  // 607
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 610
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 613
});                                                                                                                    // 614
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 616
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 617
  return ApiTokens.find({                                                                                              // 618
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 619
  }, {                                                                                                                 // 618
    fields: {                                                                                                          // 624
      frontendRef: 1,                                                                                                  // 625
      created: 1,                                                                                                      // 626
      requirements: 1,                                                                                                 // 627
      revoked: 1,                                                                                                      // 628
      owner: 1                                                                                                         // 629
    }                                                                                                                  // 624
  });                                                                                                                  // 623
});                                                                                                                    // 632
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 634
  var _this3 = this;                                                                                                   // 634
                                                                                                                       //
  // Note: we publish the *raw* feature key data to the client, exactly as it was loaded from the                      //
  // signed blob.  Any mapping from the raw data to "effective" feature key/limits should be applied                   //
  // in the implementation of db.currentFeatureKey().                                                                  //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 638
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 640
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 643
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 644
  var observeHandle = featureKeyQuery.observe({                                                                        // 645
    added: function added(doc) {                                                                                       // 646
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 648
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 649
                                                                                                                       //
      if (featureKey) {                                                                                                // 651
        var _ref;                                                                                                      // 651
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 653
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 654
      }                                                                                                                // 655
    },                                                                                                                 // 656
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 658
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 660
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 661
                                                                                                                       //
      if (featureKey) {                                                                                                // 663
        var _ref2;                                                                                                     // 663
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 665
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 666
      } else {                                                                                                         // 667
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 669
      }                                                                                                                // 670
    },                                                                                                                 // 671
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 673
      _this3.removed("featureKey", oldDoc._id);                                                                        // 674
    }                                                                                                                  // 675
  });                                                                                                                  // 645
                                                                                                                       //
  this.onStop(function () {                                                                                            // 678
    observeHandle.stop();                                                                                              // 679
  });                                                                                                                  // 680
                                                                                                                       //
  this.ready();                                                                                                        // 682
});                                                                                                                    // 683
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 685
  var _this4 = this;                                                                                                   // 685
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 687
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 690
  if (cursor.count() > 0) {                                                                                            // 691
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 692
  } else {                                                                                                             // 693
    (function () {                                                                                                     // 693
      var handle = cursor.observeChanges({                                                                             // 694
        added: function added(id) {                                                                                    // 695
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 696
          handle.stop();                                                                                               // 697
          handle = null;                                                                                               // 698
        }                                                                                                              // 699
      });                                                                                                              // 694
      _this4.onStop(function () {                                                                                      // 701
        if (handle) handle.stop();                                                                                     // 702
      });                                                                                                              // 703
    })();                                                                                                              // 693
  }                                                                                                                    // 704
                                                                                                                       //
  this.ready();                                                                                                        // 706
});                                                                                                                    // 707
                                                                                                                       //
Meteor.publish("appIndexAdmin", function (token) {                                                                     // 709
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 710
  return globalDb.collections.appIndex.find();                                                                         // 711
});                                                                                                                    // 712
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 714
  Settings.find({ _id: name, value: true }).observe({                                                                  // 715
    added: function added() {                                                                                          // 716
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 718
    },                                                                                                                 // 719
                                                                                                                       //
    removed: function removed() {                                                                                      // 721
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 723
    }                                                                                                                  // 724
  });                                                                                                                  // 715
}                                                                                                                      // 726
                                                                                                                       //
observeOauthService("github");                                                                                         // 728
observeOauthService("google");                                                                                         // 729
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 21
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 23
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 24
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 26
  check(tokenId, String);                                                                                              // 27
  FileTokens.remove({ _id: tokenId });                                                                                 // 28
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 29
}                                                                                                                      // 30
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 32
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 34
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 35
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 37
      cleanupToken(token._id);                                                                                         // 38
    });                                                                                                                // 39
  });                                                                                                                  // 40
});                                                                                                                    // 41
                                                                                                                       //
Meteor.methods({                                                                                                       // 43
  backupGrain: function backupGrain(grainId) {                                                                         // 44
    check(grainId, String);                                                                                            // 45
    var grain = Grains.findOne(grainId);                                                                               // 46
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 47
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 48
    }                                                                                                                  // 49
                                                                                                                       //
    this.unblock();                                                                                                    // 51
                                                                                                                       //
    var token = {                                                                                                      // 53
      _id: Random.id(),                                                                                                // 54
      timestamp: new Date(),                                                                                           // 55
      name: grain.title                                                                                                // 56
    };                                                                                                                 // 53
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 61
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 63
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 64
                                                                                                                       //
    return token._id;                                                                                                  // 66
  },                                                                                                                   // 67
  newRestoreToken: function newRestoreToken() {                                                                        // 69
    if (!isSignedUpOrDemo()) {                                                                                         // 70
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                          // 71
    }                                                                                                                  // 72
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 74
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 75
    }                                                                                                                  // 77
                                                                                                                       //
    var token = {                                                                                                      // 79
      _id: Random.id(),                                                                                                // 80
      timestamp: new Date()                                                                                            // 81
    };                                                                                                                 // 79
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 84
                                                                                                                       //
    return token._id;                                                                                                  // 86
  },                                                                                                                   // 87
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 89
    check(tokenId, String);                                                                                            // 90
    check(identityId, String);                                                                                         // 91
    var token = FileTokens.findOne(tokenId);                                                                           // 92
    if (!token || !isSignedUpOrDemo()) {                                                                               // 93
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 94
    }                                                                                                                  // 96
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 98
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 99
    }                                                                                                                  // 101
                                                                                                                       //
    this.unblock();                                                                                                    // 103
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 105
                                                                                                                       //
    try {                                                                                                              // 107
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 110
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 111
      })).info;                                                                                                        // 112
      if (!grainInfo.appId) {                                                                                          // 113
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 114
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 115
      }                                                                                                                // 116
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 118
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 121
      var appVersion = void 0;                                                                                         // 122
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 125
      if (devPackage) {                                                                                                // 126
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 128
        appVersion = devPackage.manifest.appVersion;                                                                   // 129
      } else if (action) {                                                                                             // 130
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 133
        appVersion = action.appVersion;                                                                                // 134
      } else {                                                                                                         // 135
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 137
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 138
      }                                                                                                                // 141
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 143
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 144
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 150
                                                                                                                       //
      Grains.insert({                                                                                                  // 152
        _id: grainId,                                                                                                  // 153
        packageId: packageId,                                                                                          // 154
        appId: grainInfo.appId,                                                                                        // 155
        appVersion: appVersion,                                                                                        // 156
        userId: this.userId,                                                                                           // 157
        identityId: identityId,                                                                                        // 158
        title: grainInfo.title,                                                                                        // 159
        "private": true,                                                                                               // 160
        size: 0                                                                                                        // 161
      });                                                                                                              // 152
    } finally {                                                                                                        // 163
      cleanupToken(tokenId);                                                                                           // 164
    }                                                                                                                  // 165
                                                                                                                       //
    return grainId;                                                                                                    // 167
  }                                                                                                                    // 168
});                                                                                                                    // 43
                                                                                                                       //
Router.map(function () {                                                                                               // 171
  this.route("downloadBackup", {                                                                                       // 172
    where: "server",                                                                                                   // 173
    path: "/downloadBackup/:tokenId",                                                                                  // 174
    action: function action() {                                                                                        // 175
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 176
      var response = this.response;                                                                                    // 177
      if (!token) {                                                                                                    // 178
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 179
        return response.end("File does not exist");                                                                    // 180
      }                                                                                                                // 181
                                                                                                                       //
      var started = false;                                                                                             // 183
      var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                          // 184
      var sawEnd = false;                                                                                              // 185
                                                                                                                       //
      var stream = {                                                                                                   // 187
        expectSize: function expectSize(size) {                                                                        // 188
          if (!started) {                                                                                              // 189
            started = true;                                                                                            // 190
            response.writeHead(200, {                                                                                  // 191
              "Content-Length": size,                                                                                  // 192
              "Content-Type": "application/zip",                                                                       // 193
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 194
            });                                                                                                        // 191
          }                                                                                                            // 196
        },                                                                                                             // 197
        write: function write(data) {                                                                                  // 199
          if (!started) {                                                                                              // 200
            started = true;                                                                                            // 201
            response.writeHead(200, {                                                                                  // 202
              "Content-Type": "application/zip",                                                                       // 203
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 204
            });                                                                                                        // 202
          }                                                                                                            // 206
                                                                                                                       //
          response.write(data);                                                                                        // 208
        },                                                                                                             // 209
        done: function done(data) {                                                                                    // 211
          if (!started) {                                                                                              // 212
            started = true;                                                                                            // 213
            response.writeHead(200, {                                                                                  // 214
              "Content-Length": 0,                                                                                     // 215
              "Content-Type": "application/zip",                                                                       // 216
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 217
            });                                                                                                        // 214
          }                                                                                                            // 219
                                                                                                                       //
          sawEnd = true;                                                                                               // 221
          response.end();                                                                                              // 222
        }                                                                                                              // 223
      };                                                                                                               // 187
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 226
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 228
        console.error("backend failed to call done() when downloading backup");                                        // 229
        if (!started) {                                                                                                // 230
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 231
        }                                                                                                              // 232
                                                                                                                       //
        response.end();                                                                                                // 234
      }                                                                                                                // 235
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 237
    }                                                                                                                  // 238
  });                                                                                                                  // 172
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 241
    where: "server",                                                                                                   // 242
    path: "/uploadBackup/:token",                                                                                      // 243
    action: function action() {                                                                                        // 244
      var _this = this;                                                                                                // 244
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 245
        var _ret = function () {                                                                                       // 245
          var token = FileTokens.findOne(_this.params.token);                                                          // 246
          if (!_this.params.token || !token) {                                                                         // 247
            _this.response.writeHead(403, {                                                                            // 248
              "Content-Type": "text/plain"                                                                             // 249
            });                                                                                                        // 248
            _this.response.write("Invalid upload token.");                                                             // 251
            _this.response.end();                                                                                      // 252
            return {                                                                                                   // 253
              v: void 0                                                                                                // 253
            };                                                                                                         // 253
          }                                                                                                            // 254
                                                                                                                       //
          var request = _this.request;                                                                                 // 256
          try {                                                                                                        // 257
            (function () {                                                                                             // 257
              var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                                // 258
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 260
                request.on("data", function (data) {                                                                   // 261
                  stream.write(data);                                                                                  // 262
                });                                                                                                    // 263
                request.on("end", function () {                                                                        // 264
                  resolve(stream.done());                                                                              // 265
                });                                                                                                    // 266
                request.on("error", function (err) {                                                                   // 267
                  stream.close();                                                                                      // 268
                });                                                                                                    // 269
              }));                                                                                                     // 270
                                                                                                                       //
              _this.response.writeHead(204);                                                                           // 272
              _this.response.end();                                                                                    // 273
            })();                                                                                                      // 257
          } catch (error) {                                                                                            // 274
            console.error(error.stack);                                                                                // 275
            _this.response.writeHead(500, {                                                                            // 276
              "Content-Type": "text/plain"                                                                             // 277
            });                                                                                                        // 276
            _this.response.write(error.stack);                                                                         // 279
            _this.response.end();                                                                                      // 280
          }                                                                                                            // 281
        }();                                                                                                           // 245
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 245
      } else {                                                                                                         // 282
        this.response.writeHead(405, {                                                                                 // 283
          "Content-Type": "text/plain"                                                                                 // 284
        });                                                                                                            // 283
        this.response.write("You can only POST here.");                                                                // 286
        this.response.end();                                                                                           // 287
      }                                                                                                                // 288
    }                                                                                                                  // 289
  });                                                                                                                  // 241
});                                                                                                                    // 291
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"contacts-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/contacts-server.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.publish("contactProfiles", function (showAll) {                                                                 // 17
  var db = this.connection.sandstormDb;                                                                                // 18
  var _this = this;                                                                                                    // 19
  var userId = this.userId;                                                                                            // 20
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var contactIdentities = {};                                                                                          // 23
  var disallowGuests = db.getOrganizationDisallowGuests();                                                             // 24
                                                                                                                       //
  function addIdentityOfContact(identityId) {                                                                          // 26
    if (!(identityId in contactIdentities)) {                                                                          // 27
      var user = Meteor.users.findOne({ _id: identityId });                                                            // 28
                                                                                                                       //
      if (disallowGuests && !showAll) {                                                                                // 30
        if (!db.isIdentityInOrganization(user)) {                                                                      // 31
          return;                                                                                                      // 32
        }                                                                                                              // 33
      }                                                                                                                // 34
                                                                                                                       //
      if (user) {                                                                                                      // 36
        SandstormDb.fillInProfileDefaults(user);                                                                       // 37
        SandstormDb.fillInIntrinsicName(user);                                                                         // 38
        var filteredUser = _.pick(user, "_id", "profile");                                                             // 39
        _this.added("contactProfiles", user._id, filteredUser);                                                        // 40
      }                                                                                                                // 41
                                                                                                                       //
      contactIdentities[identityId] = Meteor.users.find({ _id: identityId }, { fields: { profile: 1 } }).observeChanges({
        changed: function changed(id, fields) {                                                                        // 45
          _this.changed("contactProfiles", id, fields);                                                                // 46
        }                                                                                                              // 47
      });                                                                                                              // 44
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  var cursor = db.collections.contacts.find({ ownerId: userId });                                                      // 52
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 54
    added: function added(contact) {                                                                                   // 55
      addIdentityOfContact(contact.identityId);                                                                        // 56
    },                                                                                                                 // 57
                                                                                                                       //
    changed: function changed(contact) {                                                                               // 59
      addIdentityOfContact(contact.identityId);                                                                        // 60
    },                                                                                                                 // 61
                                                                                                                       //
    removed: function removed(contact) {                                                                               // 63
      _this.removed("contactProfiles", contact.identityId);                                                            // 64
      var contactIdentity = contactIdentities[contact.identityId];                                                     // 65
      if (contactIdentity) contactIdentities[contact.identityId].stop();                                               // 66
      delete contactIdentities[contact.identityId];                                                                    // 67
    }                                                                                                                  // 68
  });                                                                                                                  // 54
                                                                                                                       //
  var orgHandle = void 0;                                                                                              // 71
                                                                                                                       //
  if (db.getOrganizationShareContacts() && db.isUserInOrganization(db.collections.users.findOne({ _id: userId }))) {   // 73
    var orgCursor = db.collections.users.find({ profile: { $exists: 1 } });                                            // 75
    // TODO(perf): make a mongo query that can find all identities in an organization and add                          //
    // indices for it. Currently, we do some case insensitive matching which mongo can't                               //
    // handle well.                                                                                                    //
                                                                                                                       //
    orgHandle = orgCursor.observe({                                                                                    // 80
      added: function added(user) {                                                                                    // 81
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 82
          addIdentityOfContact(user._id);                                                                              // 83
        }                                                                                                              // 84
      },                                                                                                               // 85
                                                                                                                       //
      changed: function changed(user) {                                                                                // 87
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 88
          addIdentityOfContact(user._id);                                                                              // 89
        }                                                                                                              // 90
      },                                                                                                               // 91
                                                                                                                       //
      removed: function removed(user) {                                                                                // 93
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 94
          _this.removed("contactProfiles", user._id);                                                                  // 95
          var contactIdentity = contactIdentities[contact.identityId];                                                 // 96
          if (contactIdentity) contactIdentities[contact.identityId].stop();                                           // 97
          delete contactIdentities[user._id];                                                                          // 98
        }                                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 80
  }                                                                                                                    // 102
                                                                                                                       //
  this.ready();                                                                                                        // 104
                                                                                                                       //
  this.onStop(function () {                                                                                            // 106
    handle.stop();                                                                                                     // 107
    if (orgHandle) {                                                                                                   // 108
      orgHandle.stop();                                                                                                // 109
    }                                                                                                                  // 110
                                                                                                                       //
    Object.keys(contactIdentities).forEach(function (identityId) {                                                     // 112
      contactIdentities[identityId].stop();                                                                            // 113
      delete contactIdentities[identityId];                                                                            // 114
    });                                                                                                                // 115
  });                                                                                                                  // 116
});                                                                                                                    // 117
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Crypto = Npm.require("crypto");                                                                                    // 18
var Url = Npm.require("url");                                                                                          // 19
                                                                                                                       // 20
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 23
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 24
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 25
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 26
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 27
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 32
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 32
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 33
  }                                                                                                                    // 34
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef) {                                                  //
    var _this2 = this;                                                                                                 // 36
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 37
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 38
      var token = ApiTokens.findOne({                                                                                  // 39
        _id: hashedSturdyRef,                                                                                          // 40
        "owner.grain.grainId": _this2.grainId                                                                          // 41
      });                                                                                                              // 39
                                                                                                                       //
      if (!token) {                                                                                                    // 44
        throw new Error("no such token");                                                                              // 45
      }                                                                                                                // 46
                                                                                                                       //
      if (token.owner.grain.introducerIdentity) {                                                                      // 48
        throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
      }                                                                                                                // 51
                                                                                                                       //
      return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) }, [], token);     // 53
    });                                                                                                                // 56
  };                                                                                                                   // 57
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this3 = this;                                                                                                 // 59
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 60
      return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this3.grainId }) });                   // 61
    });                                                                                                                // 62
  };                                                                                                                   // 63
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this = this;                                                                                                  // 66
    return inMeteor(function () {                                                                                      // 67
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 68
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 69
      ApiTokens.insert({                                                                                               // 70
        _id: hashedSturdyRef,                                                                                          // 71
        grainId: _this.grainId,                                                                                        // 72
        objectId: ref,                                                                                                 // 73
        owner: owner,                                                                                                  // 74
        created: new Date(),                                                                                           // 75
        requirements: requirements                                                                                     // 76
      });                                                                                                              // 70
                                                                                                                       //
      return {                                                                                                         // 79
        token: sturdyRef                                                                                               // 80
      };                                                                                                               // 79
    });                                                                                                                // 82
  };                                                                                                                   // 83
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    return inMeteor(function () {                                                                                      // 86
      // Compute the save ApiToken template.                                                                           //
      return makeSaveTemplateForChild(parent.toString(), requirements);                                                // 88
    }).then(function (saveTemplate) {                                                                                  // 89
      // Create a dummy PersistentImpl and invoke its own save() method.                                               //
      return new PersistentImpl(globalDb, saveTemplate).save({ sealFor: owner });                                      // 91
    }).then(function (saveResult) {                                                                                    // 92
      // Transform to expected result structure.                                                                       //
      return { token: saveResult.sturdyRef };                                                                          // 94
    });                                                                                                                // 95
  };                                                                                                                   // 96
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var grainId = this.grainId;                                                                                        // 99
    return {                                                                                                           // 100
      owner: {                                                                                                         // 101
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 102
          return inMeteor(function () {                                                                                // 103
            var grain = Grains.findOne({ _id: grainId });                                                              // 104
            if (!grain) {                                                                                              // 105
              throw new Error("Grain not found.");                                                                     // 106
            }                                                                                                          // 107
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 109
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 110
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 114
            notification.close();                                                                                      // 115
            var notificationId = Notifications.insert({                                                                // 116
              ongoing: wakelockToken,                                                                                  // 117
              grainId: grainId,                                                                                        // 118
              userId: grain.userId,                                                                                    // 119
              text: displayInfo.caption,                                                                               // 120
              timestamp: new Date(),                                                                                   // 121
              isUnread: true                                                                                           // 122
            });                                                                                                        // 116
                                                                                                                       //
            return {                                                                                                   // 125
              handle: globalFrontendRefRegistry.create(globalDb, { notificationHandle: notificationId })               // 126
            };                                                                                                         // 125
          });                                                                                                          // 129
        }                                                                                                              // 130
      }                                                                                                                // 101
    };                                                                                                                 // 100
  };                                                                                                                   // 133
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function backgroundActivity(event) {                                //
    var _this4 = this;                                                                                                 // 135
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 136
      logActivity(_this4.grainId, null, event);                                                                        // 137
    });                                                                                                                // 138
  };                                                                                                                   // 139
                                                                                                                       //
  SandstormCoreImpl.prototype.reportGrainSize = function reportGrainSize(bytes) {                                      //
    bytes = parseInt(bytes); // int64s are stringified but precision isn't critical here                               // 142
                                                                                                                       //
    var result = Grains.findAndModify({                                                                                // 144
      query: { _id: this.grainId },                                                                                    // 145
      update: { $set: { size: bytes } },                                                                               // 146
      fields: { _id: 1, userId: 1, size: 1 }                                                                           // 147
    });                                                                                                                // 144
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 150
      throw new Error("Grain not found.");                                                                             // 151
    }                                                                                                                  // 152
                                                                                                                       //
    // If the grain did not have a "size" field before the update, then it is a grain created                          //
    // before per-grain size tracking was implemented. In that case, we don't want to update the                       //
    // user record because it may already be counting the grain (specifically on Blackrock, where                      //
    // whole-user size counting has existed for some time).                                                            //
    if (globalDb.isQuotaEnabled() && "size" in result.value) {                                                         // 158
      // Update the user record, too. Note that we periodically recompute the user's storage usage                     //
      // from scratch as well, so this doesn't have to be perfectly reliable.                                          //
      var diff = bytes - (result.value.size || 0);                                                                     // 161
      Meteor.users.update(result.value.userId, { $inc: { storageUsage: diff } });                                      // 162
    }                                                                                                                  // 163
  };                                                                                                                   // 164
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 167
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 168
};                                                                                                                     // 169
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          //
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 174
    _classCallCheck(this, NotificationHandle);                                                                         // 174
                                                                                                                       //
    var _this5 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 174
                                                                                                                       //
    _this5.notificationId = notificationId;                                                                            // 176
    return _this5;                                                                                                     // 174
  }                                                                                                                    // 177
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this6 = this;                                                                                                 // 179
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 180
      if (!_this6.isSaved()) {                                                                                         // 181
        _dismissNotification(_this6.notificationId);                                                                   // 182
      }                                                                                                                // 183
    });                                                                                                                // 184
  };                                                                                                                   // 185
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 188
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 191
    _classCallCheck(this, StaticAssetImpl);                                                                            // 191
                                                                                                                       //
    check(assetId, String);                                                                                            // 192
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 193
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 194
  }                                                                                                                    // 195
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function getUrl() {                                                               //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 198
  };                                                                                                                   // 199
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 203
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 203
                                                                                                                       //
    check(hash, String);                                                                                               // 204
    check(size, Match.Integer);                                                                                        // 205
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 206
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 207
  }                                                                                                                    // 208
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function getUrl() {                                                      //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 211
  };                                                                                                                   // 212
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               //
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 218
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 218
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 218
                                                                                                                       //
    check(grainId, String);                                                                                            // 220
    _this7._db = db;                                                                                                   // 221
    _this7._grainId = grainId;                                                                                         // 222
    return _this7;                                                                                                     // 218
  }                                                                                                                    // 223
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function getViewInfo() {                                                //
    var _this8 = this;                                                                                                 // 225
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 226
      var grain = _this8._db.getGrain(_this8._grainId);                                                                // 227
      if (!grain || grain.trashed) {                                                                                   // 228
        throw new Error("grain no longer exists");                                                                     // 229
      }                                                                                                                // 230
                                                                                                                       //
      var pkg = _this8._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};           // 232
                                                                                                                       //
      var manifest = pkg.manifest || {};                                                                               // 236
                                                                                                                       //
      var viewInfo = grain.cachedViewInfo || {};                                                                       // 238
                                                                                                                       //
      if (!viewInfo.appTitle) {                                                                                        // 240
        viewInfo.appTitle = manifest.appTitle || {};                                                                   // 241
      }                                                                                                                // 242
                                                                                                                       //
      if (!viewInfo.grainIcon) {                                                                                       // 244
        var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                                 // 245
        if (grainIcon) {                                                                                               // 246
          viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);              // 247
        } else {                                                                                                       // 249
          var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                       // 250
          viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);              // 251
        }                                                                                                              // 253
      }                                                                                                                // 254
                                                                                                                       //
      return viewInfo;                                                                                                 // 256
    });                                                                                                                // 257
  };                                                                                                                   // 258
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          //
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     //
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       //
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 265
  check(grainId, String);                                                                                              // 266
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             //
  var grain = db.getGrain(grainId);                                                                                    // 269
  if (!grain || grain.trashed) {                                                                                       // 270
    throw new Meteor.Error(404, "grain not found");                                                                    // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 274
};                                                                                                                     // 276
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 278
  frontendRefField: "notificationHandle",                                                                              // 279
                                                                                                                       //
  restore: function restore(db, saveTemplate, notificationId) {                                                        // 281
    return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);           // 282
  }                                                                                                                    // 284
});                                                                                                                    // 278
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 287
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 288
  if (notification) {                                                                                                  // 289
    Notifications.remove({ _id: notificationId });                                                                     // 290
    if (notification.ongoing) {                                                                                        // 291
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 294
                                                                                                                       //
      if (!callCancel) {                                                                                               // 296
        dropInternal(id, { frontend: null });                                                                          // 297
      } else {                                                                                                         // 298
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 299
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 300
        dropInternal(id, { frontend: null });                                                                          // 301
        try {                                                                                                          // 302
          waitPromise(castedNotification.cancel());                                                                    // 303
          castedNotification.close();                                                                                  // 304
          notificationCap.close();                                                                                     // 305
        } catch (err) {                                                                                                // 306
          if (err.kjType !== "disconnected") {                                                                         // 307
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 310
          }                                                                                                            // 311
        }                                                                                                              // 312
      }                                                                                                                // 313
    } else if (notification.appUpdates) {                                                                              // 314
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 315
        globalDb.deleteUnusedPackages(appId);                                                                          // 316
      });                                                                                                              // 317
    }                                                                                                                  // 318
  }                                                                                                                    // 319
}                                                                                                                      // 320
                                                                                                                       //
Meteor.methods({                                                                                                       // 322
  dismissNotification: function dismissNotification(notificationId) {                                                  // 323
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 328
                                                                                                                       //
    var notification = Notifications.findOne({ _id: notificationId });                                                 // 330
    if (!notification) {                                                                                               // 331
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 332
    } else if (notification.userId !== Meteor.userId()) {                                                              // 333
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 334
    } else {                                                                                                           // 335
      _dismissNotification(notificationId, true);                                                                      // 336
    }                                                                                                                  // 337
  },                                                                                                                   // 338
  readAllNotifications: function readAllNotifications() {                                                              // 340
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 342
      throw new Meteor.Error(403, "User not logged in.");                                                              // 343
    }                                                                                                                  // 344
                                                                                                                       //
    Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });                 // 346
  },                                                                                                                   // 347
  acceptPowerboxOffer: function acceptPowerboxOffer(sessionId, sturdyRef, sessionToken) {                              // 349
    var db = this.connection.sandstormDb;                                                                              // 350
    check(sessionId, String);                                                                                          // 351
    check(sturdyRef, String);                                                                                          // 352
    check(sessionToken, Match.OneOf(String, null, undefined));                                                         // 353
                                                                                                                       //
    var sessionQuery = { _id: sessionId };                                                                             // 355
    if (sessionToken) {                                                                                                // 356
      sessionQuery.hashedToken = hashSturdyRef(sessionToken);                                                          // 357
    } else {                                                                                                           // 358
      sessionQuery.userId = this.userId;                                                                               // 359
    }                                                                                                                  // 360
                                                                                                                       //
    var session = db.collections.sessions.findOne(sessionQuery);                                                       // 362
    if (!session) {                                                                                                    // 363
      throw new Meteor.Error(404, "No matching session found.");                                                       // 364
    }                                                                                                                  // 365
                                                                                                                       //
    var tokenId = hashSturdyRef(sturdyRef);                                                                            // 367
    var apiToken = db.collections.apiTokens.findOne({                                                                  // 368
      _id: tokenId,                                                                                                    // 369
      "owner.clientPowerboxOffer.sessionId": sessionId                                                                 // 370
    });                                                                                                                // 368
                                                                                                                       //
    if (!apiToken) {                                                                                                   // 373
      throw new Meteor.Error(404, "No such token.");                                                                   // 374
    }                                                                                                                  // 375
                                                                                                                       //
    var newSturdyRef = void 0;                                                                                         // 377
    var hashedNewSturdyRef = void 0;                                                                                   // 378
    if (sessionToken && apiToken.parentToken) {                                                                        // 379
      // An anonymous user is being offered a child token. To avoid bloating the database,                             //
      // we deterministically derive the sturdyref from the session token and the hashed parent                        //
      // token.                                                                                                        //
      //                                                                                                               //
      // Note that an attacker with read access to the database might be able to derive                                //
      // `newSturdyRef` from `sessionToken` and gain access to the capability without ever having                      //
      // been explicitly offered it by the grain. Therefore, grains must assume that offering                          //
      // a capability to an anonymous user can possibly make that capability accessible to any                         //
      // other anonymous user who has connected through the same URL.                                                  //
                                                                                                                       //
      newSturdyRef = Crypto.createHash("sha256").update(sessionToken).update(apiToken.parentToken).digest("base64").slice(0, -1) // removing trailing "="
      .replace(/\+/g, "-").replace(/\//g, "_"); // make URL-safe                                                       // 390
                                                                                                                       //
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 397
      if (db.collections.apiTokens.findOne({ _id: hashedNewSturdyRef })) {                                             // 398
        // We have already generated this token.                                                                       //
        db.removeApiTokens({ _id: tokenId });                                                                          // 400
        return newSturdyRef;                                                                                           // 401
      }                                                                                                                // 402
    } else {                                                                                                           // 403
      newSturdyRef = generateSturdyRef();                                                                              // 404
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 405
    }                                                                                                                  // 406
                                                                                                                       //
    apiToken._id = hashedNewSturdyRef;                                                                                 // 408
    apiToken.owner = { webkey: null };                                                                                 // 409
                                                                                                                       //
    db.collections.apiTokens.insert(apiToken);                                                                         // 411
    db.removeApiTokens({ _id: tokenId });                                                                              // 412
    return newSturdyRef;                                                                                               // 413
  }                                                                                                                    // 414
});                                                                                                                    // 322
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(parentToken, requirements, parentTokenInfo) {         // 418
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        //
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       //
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    //
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              //
  //                                                                                                                   //
  // `parentToken` is the raw SturdyRef of the parent.                                                                 //
  //                                                                                                                   //
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            //
  //                                                                                                                   //
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         //
  // it handy; if omitted it will be looked up.                                                                        //
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || ApiTokens.findOne(hashSturdyRef(parentToken));                                  // 431
  if (!parentTokenInfo) {                                                                                              // 432
    throw new Error("no such token");                                                                                  // 433
  }                                                                                                                    // 434
                                                                                                                       //
  var parentOwner = parentTokenInfo.owner || {};                                                                       // 436
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 438
  if (parentOwner.clientPowerboxRequest || parentOwner.clientPowerboxOffer) {                                          // 439
    // Saving this token should make a copy of the restored token, rather than make a child                            //
    // token.                                                                                                          //
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 443
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                //
    delete saveTemplate._id;                                                                                           // 446
    delete saveTemplate.owner;                                                                                         // 447
    delete saveTemplate.created;                                                                                       // 448
  } else {                                                                                                             // 449
    if (parentTokenInfo.identityId) {                                                                                  // 450
      // A UiView token. Need to denormalize some fields from the parent.                                              //
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 452
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         //
      // assignment.                                                                                                   //
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 456
    } else {                                                                                                           // 457
      // A non-UiView child token.                                                                                     //
      saveTemplate = {};                                                                                               // 459
    }                                                                                                                  // 460
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            //
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 463
  }                                                                                                                    // 464
                                                                                                                       //
  if (requirements) {                                                                                                  // 466
    // Append additional requirements requested by caller.                                                             //
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 468
  }                                                                                                                    // 469
                                                                                                                       //
  return saveTemplate;                                                                                                 // 471
};                                                                                                                     // 472
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 474
  function restoreInternal(_x, _x2, _x3, _x4, _x5) {                                                                   // 474
    return _restoreInternal.apply(this, arguments);                                                                    // 474
  }                                                                                                                    // 474
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 474
    return _restoreInternal.toString();                                                                                // 474
  };                                                                                                                   // 474
                                                                                                                       //
  return restoreInternal;                                                                                              // 474
}(function (originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                            // 474
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        //
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    //
  //                                                                                                                   //
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          //
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        //
  // the top-level token.                                                                                              //
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 491
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 493
    originalTokenInfo = ApiTokens.findOne(hashSturdyRef(originalToken));                                               // 494
    if (!originalTokenInfo) {                                                                                          // 495
      throw new Meteor.Error(403, "No token found to restore");                                                        // 496
    }                                                                                                                  // 497
  }                                                                                                                    // 498
                                                                                                                       //
  var token = currentTokenId ? ApiTokens.findOne(currentTokenId) : originalTokenInfo;                                  // 500
  if (!token) {                                                                                                        // 502
    if (!originalTokenInfo) {                                                                                          // 503
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 504
    }                                                                                                                  // 505
  }                                                                                                                    // 506
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 508
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 509
  }                                                                                                                    // 510
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 513
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  checkRequirements(globalDb, token.requirements);                                                                     // 516
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 519
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 520
  }                                                                                                                    // 521
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 523
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 524
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 525
    } else {                                                                                                           // 526
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 528
    }                                                                                                                  // 529
  }                                                                                                                    // 530
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 533
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);              // 536
  }                                                                                                                    // 538
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  checkRequirements(globalDb, requirements);                                                                           // 541
                                                                                                                       //
  if (token.objectId) {                                                                                                // 543
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 547
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 548
    }                                                                                                                  // 549
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 552
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // don't generate a saveTemplate here.                                                                           //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 555
    }));                                                                                                               // 556
  } else {                                                                                                             // 557
    // Construct a template ApiToken for use if the restored capability is save()d later.                              //
    var saveTemplate = makeSaveTemplateForChild(originalToken, requirements, originalTokenInfo);                       // 559
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 561
      // A token which represents a capability implemented by a pseudo-driver.                                         //
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(globalDb, saveTemplate, token.frontendRef);                          // 564
      return { cap: cap };                                                                                             // 565
    } else if (token.grainId) {                                                                                        // 566
      // It's a UiView.                                                                                                //
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          //
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  //
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     //
      // do some transformation), which will return a different capability.                                            //
      return { cap: makePersistentUiView(globalDb, saveTemplate, token.grainId) };                                     // 573
    } else {                                                                                                           // 574
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 575
    }                                                                                                                  // 576
  }                                                                                                                    // 577
});                                                                                                                    // 578
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 580
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 583
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 584
  if (!token) {                                                                                                        // 585
    return;                                                                                                            // 586
  }                                                                                                                    // 587
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 589
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 591
    var notificationId = token.frontendRef.notificationHandle;                                                         // 592
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 593
    var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                            // 594
    if (!anyToken) {                                                                                                   // 595
      // No other tokens referencing this notification exist, so dismiss the notification                              //
      _dismissNotification(notificationId);                                                                            // 597
    }                                                                                                                  // 598
  } else if (token.objectId) {                                                                                         // 599
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 600
      return supervisor.drop(token.objectId);                                                                          // 601
    }));                                                                                                               // 602
                                                                                                                       //
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 604
  } else {                                                                                                             // 605
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 606
  }                                                                                                                    // 607
}                                                                                                                      // 608
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 610
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 613
  return { core: makeSandstormCore(grainId) };                                                                         // 614
};                                                                                                                     // 615
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 617
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 618
};                                                                                                                     // 619
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 621
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        //
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        //
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       //
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          //
  // anywhere. The function returns a Promise for the result of the callback.                                          //
  //                                                                                                                   //
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         //
  // so that you don't have to do your own inMeteor() dance.)                                                          //
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          //
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         //
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         //
  //   there are multiple front-end replicas, since the capability could be on a different                             //
  //   replica.                                                                                                        //
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 637
    return inMeteor(function () {                                                                                      // 638
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 639
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 640
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   //
      ApiTokens.remove(tokenId);                                                                                       // 643
                                                                                                                       //
      for (;;) {                                                                                                       // 645
        if (!tokenInfo) throw new Error("missing token?");                                                             // 646
        if (!tokenInfo.parentToken) break;                                                                             // 647
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 648
      }                                                                                                                // 649
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 651
        throw new Error("not a " + type + " capability");                                                              // 652
      }                                                                                                                // 653
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 655
    });                                                                                                                // 656
  });                                                                                                                  // 657
};                                                                                                                     // 658
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 19
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 20
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 22
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 25
    (function () {                                                                                                     // 25
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 26
      if (expireIn < 0) {                                                                                              // 27
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 28
      }                                                                                                                // 29
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 31
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 34
      }                                                                                                                // 35
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 39
      var handle = Meteor.setTimeout(function () {                                                                     // 40
        connection.close();                                                                                            // 40
      }, expireIn);                                                                                                    // 40
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 42
        Meteor.clearTimeout(handle);                                                                                   // 42
      });                                                                                                              // 42
    })();                                                                                                              // 25
  }                                                                                                                    // 43
                                                                                                                       //
  return true;                                                                                                         // 45
});                                                                                                                    // 46
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 48
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 51
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
                                                                                                                       //
    globalDb.deleteGrains({ userId: user._id }, globalBackend, "demoGrain");                                           // 56
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 58
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 61
    UserActions.remove({ userId: user._id });                                                                          // 62
    Notifications.remove({ userId: user._id });                                                                        // 63
    Meteor.users.remove(user._id);                                                                                     // 64
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 65
    if (user.loginIdentities && user.lastActive) {                                                                     // 66
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 70
      var isAppDemoUser = !!user.appDemoId;                                                                            // 71
      if (isAppDemoUser) {                                                                                             // 72
        deleteStatsType = "appDemoUser";                                                                               // 73
      }                                                                                                                // 74
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 78
    }                                                                                                                  // 79
  });                                                                                                                  // 80
}                                                                                                                      // 81
                                                                                                                       //
if (allowDemo) {                                                                                                       // 83
  Meteor.methods({                                                                                                     // 84
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 85
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 90
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 91
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 94
      if (appDemoId) {                                                                                                 // 95
        newUser.appDemoId = appDemoId;                                                                                 // 96
      }                                                                                                                // 97
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 99
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 102
        return { userId: userId };                                                                                     // 103
      });                                                                                                              // 103
    },                                                                                                                 // 104
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 106
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 107
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 109
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 110
        throw new Meteor.Error(403, "can't exend demo");                                                               // 111
      }                                                                                                                // 112
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 114
    }                                                                                                                  // 115
  });                                                                                                                  // 84
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to information about an app by                         //
  // appId. If this were available in non-demo mode, then anonymous users could effectively ask the                    //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appDemoInfo", function (appId) {                                                                     // 121
    // This publishes info about an app, including the latest version of it. Once you log in, it                       //
    // also publishes your list of UserActions.                                                                        //
    check(appId, String);                                                                                              // 124
                                                                                                                       //
    // Get data about this app from the app index. Note that the app index cache on this server                        //
    // is typically 6-24 hours delayed from reality, so if an app is newly-available                                   //
    // in the app market, it won't be in the app index. Therefore we don't bail-out if the app                         //
    // is missing from the AppIndex collection.                                                                        //
    var appIndexData = globalDb.collections.appIndex.findOne({ appId: appId });                                        // 130
                                                                                                                       //
    // Prepare a helper function we can use to transform a package cursor into an appropriate return                   //
    // value for this function.                                                                                        //
    var packageCursorAndMaybeUserActions = function packageCursorAndMaybeUserActions(userId, appId, packageCursor) {   // 134
      // This allows us to avoid creating duplicate UserActions.                                                       //
      if (userId) {                                                                                                    // 136
        return [packageCursor, UserActions.find({ userId: userId, appId: appId })];                                    // 137
      }                                                                                                                // 141
                                                                                                                       //
      return packageCursor;                                                                                            // 143
    };                                                                                                                 // 144
                                                                                                                       //
    // If the app is in the app index, and the current version is installed, always return that. If                    //
    // that package isn't installed, store the version number so we can filter on it later.                            //
    var packageQuery = {};                                                                                             // 148
    if (appIndexData) {                                                                                                // 149
      var appIndexPackageQuery = Packages.find({ _id: appIndexData.packageId });                                       // 150
      if (appIndexPackageQuery.count() > 0) {                                                                          // 151
        return packageCursorAndMaybeUserActions(this.userId, appId, appIndexPackageQuery);                             // 152
      }                                                                                                                // 153
                                                                                                                       //
      // If the app index version isn't present, insist on a lower version than the app index                          //
      // version. This avoids accidentally catching some development version of the app that has the                   //
      // same version number as the app market version but isn't the app market version.                               //
      packageQuery["manifest.appVersion"] = { $lt: appIndexData.versionNumber };                                       // 158
    }                                                                                                                  // 159
                                                                                                                       //
    // If the specific package from the app index isn't installed, or the app isn't there at all, do                   //
    // our best.                                                                                                       //
    packageQuery.appId = appId;                                                                                        // 163
    var packageCursor = Packages.find(packageQuery, { sort: { "manifest.appVersion": -1 },                             // 164
      limit: 1                                                                                                         // 167
    });                                                                                                                // 166
    return packageCursorAndMaybeUserActions(this.userId, appId, packageCursor);                                        // 169
  });                                                                                                                  // 170
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 172
} else {                                                                                                               // 173
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 175
}                                                                                                                      // 176
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        //
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       //
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   //
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function added(doc) {                                                                                       // 43
      _this.added("desktopNotifications", doc._id, doc);                                                               // 44
    },                                                                                                                 // 45
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 47
      _this.changed("desktopNotifications", newDoc._id, newDoc);                                                       // 48
    },                                                                                                                 // 49
                                                                                                                       //
    removed: function removed(doc) {                                                                                   // 51
      _this.removed("desktopNotifications", doc._id);                                                                  // 52
    }                                                                                                                  // 53
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 20
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 26
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 27
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 28
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 29
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 36
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 39
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 46
  var signedData = buf.slice(64);                                                                                      // 47
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 49
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 50
    return undefined;                                                                                                  // 51
  } else {                                                                                                             // 52
    return signedData;                                                                                                 // 53
  }                                                                                                                    // 54
};                                                                                                                     // 55
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 58
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 62
  if (verifiedFeatureKeyBlob) {                                                                                        // 63
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 64
    if (featureKey.isForTesting && !isTesting) {                                                                       // 65
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 68
    }                                                                                                                  // 69
                                                                                                                       //
    return featureKey;                                                                                                 // 71
  } else {                                                                                                             // 72
    return undefined;                                                                                                  // 73
  }                                                                                                                    // 74
};                                                                                                                     // 75
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       // 18
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 20
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 25
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 27
  check(grainId, String);                                                                                              // 28
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 30
    _id: grainId,                                                                                                      // 32
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 33
  }, {                                                                                                                 // 31
    fields: {                                                                                                          // 38
      title: 1,                                                                                                        // 39
      userId: 1,                                                                                                       // 40
      identityId: 1,                                                                                                   // 41
      "private": 1                                                                                                     // 42
    }                                                                                                                  // 38
  })];                                                                                                                 // 37
  if (this.userId) {                                                                                                   // 46
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 47
    result.push(ApiTokens.find({                                                                                       // 48
      grainId: grainId,                                                                                                // 49
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 50
    }));                                                                                                               // 48
  }                                                                                                                    // 55
                                                                                                                       //
  return result;                                                                                                       // 57
});                                                                                                                    // 58
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 64
  check(grainId, String);                                                                                              // 65
  var publishThis = [];                                                                                                // 66
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 69
    _id: grainId,                                                                                                      // 70
    userId: this.userId                                                                                                // 71
  }, {                                                                                                                 // 69
    fields: { packageId: 1 }                                                                                           // 73
  });                                                                                                                  // 72
  publishThis.push(thisGrainCursor);                                                                                   // 75
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 77
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 78
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 79
    publishThis.push(thisPackageCursor);                                                                               // 80
  }                                                                                                                    // 81
                                                                                                                       //
  return publishThis;                                                                                                  // 83
});                                                                                                                    // 84
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 86
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 90
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 92
  var apiToken = ApiTokens.findOne({                                                                                   // 93
    _id: hashedToken                                                                                                   // 94
  }, {                                                                                                                 // 93
    fields: {                                                                                                          // 96
      grainId: 1,                                                                                                      // 97
      identityId: 1,                                                                                                   // 98
      owner: 1,                                                                                                        // 99
      revoked: 1                                                                                                       // 100
    }                                                                                                                  // 96
  });                                                                                                                  // 95
  if (!apiToken) {                                                                                                     // 103
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 104
  } else if (apiToken.revoked) {                                                                                       // 105
    this.added("tokenInfo", token, { revoked: true });                                                                 // 106
  } else {                                                                                                             // 107
    var grainId = apiToken.grainId;                                                                                    // 108
    var grain = Grains.findOne({                                                                                       // 109
      _id: grainId                                                                                                     // 110
    }, {                                                                                                               // 109
      fields: {                                                                                                        // 112
        packageId: 1,                                                                                                  // 113
        appId: 1,                                                                                                      // 114
        userId: 1                                                                                                      // 115
      }                                                                                                                // 112
    });                                                                                                                // 111
    if (!grain) {                                                                                                      // 118
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 119
    } else {                                                                                                           // 120
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 121
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 122
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 123
        if (identity && metadata) {                                                                                    // 124
          SandstormDb.fillInLoginId(identity);                                                                         // 125
          this.added("tokenInfo", token, {                                                                             // 126
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 127
            grainId: grainId,                                                                                          // 128
            grainMetadata: metadata                                                                                    // 129
          });                                                                                                          // 126
        } else {                                                                                                       // 131
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 132
        }                                                                                                              // 133
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 134
        if (this.userId) {                                                                                             // 135
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 136
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 137
          var childToken = ApiTokens.findOne({                                                                         // 138
            "owner.user.identityId": { $in: identityIds },                                                             // 139
            parentToken: apiToken._id                                                                                  // 140
          });                                                                                                          // 138
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 142
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 144
            this.ready();                                                                                              // 145
            return;                                                                                                    // 146
          }                                                                                                            // 147
        }                                                                                                              // 148
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 150
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 151
        var appIcon = undefined;                                                                                       // 152
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 153
          var icons = pkg.manifest.metadata.icons;                                                                     // 154
          appIcon = icons.grain || icons.appGrid;                                                                      // 155
        }                                                                                                              // 156
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 158
          appTitle: appTitle,                                                                                          // 159
          icon: appIcon,                                                                                               // 160
          appId: appIcon ? undefined : grain.appId                                                                     // 161
        };                                                                                                             // 158
        this.added("tokenInfo", token, {                                                                               // 163
          webkey: true,                                                                                                // 164
          grainId: grainId,                                                                                            // 165
          grainMetadata: denormalizedGrainMetadata                                                                     // 166
        });                                                                                                            // 163
      } else {                                                                                                         // 168
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 169
      }                                                                                                                // 170
    }                                                                                                                  // 171
  }                                                                                                                    // 172
                                                                                                                       //
  this.ready();                                                                                                        // 174
  return;                                                                                                              // 175
});                                                                                                                    // 176
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 178
  check(grainId, String);                                                                                              // 179
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 181
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 182
  }                                                                                                                    // 183
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 185
  if (!grain) {                                                                                                        // 186
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 187
  }                                                                                                                    // 188
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 190
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 191
  }                                                                                                                    // 193
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 195
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 196
                                                                                                                       //
  var _this = this;                                                                                                    // 199
  var query = ApiTokens.find({                                                                                         // 200
    grainId: grainId,                                                                                                  // 201
    identityId: { $in: ownerIdentityIds },                                                                             // 202
    parentToken: { $exists: false },                                                                                   // 203
    "owner.user.identityId": { $in: identityIds },                                                                     // 204
    revoked: { $ne: true }                                                                                             // 205
  });                                                                                                                  // 200
  var handle = query.observe({                                                                                         // 207
    added: function added(apiToken) {                                                                                  // 208
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 211
  });                                                                                                                  // 207
                                                                                                                       //
  this.onStop(function () {                                                                                            // 214
    return handle.stop();                                                                                              // 214
  });                                                                                                                  // 214
});                                                                                                                    // 215
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 217
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 218
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 219
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 220
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 221
});                                                                                                                    // 222
                                                                                                                       //
Meteor.methods({                                                                                                       // 224
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 225
    check(grainIds, [String]);                                                                                         // 226
                                                                                                                       //
    if (this.userId) {                                                                                                 // 228
      Grains.update({ userId: { $eq: this.userId },                                                                    // 229
        _id: { $in: grainIds },                                                                                        // 230
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 231
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 235
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 237
        "owner.user.identityId": { $in: identityIds },                                                                 // 238
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 239
    }                                                                                                                  // 242
  },                                                                                                                   // 243
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 245
    check(grainIds, [String]);                                                                                         // 246
                                                                                                                       //
    if (this.userId) {                                                                                                 // 248
      Grains.update({ userId: { $eq: this.userId },                                                                    // 249
        _id: { $in: grainIds },                                                                                        // 250
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 251
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 255
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 257
        "owner.user.identityId": { $in: identityIds },                                                                 // 258
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 259
    }                                                                                                                  // 262
  },                                                                                                                   // 263
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 265
    check(grainId, String);                                                                                            // 266
                                                                                                                       //
    if (this.userId) {                                                                                                 // 268
      var query = {                                                                                                    // 269
        _id: grainId,                                                                                                  // 270
        userId: this.userId,                                                                                           // 271
        trashed: { $exists: true }                                                                                     // 272
      };                                                                                                               // 269
      var numDeleted = globalDb.deleteGrains(query, globalBackend, isDemoUser() ? "demoGrain" : "grain");              // 274
                                                                                                                       //
      // Usually we don't automatically remove user-owned tokens that have become invalid,                             //
      // because if we did their owner might become confused as to why they have mysteriously                          //
      // disappeared. In this particular case, however, for tokens held by the grain owner,                            //
      // there should be no confusion. Indeed, it would be more confusing *not* to remove these                        //
      // tokens, because then the grain could still show up in the trash bin as a "shared with me"                     //
      // grain after the owner clicks "delete permanently".                                                            //
      //                                                                                                               //
      // Note that these tokens may be visible to other accounts if there are identities shared                        //
      // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                        //
      // case too.                                                                                                     //
      if (numDeleted > 0) {                                                                                            // 287
        globalDb.removeApiTokens({                                                                                     // 288
          grainId: grainId,                                                                                            // 289
          "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                             // 290
          "trashed": { $exists: true }                                                                                 // 291
        });                                                                                                            // 288
      }                                                                                                                // 293
    }                                                                                                                  // 294
  },                                                                                                                   // 295
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 297
    check(grainId, String);                                                                                            // 298
    check(identityId, String);                                                                                         // 299
                                                                                                                       //
    if (!this.userId) {                                                                                                // 301
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 302
    }                                                                                                                  // 303
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 305
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 306
    }                                                                                                                  // 307
                                                                                                                       //
    globalDb.removeApiTokens({ grainId: grainId,                                                                       // 309
      "owner.user.identityId": identityId,                                                                             // 310
      "trashed": { $exists: true }                                                                                     // 311
    });                                                                                                                // 309
  },                                                                                                                   // 313
                                                                                                                       //
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 315
    check(grainId, String);                                                                                            // 316
    check(identityId, String);                                                                                         // 317
    if (!this.userId) {                                                                                                // 318
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 319
    }                                                                                                                  // 320
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 322
    if (!grain.userId === this.userId) {                                                                               // 323
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 324
    }                                                                                                                  // 325
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 327
  },                                                                                                                   // 328
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 330
    check(grainId, String);                                                                                            // 331
    check(newTitle, String);                                                                                           // 332
    check(identityId, String);                                                                                         // 333
    if (this.userId) {                                                                                                 // 334
      var grain = Grains.findOne(grainId);                                                                             // 335
      if (grain) {                                                                                                     // 336
        if (grain.userId === this.userId) {                                                                            // 337
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 338
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 344
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 345
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 346
          }                                                                                                            // 347
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 349
            grainId: grainId,                                                                                          // 350
            objectId: { $exists: false },                                                                              // 351
            "owner.user.identityId": identityId                                                                        // 352
          }, {                                                                                                         // 349
            sort: { created: 1 } });                                                                                   // 354
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 356
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 357
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 360
                grainId: grainId,                                                                                      // 361
                "owner.user.identityId": identityId                                                                    // 362
              }, {                                                                                                     // 360
                $set: { "owner.user.title": newTitle },                                                                // 364
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 365
              }, {                                                                                                     // 363
                multi: true                                                                                            // 367
              });                                                                                                      // 366
            } else {                                                                                                   // 369
              var modification = {                                                                                     // 370
                "owner.user.title": newTitle,                                                                          // 371
                "owner.user.renamed": true                                                                             // 372
              };                                                                                                       // 370
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 375
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 377
              }                                                                                                        // 378
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 383
          }                                                                                                            // 384
        }                                                                                                              // 385
      }                                                                                                                // 386
    }                                                                                                                  // 387
  },                                                                                                                   // 388
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 390
    check(grainId, String);                                                                                            // 391
    if (this.userId) {                                                                                                 // 392
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 393
    }                                                                                                                  // 394
  },                                                                                                                   // 395
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 398
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 399
      var _ret = function () {                                                                                         // 399
        check(origin, String);                                                                                         // 400
        check(identityId, String);                                                                                     // 401
        check(grainId, String);                                                                                        // 402
        check(title, String);                                                                                          // 403
        check(roleAssignment, roleAssignmentPattern);                                                                  // 404
        check(contacts, [{                                                                                             // 405
          _id: String,                                                                                                 // 407
          isDefault: Match.Optional(Boolean),                                                                          // 408
          profile: Match.ObjectIncluding({                                                                             // 409
            service: String,                                                                                           // 410
            name: String,                                                                                              // 411
            intrinsicName: String                                                                                      // 412
          })                                                                                                           // 409
        }]);                                                                                                           // 406
        check(message, { text: String, html: String });                                                                // 416
        if (!_this2.userId) {                                                                                          // 417
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 418
        }                                                                                                              // 419
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 421
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 422
        }                                                                                                              // 423
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 425
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 426
        }                                                                                                              // 427
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 429
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 430
        }                                                                                                              // 431
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 433
        var outerResult = { successes: [], failures: [] };                                                             // 434
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 435
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 436
        contacts.forEach(function (contact) {                                                                          // 437
          if (contact.isDefault && contact.profile.service === "email") {                                              // 438
            var emailAddress = contact.profile.intrinsicName;                                                          // 439
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = origin + "/shared/" + result.token;                                                              // 444
            var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 450
              globalDb.incrementDailySentMailCount(accountId);                                                         // 451
              sendEmail({                                                                                              // 452
                to: emailAddress,                                                                                      // 453
                from: fromEmail,                                                                                       // 454
                replyTo: replyTo,                                                                                      // 455
                subject: title + " - Invitation to collaborate",                                                       // 456
                text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 460
              });                                                                                                      // 452
            } catch (e) {                                                                                              // 462
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 463
            }                                                                                                          // 464
          } else {                                                                                                     // 465
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = origin + "/shared/" + _result.token;                                                            // 470
            try {                                                                                                      // 471
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 472
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 473
              if (email) {                                                                                             // 475
                var intrinsicName = contact.profile.intrinsicName;                                                     // 476
                var loginNote = void 0;                                                                                // 477
                if (contact.profile.service === "google") {                                                            // 478
                  loginNote = "Google account with address " + email.email;                                            // 479
                } else if (contact.profile.service === "github") {                                                     // 480
                  loginNote = "Github account with username " + intrinsicName;                                         // 481
                } else if (contact.profile.service === "email") {                                                      // 482
                  loginNote = "email address " + intrinsicName;                                                        // 483
                } else if (contact.profile.service === "ldap") {                                                       // 484
                  loginNote = "LDAP username " + intrinsicName;                                                        // 485
                } else if (contact.profile.service === "saml") {                                                       // 486
                  loginNote = "SAML ID " + intrinsicName;                                                              // 487
                } else {                                                                                               // 488
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 489
                }                                                                                                      // 490
                                                                                                                       //
                var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 497
                sendEmail({                                                                                            // 498
                  to: email.email,                                                                                     // 499
                  from: fromEmail,                                                                                     // 500
                  replyTo: replyTo,                                                                                    // 501
                  subject: title + " - Invitation to collaborate",                                                     // 502
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 506
                });                                                                                                    // 498
              } else {                                                                                                 // 508
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 512
            } catch (e) {                                                                                              // 513
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 514
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 517
          }                                                                                                            // 518
        });                                                                                                            // 519
                                                                                                                       //
        return {                                                                                                       // 521
          v: outerResult                                                                                               // 521
        };                                                                                                             // 521
      }();                                                                                                             // 399
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 399
    }                                                                                                                  // 522
  },                                                                                                                   // 523
                                                                                                                       //
  requestAccess: function requestAccess(origin, grainId, identityId) {                                                 // 525
    check(origin, String);                                                                                             // 526
    check(grainId, String);                                                                                            // 527
    check(identityId, String);                                                                                         // 528
    if (!this.isSimulation) {                                                                                          // 529
      if (!this.userId) {                                                                                              // 530
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 531
      }                                                                                                                // 532
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 534
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 535
      }                                                                                                                // 536
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 538
      if (!grain) {                                                                                                    // 539
        throw new Meteor.Error(404, "No such grain");                                                                  // 540
      }                                                                                                                // 541
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 543
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 544
      if (!email) {                                                                                                    // 545
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 546
      }                                                                                                                // 547
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 549
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 551
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 552
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 554
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 555
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 558
      if (identity.profile.service === "google") {                                                                     // 559
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 560
      } else if (identity.profile.service === "github") {                                                              // 561
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 562
      } else if (identity.profile.service === "email") {                                                               // 563
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 564
      } else if (identity.profile.service === "ldap") {                                                                // 565
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 566
      } else if (identity.profile.service === "saml") {                                                                // 567
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 568
      }                                                                                                                // 569
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = origin + "/share/" + grainId + "/" + identityId;                                                       // 574
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 576
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 579
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 580
      var resetCount = true;                                                                                           // 581
      if (user.accessRequests) {                                                                                       // 582
        if (user.accessRequests.resetOn < new Date()) {                                                                // 583
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 584
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 585
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 589
          resetCount = false;                                                                                          // 590
        }                                                                                                              // 591
      }                                                                                                                // 592
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 594
      if (resetCount) {                                                                                                // 595
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 596
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 597
      }                                                                                                                // 598
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 600
                                                                                                                       //
      sendEmail({                                                                                                      // 602
        to: emailAddress,                                                                                              // 603
        from: fromEmail,                                                                                               // 604
        replyTo: replyTo,                                                                                              // 605
        subject: grain.title + " - Request for access",                                                                // 606
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 607
        html: html                                                                                                     // 608
      });                                                                                                              // 602
    }                                                                                                                  // 610
  }                                                                                                                    // 611
});                                                                                                                    // 224
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Capnp = Npm.require("capnp");                                                                                      // 23
                                                                                                                       // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    _classCallCheck(this, SessionContextImpl);                                                                         // 40
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    // 45
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function claimRequest(sturdyRef, requiredPermissions) {                  // 39
    var _this2 = this;                                                                                                 // 47
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 48
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 49
                                                                                                                       //
      var token = ApiTokens.findOne({                                                                                  // 51
        _id: hashedSturdyRef,                                                                                          // 52
        "owner.clientPowerboxRequest.grainId": _this2.grainId,                                                         // 53
        "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                      // 54
      });                                                                                                              // 51
                                                                                                                       //
      if (!token) {                                                                                                    // 57
        throw new Error("no such token");                                                                              // 58
      }                                                                                                                // 59
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 62
      if (token.owner.clientPowerboxRequest.introducerIdentity) {                                                      // 63
        requirements.push({                                                                                            // 64
          permissionsHeld: {                                                                                           // 65
            permissions: requiredPermissions || [],                                                                    // 66
            identityId: token.owner.clientPowerboxRequest.introducerIdentity,                                          // 67
            grainId: _this2.grainId                                                                                    // 68
          }                                                                                                            // 65
        });                                                                                                            // 64
      }                                                                                                                // 71
                                                                                                                       //
      return restoreInternal(new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ grainId: _this2.grainId }) }, requirements, token);
    });                                                                                                                // 77
  };                                                                                                                   // 78
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 39
    var _this3 = this;                                                                                                 // 80
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 81
                                                                                                                       //
      var session = Sessions.findOne({ _id: _this3.sessionId });                                                       // 83
                                                                                                                       //
      if (!session.identityId && !session.hashedToken) {                                                               // 85
        throw new Error("Session has neither an identityId nor a hashedToken.");                                       // 86
      }                                                                                                                // 87
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 89
      var apiTokenOwner = { clientPowerboxOffer: { sessionId: _this3.sessionId } };                                    // 90
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 94
        var tagValue = {};                                                                                             // 95
        if (descriptor.tags[0].value) {                                                                                // 96
          tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                  // 97
        }                                                                                                              // 98
                                                                                                                       //
        if (!tagValue.title) {                                                                                         // 100
          // TODO(someday): We should arguably throw here, but the collections app currently                           //
          //   fails to provide a title.                                                                               //
          tagValue.title = "offer()ed grain had no title";                                                             // 103
        }                                                                                                              // 104
                                                                                                                       //
        if (session.identityId) {                                                                                      // 106
          apiTokenOwner = {                                                                                            // 107
            user: {                                                                                                    // 108
              identityId: _this3.identityId,                                                                           // 109
              title: tagValue.title                                                                                    // 110
            }                                                                                                          // 108
          };                                                                                                           // 107
        }                                                                                                              // 113
      }                                                                                                                // 114
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      var permissionsHeld = {                                                                                          // 118
        grainId: _this3.grainId,                                                                                       // 119
        permissions: requiredPermissions                                                                               // 120
      };                                                                                                               // 118
                                                                                                                       //
      if (session.identityId) {                                                                                        // 123
        permissionsHeld.identityId = session.identityId;                                                               // 124
      } else if (session.hashedToken) {                                                                                // 125
        permissionsHeld.tokenId = session.hashedToken;                                                                 // 126
      } else {                                                                                                         // 127
        throw new Error("Cannot offer to anonymous session that does not have a token.");                              // 128
      }                                                                                                                // 129
                                                                                                                       //
      var requirement = { permissionsHeld: permissionsHeld };                                                          // 131
                                                                                                                       //
      checkRequirements(globalDb, [requirement]);                                                                      // 133
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 135
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 136
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 137
                                                                                                                       //
      var powerboxView = void 0;                                                                                       // 139
      if (isUiView) {                                                                                                  // 140
        if (session.identityId) {                                                                                      // 141
          // Deduplicate.                                                                                              //
          var tokenId = hashSturdyRef(sturdyRef.toString());                                                           // 143
          var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                       // 144
          var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
          dupeQuery._id = { $ne: newApiToken._id };                                                                    // 147
          dupeQuery["owner.user.identityId"] = _this3.identityId;                                                      // 148
          dupeQuery.trashed = { $exists: false };                                                                      // 149
          dupeQuery.revoked = { $exists: false };                                                                      // 150
                                                                                                                       //
          var dupeToken = ApiTokens.findOne(dupeQuery);                                                                // 152
          if (dupeToken) {                                                                                             // 153
            globalDb.removeApiTokens({ _id: tokenId });                                                                // 154
            tokenId = dupeToken._id;                                                                                   // 155
          }                                                                                                            // 156
                                                                                                                       //
          powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                  // 158
        } else {                                                                                                       // 159
          powerboxView = { offer: { uiView: { token: sturdyRef.toString() } } };                                       // 160
        }                                                                                                              // 161
      } else {                                                                                                         // 162
        powerboxView = {                                                                                               // 163
          offer: {                                                                                                     // 164
            token: sturdyRef.toString()                                                                                // 165
          }                                                                                                            // 164
        };                                                                                                             // 163
      }                                                                                                                // 168
                                                                                                                       //
      Sessions.update({ _id: _this3.sessionId }, {                                                                     // 170
        $set: {                                                                                                        // 172
          powerboxView: powerboxView                                                                                   // 173
        }                                                                                                              // 172
      });                                                                                                              // 171
    });                                                                                                                // 177
  };                                                                                                                   // 178
                                                                                                                       //
  SessionContextImpl.prototype.activity = function activity(event) {                                                   // 39
    var _this4 = this;                                                                                                 // 180
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 181
      logActivity(_this4.grainId, _this4.identityId, event);                                                           // 182
    });                                                                                                                // 183
  };                                                                                                                   // 184
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 39
}();                                                                                                                   // 39
                                                                                                                       //
Meteor.methods({                                                                                                       // 187
  finishPowerboxRequest: function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {        // 188
    check(sessionId, String);                                                                                          // 189
    check(webkeyUrl, String);                                                                                          // 190
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 191
    check(identityId, String);                                                                                         // 192
    check(grainId, String);                                                                                            // 193
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 195
    if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                    // 196
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 197
    }                                                                                                                  // 198
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 200
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 201
    if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                    // 202
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 205
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 207
    if (!token) {                                                                                                      // 208
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 211
                                                                                                                       //
    token = token.slice(1);                                                                                            // 213
    if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                      // 214
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 218
    }                                                                                                                  // 219
                                                                                                                       //
    var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;       // 221
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 223
    var owner = {                                                                                                      // 224
      clientPowerboxRequest: {                                                                                         // 225
        grainId: grainId,                                                                                              // 226
        introducerIdentity: identityId,                                                                                // 227
        sessionId: sessionId                                                                                           // 228
      }                                                                                                                // 225
    };                                                                                                                 // 224
    if (saveLabel) {                                                                                                   // 231
      grainOwner.saveLabel = {                                                                                         // 232
        defaultText: saveLabel                                                                                         // 233
      };                                                                                                               // 232
    }                                                                                                                  // 235
                                                                                                                       //
    var save = castedCap.save(owner);                                                                                  // 237
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 238
    return sturdyRef.toString();                                                                                       // 239
  },                                                                                                                   // 240
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 242
    check(sessionId, String);                                                                                          // 243
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 245
  },                                                                                                                   // 246
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 248
    check(apiTokenId, String);                                                                                         // 249
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 250
    if (!token) {                                                                                                      // 251
      throw new Meteor.Error(400, "No such token.");                                                                   // 252
    }                                                                                                                  // 253
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 255
    if (!grain) {                                                                                                      // 256
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 257
    }                                                                                                                  // 258
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 260
  }                                                                                                                    // 261
});                                                                                                                    // 187
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 264
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 264
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 265
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 265
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 265
  }                                                                                                                    // 267
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 264
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 274
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 276
      if (!grain) throw new Error("Grain does not exist.");                                                            // 277
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 279
        this.publicId = grain.publicId;                                                                                // 280
      } else {                                                                                                         // 281
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 283
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 285
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 287
          continue;                                                                                                    // 289
        }                                                                                                              // 290
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 297
        }                                                                                                              // 298
      }                                                                                                                // 299
    }                                                                                                                  // 300
                                                                                                                       //
    return this.publicId;                                                                                              // 302
  };                                                                                                                   // 303
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 264
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 310
  };                                                                                                                   // 311
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 264
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 318
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 320
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 322
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 323
                                                                                                                       //
    var result = {};                                                                                                   // 325
    if (email) {                                                                                                       // 326
      result.address = email;                                                                                          // 327
    }                                                                                                                  // 328
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 330
      result.name = identity.profile.name;                                                                             // 331
    }                                                                                                                  // 332
                                                                                                                       //
    return result;                                                                                                     // 334
  };                                                                                                                   // 335
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 264
    return hackSendEmail(this, email);                                                                                 // 338
  };                                                                                                                   // 339
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 264
    return inMeteor(function () {                                                                                      // 342
      var result = {};                                                                                                 // 343
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 345
      result.hostname = HOSTNAME;                                                                                      // 346
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 347
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 349
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 350
                                                                                                                       //
      return result;                                                                                                   // 352
    }.bind(this));                                                                                                     // 353
  };                                                                                                                   // 354
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 264
    var _this = this;                                                                                                  // 357
    var session = _this;                                                                                               // 358
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 360
      var requestMethod = Http.request;                                                                                // 361
      if (url.indexOf("https://") === 0) {                                                                             // 362
        requestMethod = Https.request;                                                                                 // 363
      } else if (url.indexOf("http://") !== 0) {                                                                       // 364
        err = new Error("Protocol not recognized.");                                                                   // 365
        err.nature = "precondition";                                                                                   // 366
        reject(err);                                                                                                   // 367
      }                                                                                                                // 368
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 370
        var buffers = [];                                                                                              // 371
        var err = void 0;                                                                                              // 372
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 374
          case 2:                                                                                                      // 375
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 376
              buffers.push(buf);                                                                                       // 377
            });                                                                                                        // 378
                                                                                                                       //
            resp.on("end", function () {                                                                               // 380
              resolve({                                                                                                // 381
                content: Buffer.concat(buffers),                                                                       // 382
                mimeType: resp.headers["content-type"] || null                                                         // 383
              });                                                                                                      // 381
            });                                                                                                        // 385
            break;                                                                                                     // 386
          case 3:                                                                                                      // 387
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 388
            break;                                                                                                     // 389
          case 4:                                                                                                      // 390
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 391
            err.nature = "precondition";                                                                               // 392
            reject(err);                                                                                               // 393
            break;                                                                                                     // 394
          case 5:                                                                                                      // 395
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 396
            err.nature = "localBug";                                                                                   // 397
            reject(err);                                                                                               // 398
            break;                                                                                                     // 399
          default:                                                                                                     // 400
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 401
            err.nature = "localBug";                                                                                   // 402
            reject(err);                                                                                               // 403
            break;                                                                                                     // 404
        }                                                                                                              // 374
      });                                                                                                              // 406
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 408
        e.nature = "networkFailure";                                                                                   // 409
        reject(e);                                                                                                     // 410
      });                                                                                                              // 411
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 413
        req.abort();                                                                                                   // 414
        err = new Error("Request timed out.");                                                                         // 415
        err.nature = "localBug";                                                                                       // 416
        err.durability = "overloaded";                                                                                 // 417
        reject(err);                                                                                                   // 418
      });                                                                                                              // 419
                                                                                                                       //
      req.end();                                                                                                       // 421
    });                                                                                                                // 422
  };                                                                                                                   // 423
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 264
    return inMeteor(function () {                                                                                      // 426
      return this._getUserAddress();                                                                                   // 427
    }.bind(this));                                                                                                     // 428
  };                                                                                                                   // 429
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 432
  };                                                                                                                   // 433
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 264
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 436
  };                                                                                                                   // 437
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 264
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 440
  };                                                                                                                   // 441
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 264
    var parsedUrl = Url.parse(url);                                                                                    // 444
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 446
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname) {                                                                                        // 447
        throw new Error("Webkey urls cannot contain a path.");                                                         // 448
      }                                                                                                                // 449
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 451
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 452
      if (hostId && globalDb.isApiHostId(hostId)) {                                                                    // 453
        // Connecting to a local capability.                                                                           //
        return getWrappedUiViewForToken(token);                                                                        // 455
      } else {                                                                                                         // 456
        // Connecting to a remote server with a bearer token.                                                          //
        // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                           //
        return { view: new ExternalUiView(url, this.grainId, token) };                                                 // 459
      }                                                                                                                // 460
    } else {                                                                                                           // 461
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 462
    }                                                                                                                  // 463
  };                                                                                                                   // 464
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 264
}(SessionContextImpl);                                                                                                 // 264
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 467
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 468
};                                                                                                                     // 470
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 472
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 474
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 477
  for (var i = 0; i < length; i++) {                                                                                   // 478
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 479
  }                                                                                                                    // 480
                                                                                                                       //
  return digits.join("");                                                                                              // 482
};                                                                                                                     // 483
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
                                                                                                                       // 19
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 22
    _classCallCheck(this, IdentityImpl);                                                                               // 22
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 22
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 24
    return _this;                                                                                                      // 22
  }                                                                                                                    // 25
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 26
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requriements) {                                                       // 28
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 29
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 30
};                                                                                                                     // 32
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 34
  frontendRefField: "identity",                                                                                        // 35
                                                                                                                       //
  restore: function restore(db, saveTemplate, identityId) {                                                            // 37
    return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);       // 38
  }                                                                                                                    // 40
});                                                                                                                    // 34
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 19
  defaultText: String,                                                                                                 // 20
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 21
};                                                                                                                     // 19
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 24
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 29
  cancelDownload: function (_cancelDownload) {                                                                         // 30
    function cancelDownload(_x) {                                                                                      // 30
      return _cancelDownload.apply(this, arguments);                                                                   // 30
    }                                                                                                                  // 30
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 30
      return _cancelDownload.toString();                                                                               // 30
    };                                                                                                                 // 30
                                                                                                                       //
    return cancelDownload;                                                                                             // 30
  }(function (packageId) {                                                                                             // 30
    check(packageId, String);                                                                                          // 31
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 34
  }),                                                                                                                  // 35
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 37
    if (!isSignedUp()) {                                                                                               // 38
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 39
    }                                                                                                                  // 40
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 42
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 46
    uploadTokens[token] = setTimeout(function () {                                                                     // 47
      delete uploadTokens[token];                                                                                      // 48
    }, 20 * 60 * 1000);                                                                                                // 49
                                                                                                                       //
    return token;                                                                                                      // 51
  },                                                                                                                   // 52
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 54
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 55
  },                                                                                                                   // 56
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 58
    check(packageId, String);                                                                                          // 59
    check(url, Match.OneOf(String, undefined, null));                                                                  // 60
    check(isRetry, Boolean);                                                                                           // 61
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 63
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 64
    }                                                                                                                  // 65
                                                                                                                       //
    if (!this.userId) {                                                                                                // 67
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 68
        // continue on                                                                                                 //
      } else {                                                                                                         // 70
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 71
        }                                                                                                              // 72
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 73
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 74
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 76
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 77
    }                                                                                                                  // 79
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 81
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 83
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 84
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 85
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 89
      }                                                                                                                // 90
    }                                                                                                                  // 91
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 93
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 94
    }                                                                                                                  // 95
  }                                                                                                                    // 96
});                                                                                                                    // 29
                                                                                                                       //
Meteor.publish("packageInfo", function (packageId) {                                                                   // 99
  check(packageId, String);                                                                                            // 100
  var db = this.connection.sandstormDb;                                                                                // 101
  var pkgCursor = db.collections.packages.find(packageId);                                                             // 102
  var pkg = pkgCursor.fetch()[0];                                                                                      // 103
  if (pkg && this.userId) {                                                                                            // 104
    return [pkgCursor, db.collections.userActions.find({ userId: this.userId, appId: pkg.appId }), db.collections.grains.find({ userId: this.userId, appId: pkg.appId })];
  } else {                                                                                                             // 110
    return pkgCursor;                                                                                                  // 111
  }                                                                                                                    // 112
});                                                                                                                    // 113
                                                                                                                       //
Router.map(function () {                                                                                               // 115
  this.route("upload", {                                                                                               // 116
    where: "server",                                                                                                   // 117
    path: "/upload/:token",                                                                                            // 118
                                                                                                                       //
    action: function action() {                                                                                        // 120
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 121
        this.response.writeHead(403, {                                                                                 // 122
          "Content-Type": "text/plain"                                                                                 // 123
        });                                                                                                            // 122
        this.response.write("Invalid upload token.");                                                                  // 125
        this.response.end();                                                                                           // 126
      } else if (this.request.method === "POST") {                                                                     // 127
        try {                                                                                                          // 128
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 129
          this.response.writeHead(200, {                                                                               // 130
            "Content-Length": packageId.length,                                                                        // 131
            "Content-Type": "text/plain"                                                                               // 132
          });                                                                                                          // 130
          this.response.write(packageId);                                                                              // 134
          this.response.end();                                                                                         // 135
          clearTimeout(uploadTokens[this.params.token]);                                                               // 136
          delete uploadTokens[this.params.token];                                                                      // 137
        } catch (error) {                                                                                              // 138
          console.error(error.stack);                                                                                  // 139
          this.response.writeHead(500, {                                                                               // 140
            "Content-Type": "text/plain"                                                                               // 141
          });                                                                                                          // 140
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 143
          this.response.end();                                                                                         // 144
        };                                                                                                             // 145
      } else {                                                                                                         // 146
        this.response.writeHead(405, {                                                                                 // 147
          "Content-Type": "text/plain"                                                                                 // 148
        });                                                                                                            // 147
        this.response.write("You can only POST here.");                                                                // 150
        this.response.end();                                                                                           // 151
      }                                                                                                                // 152
    }                                                                                                                  // 153
  });                                                                                                                  // 116
});                                                                                                                    // 155
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 27
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 29
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 36
  if (Meteor.settings.replicaNumber) {                                                                                 // 37
    throw new Error("This can only be called on the main front-end replica.");                                         // 38
  }                                                                                                                    // 39
};                                                                                                                     // 40
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 42
  verifyIsMainReplica();                                                                                               // 43
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 45
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 47
    return;                                                                                                            // 48
  }                                                                                                                    // 49
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 51
                                                                                                                       //
  try {                                                                                                                // 53
    var action = UserActions.findOne({ packageId: packageId });                                                        // 54
    var grain = Grains.findOne({ packageId: packageId });                                                              // 55
    var notificationQuery = {};                                                                                        // 56
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 57
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery)) && !globalDb.getAppIdForPreinstalledPackage(packageId)) {
      Packages.update({                                                                                                // 60
        _id: packageId                                                                                                 // 61
      }, {                                                                                                             // 60
        $set: { status: "delete" },                                                                                    // 63
        $unset: { shouldCleanup: "" }                                                                                  // 64
      });                                                                                                              // 62
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 66
      Packages.remove(packageId);                                                                                      // 67
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 70
        globalDb.unrefStaticAsset(assetId);                                                                            // 71
      });                                                                                                              // 72
    } else {                                                                                                           // 73
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 74
    }                                                                                                                  // 75
                                                                                                                       //
    delete installers[packageId];                                                                                      // 77
  } catch (error) {                                                                                                    // 78
    delete installers[packageId];                                                                                      // 79
    throw error;                                                                                                       // 80
  }                                                                                                                    // 81
};                                                                                                                     // 82
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 84
  verifyIsMainReplica();                                                                                               // 85
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 87
    return;                                                                                                            // 88
  }                                                                                                                    // 89
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 91
  installers[pkg._id] = installer;                                                                                     // 92
  installer.start();                                                                                                   // 93
};                                                                                                                     // 94
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 96
  Packages.remove({ _id: packageId, status: "download" });                                                             // 97
};                                                                                                                     // 98
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 100
  verifyIsMainReplica();                                                                                               // 101
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 103
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 106
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 108
      throw new Error("Canceled");                                                                                     // 109
    })();                                                                                                              // 110
  }                                                                                                                    // 111
};                                                                                                                     // 112
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 114
  installers = {};                                                                                                     // 115
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 117
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 119
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 122
      added: startInstallInternal,                                                                                     // 123
      removed: cancelDownloadInternal                                                                                  // 124
    });                                                                                                                // 122
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 128
      added: deletePackageInternal                                                                                     // 129
    });                                                                                                                // 128
  });                                                                                                                  // 131
}                                                                                                                      // 132
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 134
  return new Promise(function (resolve, reject) {                                                                      // 135
    var id = Random.id();                                                                                              // 136
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 138
    var hasher = Crypto.createHash("sha256");                                                                          // 139
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 141
      try {                                                                                                            // 142
        hasher.update(chunk);                                                                                          // 143
        backendStream.write(chunk);                                                                                    // 144
      } catch (err) {                                                                                                  // 145
        reject(err);                                                                                                   // 146
      }                                                                                                                // 147
    });                                                                                                                // 148
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 150
      try {                                                                                                            // 151
        (function () {                                                                                                 // 151
          backendStream.done();                                                                                        // 152
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 153
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 154
            return packageId;                                                                                          // 155
          }));                                                                                                         // 156
          backendStream.close();                                                                                       // 157
        })();                                                                                                          // 151
      } catch (err) {                                                                                                  // 158
        reject(err);                                                                                                   // 159
      }                                                                                                                // 160
    });                                                                                                                // 161
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 163
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 165
        backendStream.close();                                                                                         // 166
        reject(err);                                                                                                   // 167
      } catch (err2) {                                                                                                 // 168
        reject(err2);                                                                                                  // 169
      }                                                                                                                // 170
    });                                                                                                                // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
AppInstaller = function () {                                                                                           // 175
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 176
    _classCallCheck(this, AppInstaller);                                                                               // 176
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 177
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 179
    this.url = url;                                                                                                    // 180
    this.failed = false;                                                                                               // 181
    this.appId = appId;                                                                                                // 182
    this.isAutoUpdated = isAutoUpdated;                                                                                // 183
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 186
  }                                                                                                                    // 187
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 175
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 196
    this.progress = progress || -1;                                                                                    // 197
    this.error = error;                                                                                                // 198
    this.manifest = manifest || null;                                                                                  // 199
                                                                                                                       //
    var _this = this;                                                                                                  // 201
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 206
      return inMeteor(function () {                                                                                    // 207
        if (manifest) extractManifestAssets(manifest);                                                                 // 208
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 210
          $set: {                                                                                                      // 211
            status: _this.status,                                                                                      // 212
            progress: _this.progress,                                                                                  // 213
            error: _this.error ? _this.error.message : null,                                                           // 214
            manifest: _this.manifest,                                                                                  // 215
            appId: _this.appId,                                                                                        // 216
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 217
          }                                                                                                            // 211
        });                                                                                                            // 210
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 221
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 222
        }                                                                                                              // 223
      })["catch"](function (err) {                                                                                     // 224
        console.error(err.stack);                                                                                      // 225
      });                                                                                                              // 226
    });                                                                                                                // 227
  };                                                                                                                   // 228
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 175
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 233
    return function () {                                                                                               // 234
      if (_this.failed) return;                                                                                        // 235
      try {                                                                                                            // 236
        return method.apply(_this, _.toArray(arguments));                                                              // 237
      } catch (err) {                                                                                                  // 238
        _this.failed = true;                                                                                           // 239
        _this.cleanup();                                                                                               // 240
        _this.updateProgress("failed", 0, err);                                                                        // 241
        _this.writeChain = _this.writeChain.then(function () {                                                         // 242
          delete installers[_this.packageId];                                                                          // 243
        });                                                                                                            // 244
        console.error("Failed to install app:", err.stack);                                                            // 245
      }                                                                                                                // 246
    };                                                                                                                 // 247
  };                                                                                                                   // 248
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 175
    if (this.uploadStream) {                                                                                           // 251
      try {                                                                                                            // 252
        this.uploadStream.close();                                                                                     // 253
      } catch (err) {}                                                                                                 // 254
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 256
    }                                                                                                                  // 257
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 259
      try {                                                                                                            // 260
        this.downloadRequest.abort();                                                                                  // 261
      } catch (err) {}                                                                                                 // 262
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 264
    }                                                                                                                  // 265
  };                                                                                                                   // 266
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 175
    var _this2 = this;                                                                                                 // 268
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 269
      _this2.cleanup();                                                                                                // 270
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 272
        if (info.appId) {                                                                                              // 273
          _this2.appId = info.appId;                                                                                   // 274
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 275
          _this2.done(info.manifest);                                                                                  // 276
        } else {                                                                                                       // 277
          _this2.doDownload();                                                                                         // 278
        }                                                                                                              // 279
      }), _this2.wrapCallback(function (err) {                                                                         // 280
        throw err;                                                                                                     // 281
      }));                                                                                                             // 282
    })();                                                                                                              // 283
  };                                                                                                                   // 284
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 175
    if (!this.url) {                                                                                                   // 287
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 288
    }                                                                                                                  // 289
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 291
    this.updateProgress("download");                                                                                   // 292
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 294
    return this.doDownloadTo(this.uploadStream);                                                                       // 295
  };                                                                                                                   // 296
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 175
    var _this3 = this;                                                                                                 // 298
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 299
    var options = {                                                                                                    // 300
      hostname: url.hostname,                                                                                          // 301
      port: url.port,                                                                                                  // 302
      path: url.path                                                                                                   // 303
    };                                                                                                                 // 300
                                                                                                                       //
    var protocol = void 0;                                                                                             // 306
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 307
      protocol = Request.defaults({                                                                                    // 308
        maxRedirects: 20,                                                                                              // 309
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 315
      });                                                                                                              // 308
    } else {                                                                                                           // 317
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 318
    }                                                                                                                  // 319
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 323
    var bytesReceived = 0;                                                                                             // 324
    var hasher = Crypto.createHash("sha256");                                                                          // 325
    var done = false;                                                                                                  // 326
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 327
      if (!done) {                                                                                                     // 328
        if (bytesExpected) {                                                                                           // 329
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 330
        } else {                                                                                                       // 331
          _this3.updateProgress("download", bytesReceived);                                                            // 332
        }                                                                                                              // 333
      }                                                                                                                // 334
    }), 500);                                                                                                          // 335
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 337
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 339
      if ("content-length" in response.headers) {                                                                      // 340
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 341
      }                                                                                                                // 342
    }));                                                                                                               // 343
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 345
      hasher.update(chunk);                                                                                            // 346
      out.write(chunk);                                                                                                // 347
      bytesReceived += chunk.length;                                                                                   // 348
      updateDownloadProgress();                                                                                        // 349
    }));                                                                                                               // 350
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 352
      out.done();                                                                                                      // 353
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 355
        throw new Error("Package hash did not match.");                                                                // 356
      }                                                                                                                // 357
                                                                                                                       //
      done = true;                                                                                                     // 359
      delete _this3.downloadRequest;                                                                                   // 360
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 362
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 363
        _this3.appId = info.appId;                                                                                     // 364
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 365
        _this3.done(info.manifest);                                                                                    // 366
      }), _this3.wrapCallback(function (err) {                                                                         // 367
        throw err;                                                                                                     // 368
      }));                                                                                                             // 369
    }));                                                                                                               // 370
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 372
      throw err;                                                                                                       // 372
    }));                                                                                                               // 372
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 374
  };                                                                                                                   // 375
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 175
    console.log("App ready:", this.packageId);                                                                         // 378
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 379
    var _this = this;                                                                                                  // 380
    _this.writeChain = _this.writeChain.then(function () {                                                             // 381
      return inMeteor(function () {                                                                                    // 382
        if (_this.isAutoUpdated) {                                                                                     // 383
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 387
                                                                                                                       //
        if (globalDb.getPackageIdForPreinstalledApp(_this.appId) && globalDb.collections.appIndex.findOne({            // 389
          _id: _this.appId,                                                                                            // 391
          packageId: _this.packageId                                                                                   // 392
        })) {                                                                                                          // 390
          // Only mark app as preinstall ready if its appId is in the preinstalledApps setting                         //
          // and if it's the latest package version in the appIndex. The updateAppIndex function                       //
          // will always trigger updates of preinstalled apps, even if a concurrent download of                        //
          // an older package is going on.                                                                             //
          globalDb.setPreinstallAppAsReady(_this.appId, _this.packageId);                                              // 398
        }                                                                                                              // 399
      });                                                                                                              // 400
    }).then(function () {                                                                                              // 401
      delete installers[_this.packageId];                                                                              // 402
    });                                                                                                                // 403
  };                                                                                                                   // 404
                                                                                                                       //
  return AppInstaller;                                                                                                 // 175
}();                                                                                                                   // 175
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 407
  var metadata = manifest.metadata;                                                                                    // 408
  if (!metadata) return;                                                                                               // 409
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 411
  if (icons) {                                                                                                         // 412
    var handleIcon = function handleIcon(icon) {                                                                       // 413
      if (icon.svg) {                                                                                                  // 414
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 415
        icon.format = "svg";                                                                                           // 416
        delete icon.svg;                                                                                               // 417
        return true;                                                                                                   // 418
      } else if (icon.png) {                                                                                           // 419
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 421
        if (!normalDpi) return false;                                                                                  // 422
        icon.format = "png";                                                                                           // 423
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 424
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 426
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 428
        }                                                                                                              // 429
                                                                                                                       //
        delete icon.png;                                                                                               // 431
        return true;                                                                                                   // 432
      } else {                                                                                                         // 433
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 435
      }                                                                                                                // 436
    };                                                                                                                 // 437
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 439
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 440
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 443
    if (icons.marketBig) delete icons.marketBig;                                                                       // 444
  }                                                                                                                    // 445
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 447
    if (text.defaultText) {                                                                                            // 448
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 449
      delete text.defaultText;                                                                                         // 450
    }                                                                                                                  // 451
                                                                                                                       //
    if (text.localizations) {                                                                                          // 453
      text.localizations.forEach(function (localization) {                                                             // 454
        if (localization.text) {                                                                                       // 455
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 456
          delete localization.text;                                                                                    // 458
        }                                                                                                              // 459
      });                                                                                                              // 460
    }                                                                                                                  // 461
  };                                                                                                                   // 462
                                                                                                                       //
  var license = metadata.license;                                                                                      // 464
  if (license) {                                                                                                       // 465
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 466
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 467
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 468
  }                                                                                                                    // 469
                                                                                                                       //
  var author = metadata.author;                                                                                        // 471
  if (author) {                                                                                                        // 472
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 474
  }                                                                                                                    // 475
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 478
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 481
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 484
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 487
};                                                                                                                     // 488
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 490
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 493
  if (!metadata) return [];                                                                                            // 494
                                                                                                                       //
  var result = [];                                                                                                     // 496
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 498
  if (icons) {                                                                                                         // 499
    var handleIcon = function handleIcon(icon) {                                                                       // 500
      if (icon.assetId) {                                                                                              // 501
        result.push(icon.assetId);                                                                                     // 502
      }                                                                                                                // 503
    };                                                                                                                 // 504
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 506
    if (icons.grain) handleIcon(icons.grain);                                                                          // 507
  }                                                                                                                    // 508
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 510
    if (text.defaultTextAssetId) {                                                                                     // 511
      result.push(defaultTextAssetId);                                                                                 // 512
    }                                                                                                                  // 513
                                                                                                                       //
    if (text.localizations) {                                                                                          // 515
      text.localizations.forEach(function (localization) {                                                             // 516
        if (localization.assetId) {                                                                                    // 517
          result.push(localization.assetId);                                                                           // 518
        }                                                                                                              // 519
      });                                                                                                              // 520
    }                                                                                                                  // 521
  };                                                                                                                   // 522
                                                                                                                       //
  var license = metadata.license;                                                                                      // 524
  if (license) {                                                                                                       // 525
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 526
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 527
    if (license.notices) handleLocalizedText(license.notices);                                                         // 528
  }                                                                                                                    // 529
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 531
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 532
                                                                                                                       //
  return result;                                                                                                       // 534
};                                                                                                                     // 535
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":["/imports/server/desktop-notifications.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var createAppActivityDesktopNotification;module.import("/imports/server/desktop-notifications.js",{"createAppActivityDesktopNotification":function(v){createAppActivityDesktopNotification=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 19
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 20
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 21
                                                                                                                       //
logActivity = function logActivity(grainId, identityId, event) {                                                       // 23
  check(grainId, String);                                                                                              // 24
  check(identityId, String);                                                                                           // 25
  // `event` is always an ActivityEvent parsed from Cap'n Proto buf that's too complicated to check                    //
  // here.                                                                                                             //
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          //
  //   here, rather than looking it up every time.                                                                     //
  grain = Grains.findOne(grainId);                                                                                     // 31
  if (!grain) {                                                                                                        // 32
    // Shouldn't be possible since activity events come from the grain.                                                //
    throw new Error("no such grain");                                                                                  // 34
  }                                                                                                                    // 35
                                                                                                                       //
  // Look up the event typedef.                                                                                        //
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 38
  if (!eventType) {                                                                                                    // 39
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 40
  }                                                                                                                    // 41
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 43
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           //
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    //
    if (identityId != grain.identityId) {                                                                              // 46
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 47
    }                                                                                                                  // 48
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        //
    ApiTokens.update({                                                                                                 // 51
      "grainId": grainId,                                                                                              // 52
      "owner.user.seenAllActivity": true,                                                                              // 53
      "owner.user.identityId": { $ne: identityId }                                                                     // 54
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 51
  }                                                                                                                    // 56
                                                                                                                       //
  // Apply auto-subscriptions.                                                                                         //
  if (eventType.autoSubscribeToGrain) {                                                                                // 59
    globalDb.subscribeToActivity(identityId, grainId);                                                                 // 60
  }                                                                                                                    // 61
                                                                                                                       //
  if (event.thread && eventType.autoSubscribeToThread) {                                                               // 63
    globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                        // 64
  }                                                                                                                    // 65
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                //
  var notifyMap = {};                                                                                                  // 68
  var addRecipient = function addRecipient(recipient) {                                                                // 69
    // Mutes take priority over subscriptions.                                                                         //
    if (recipient.mute) {                                                                                              // 71
      notifyMap[identityId] = false;                                                                                   // 72
    } else {                                                                                                           // 73
      if (!(recipient.identityId in notifyMap)) {                                                                      // 74
        notifyMap[recipient.identityId] = true;                                                                        // 75
      }                                                                                                                // 76
    }                                                                                                                  // 77
  };                                                                                                                   // 78
                                                                                                                       //
  // Don't notify self.                                                                                                //
  addRecipient({ identityId: identityId, mute: true });                                                                // 81
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   //
  if (eventType.notifySubscribers) {                                                                                   // 84
    // The grain owner is implicitly subscribed.                                                                       //
    addRecipient({ identityId: grain.identityId });                                                                    // 86
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           //
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 89
                                                                                                                       //
    if (event.thread) {                                                                                                // 91
      // Add everyone subscribed to the thread.                                                                        //
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 93
    }                                                                                                                  // 94
  }                                                                                                                    // 95
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    //
  if (event.users && event.users.length > 0) {                                                                         // 98
    (function () {                                                                                                     // 98
      var promises = [];                                                                                               // 99
      event.users.forEach(function (user) {                                                                            // 100
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 101
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 102
            addRecipient({ identityId: targetId });                                                                    // 103
          }));                                                                                                         // 104
        }                                                                                                              // 105
      });                                                                                                              // 106
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 107
        return undefined;                                                                                              // 107
      }));                                                                                                             // 107
    })();                                                                                                              // 98
  }                                                                                                                    // 108
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                //
  var notify = [];                                                                                                     // 111
  for (var _identityId in notifyMap) {                                                                                 // 112
    if (notifyMap[_identityId]) {                                                                                      // 113
      notify.push(_identityId);                                                                                        // 114
    }                                                                                                                  // 115
  }                                                                                                                    // 116
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 118
    (function () {                                                                                                     // 118
      var notification = {                                                                                             // 119
        grainId: grainId,                                                                                              // 120
        path: event.path || ""                                                                                         // 121
      };                                                                                                               // 119
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  //
      var update = {                                                                                                   // 125
        isUnread: true,                                                                                                // 126
        timestamp: new Date()                                                                                          // 127
      };                                                                                                               // 125
                                                                                                                       //
      if (event.thread) {                                                                                              // 130
        notification.threadPath = event.thread.path || "";                                                             // 131
      }                                                                                                                // 132
                                                                                                                       //
      if (identityId) {                                                                                                // 134
        notification.initiatingIdentity = identityId;                                                                  // 135
      }                                                                                                                // 136
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 138
      update.text = eventType.verbPhrase;                                                                              // 139
                                                                                                                       //
      // Look up icon urls for the responsible identity and the app                                                    //
      var identity = Meteor.users.findOne({ _id: identityId });                                                        // 142
      if (!identity) {                                                                                                 // 143
        throw new Error("no such identity");                                                                           // 144
      }                                                                                                                // 145
                                                                                                                       //
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 147
      SandstormDb.fillInPictureUrl(identity);                                                                          // 148
                                                                                                                       //
      var body = event.notification && event.notification.caption || { defaultText: "" };                              // 150
                                                                                                                       //
      var appActivity = {                                                                                              // 152
        user: {                                                                                                        // 153
          identityId: identity._id,                                                                                    // 154
          name: identity.profile.name,                                                                                 // 155
          avatarUrl: identity.profile.pictureUrl || ""                                                                 // 156
        },                                                                                                             // 153
        grainId: notification.grainId,                                                                                 // 158
        path: notification.path,                                                                                       // 159
        body: body,                                                                                                    // 160
        actionText: eventType.verbPhrase                                                                               // 161
      };                                                                                                               // 152
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 164
        // Notify all accounts connected with this identity.                                                           //
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          // We need to know the ID of the inserted/updated document so we can embed it in the                         //
          // desktop notification to bind them.                                                                        //
          var idIfInserted = Random.id(17);                                                                            // 172
          var result = Notifications.findAndModify({                                                                   // 173
            query: _.extend({ userId: account._id }, notification),                                                    // 174
            update: {                                                                                                  // 175
              $set: update,                                                                                            // 176
              $inc: { count: 1 },                                                                                      // 177
              $setOnInsert: {                                                                                          // 178
                _id: idIfInserted                                                                                      // 179
              }                                                                                                        // 178
            },                                                                                                         // 175
            upsert: true                                                                                               // 182
          });                                                                                                          // 173
                                                                                                                       //
          if (!result.ok) {                                                                                            // 185
            console.error("Couldn't create notification!", result.lastErrorObject);                                    // 186
            return;                                                                                                    // 187
          }                                                                                                            // 188
                                                                                                                       //
          var notificationId = result.value._id || idIfInserted;                                                       // 190
                                                                                                                       //
          var desktopNotification = {                                                                                  // 192
            userId: account._id,                                                                                       // 193
            notificationId: notificationId,                                                                            // 194
            appActivity: appActivity                                                                                   // 195
          };                                                                                                           // 192
                                                                                                                       //
          createAppActivityDesktopNotification(desktopNotification);                                                   // 198
        });                                                                                                            // 199
      });                                                                                                              // 200
    })();                                                                                                              // 118
  }                                                                                                                    // 201
};                                                                                                                     // 202
                                                                                                                       //
Meteor.methods({                                                                                                       // 204
  testNotifications: function testNotifications() {                                                                    // 205
    // Deliver a test notification of each non-grain-initiated type to the user.                                       //
    if (!this.userId) return;                                                                                          // 207
                                                                                                                       //
    Notifications.insert({                                                                                             // 209
      admin: {                                                                                                         // 210
        action: "/admin/stats",                                                                                        // 211
        type: "reportStats"                                                                                            // 212
      },                                                                                                               // 210
      userId: this.userId,                                                                                             // 214
      text: { defaultText: "You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info." },
      timestamp: new Date(),                                                                                           // 217
      isUnread: true                                                                                                   // 218
    });                                                                                                                // 209
                                                                                                                       //
    Notifications.insert({                                                                                             // 221
      userId: this.userId,                                                                                             // 222
      referral: true,                                                                                                  // 223
      timestamp: new Date(),                                                                                           // 224
      isUnread: true                                                                                                   // 225
    });                                                                                                                // 221
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 228
      Notifications.insert({                                                                                           // 229
        userId: this.userId,                                                                                           // 230
        mailingListBonus: true,                                                                                        // 231
        timestamp: new Date(),                                                                                         // 232
        isUnread: true                                                                                                 // 233
      });                                                                                                              // 229
    }                                                                                                                  // 235
  }                                                                                                                    // 236
});                                                                                                                    // 204
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 239
  return Notifications.find({ userId: this.userId });                                                                  // 240
});                                                                                                                    // 241
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 243
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 246
  var notifications = Notifications.find({                                                                             // 247
    _id: { $in: notificationIds },                                                                                     // 248
    userId: this.userId                                                                                                // 249
  }, {                                                                                                                 // 247
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 251
  });                                                                                                                  // 250
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 254
    return row.grainId;                                                                                                // 255
  }).filter(function (x) {                                                                                             // 256
    return x;                                                                                                          // 256
  });                                                                                                                  // 256
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 258
    return row.initiatingIdentity;                                                                                     // 259
  }).filter(function (x) {                                                                                             // 260
    return x;                                                                                                          // 260
  });                                                                                                                  // 260
                                                                                                                       //
  return [Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];                                // 262
});                                                                                                                    // 265
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Future = Npm.require("fibers/future");                                                                             // 23
var Http = Npm.require("http");                                                                                        // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 26
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 28
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 31
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 32
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 34
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 38
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 44
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 47
}                                                                                                                      // 48
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 52
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 54
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 56
  return function (request, response) {                                                                                // 57
    var path = request.url;                                                                                            // 58
                                                                                                                       //
    // If a directory, open "index.html".                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 61
      path = path + "index.html";                                                                                      // 62
    }                                                                                                                  // 63
                                                                                                                       //
    // Strip leading "/".                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 66
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 69
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 71
    var charset = mime.charsets.lookup(type);                                                                          // 72
    if (charset) {                                                                                                     // 73
      type = type + "; charset=" + charset;                                                                            // 74
    } else if (type === "application/json") {                                                                          // 75
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 77
    }                                                                                                                  // 78
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 83
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 84
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 96
    }                                                                                                                  // 97
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 99
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 105
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 107
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 108
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 110
        if (status === "file") {                                                                                       // 111
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 113
            stream.sendingDirectResponse();                                                                            // 114
            response.writeHead(303, {                                                                                  // 115
              "Content-Type": "text/plain",                                                                            // 116
              "Location": "/" + path + "/",                                                                            // 117
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 118
            });                                                                                                        // 115
            response.end("redirect: /" + path + "/");                                                                  // 120
          } else if (status === "notFound") {                                                                          // 121
            stream.sendingDirectResponse();                                                                            // 122
            response.writeHead(404, {                                                                                  // 123
              "Content-Type": "text/plain"                                                                             // 124
            });                                                                                                        // 123
            response.end("404 not found: /" + path);                                                                   // 126
          } else {                                                                                                     // 127
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 128
            stream.sendingDirectResponse();                                                                            // 129
            response.writeHead(500, {                                                                                  // 130
              "Content-Type": "text/plain"                                                                             // 131
            });                                                                                                        // 130
            response.end("Internal server error");                                                                     // 133
          }                                                                                                            // 134
                                                                                                                       //
        streamCap.close();                                                                                             // 136
      });                                                                                                              // 137
    })["catch"](function (err) {                                                                                       // 138
      console.error(err.stack);                                                                                        // 139
      streamCap.close();                                                                                               // 140
    });                                                                                                                // 141
  };                                                                                                                   // 142
}                                                                                                                      // 143
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 145
  var status = 500;                                                                                                    // 146
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 147
    status = err.error;                                                                                                // 149
  } else if (err.httpErrorCode) {                                                                                      // 150
    status = err.httpErrorCode;                                                                                        // 151
  }                                                                                                                    // 152
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 155
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 157
  res.end(err.htmlMessage || err.message);                                                                             // 158
}                                                                                                                      // 159
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 161
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 162
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 164
  if (buf.length < magic.length) return false;                                                                         // 165
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 167
    if (buf[i] != magic[i]) return false;                                                                              // 168
  }                                                                                                                    // 169
                                                                                                                       //
  return true;                                                                                                         // 171
}                                                                                                                      // 172
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 174
  try {                                                                                                                // 175
    if (req.method === "GET" && req.url === "/") {                                                                     // 176
      var content = new Buffer("Self-test OK.");                                                                       // 178
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 181
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 182
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 183
      }                                                                                                                // 184
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 186
        "Content-Type": "text/plain",                                                                                  // 187
        "Content-Length": content.length,                                                                              // 188
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 189
      });                                                                                                              // 186
      res.end(content);                                                                                                // 191
    } else {                                                                                                           // 192
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 193
      res.end("Bad request to self-test subdomain.");                                                                  // 194
      return;                                                                                                          // 195
    }                                                                                                                  // 196
  } catch (err) {                                                                                                      // 197
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 198
  }                                                                                                                    // 199
}                                                                                                                      // 200
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 202
  inMeteor(function () {                                                                                               // 203
    if (req.method === "GET") {                                                                                        // 204
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 205
      if (req.headers["if-none-match"] === "permanent") {                                                              // 206
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 208
          "Cache-Control": "public, max-age=31536000",                                                                 // 209
          "ETag": "permanent",                                                                                         // 210
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          "Content-Security-Policy": assetCspHeader,                                                                   // 213
          "Access-Control-Allow-Origin": "*",                                                                          // 214
          "X-Content-Type-Options": "nosniff"                                                                          // 215
        });                                                                                                            // 208
        res.end();                                                                                                     // 217
        return;                                                                                                        // 218
      }                                                                                                                // 219
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 221
      var pathname = url.pathname.slice(1);                                                                            // 222
      var asset = void 0;                                                                                              // 223
      if (pathname.startsWith("identicon/")) {                                                                         // 224
        var size = parseInt((url.query || {}).s);                                                                      // 225
        asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                    // 226
      } else if (pathname.indexOf("/") == -1) {                                                                        // 227
        asset = globalDb.getStaticAsset(pathname);                                                                     // 228
      }                                                                                                                // 229
                                                                                                                       //
      if (asset) {                                                                                                     // 231
        var headers = {                                                                                                // 232
          "Content-Type": asset.mimeType,                                                                              // 233
          "Content-Length": asset.content.length,                                                                      // 234
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          "Cache-Control": "public, max-age=31536000",                                                                 // 237
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          "ETag": "permanent",                                                                                         // 240
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          "Content-Security-Policy": assetCspHeader,                                                                   // 247
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          "Access-Control-Allow-Origin": "*",                                                                          // 252
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          "X-Content-Type-Options": "nosniff"                                                                          // 255
        };                                                                                                             // 232
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 258
          headers["Content-Encoding"] = asset.encoding;                                                                // 259
        }                                                                                                              // 260
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 262
        res.end(asset.content);                                                                                        // 263
      } else {                                                                                                         // 264
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 265
        res.end("not found");                                                                                          // 266
      }                                                                                                                // 267
    } else if (req.method === "POST") {                                                                                // 268
      var _ret = function () {                                                                                         // 268
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 269
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 271
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 272
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              //
        if (!purpose) {                                                                                                // 275
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 276
          res.end("Upload token not found or expired.");                                                               // 277
          return {                                                                                                     // 278
            v: void 0                                                                                                  // 278
          };                                                                                                           // 278
        } else if (purpose.profilePicture) {                                                                           // 279
          var userId = purpose.profilePicture.userId;                                                                  // 280
          var identityId = purpose.profilePicture.identityId;                                                          // 281
          check(userId, String);                                                                                       // 282
          check(identityId, String);                                                                                   // 283
        } else if (purpose.loginLogo) {                                                                                // 284
          // no additional fields for loginLogo                                                                        //
        } else {                                                                                                       // 286
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 287
            res.end("Found invalid purpose for upload");                                                               // 288
            return {                                                                                                   // 289
              v: void 0                                                                                                // 289
            };                                                                                                         // 289
          }                                                                                                            // 290
                                                                                                                       //
        var buffers = [];                                                                                              // 292
        var totalSize = 0;                                                                                             // 293
        var done = new Future();                                                                                       // 294
        req.on("data", function (buf) {                                                                                // 295
          totalSize += buf.length;                                                                                     // 296
          if (totalSize <= 64 * 1024) {                                                                                // 297
            buffers.push(buf);                                                                                         // 298
          }                                                                                                            // 299
        });                                                                                                            // 300
        req.on("end", done["return"].bind(done));                                                                      // 301
        req.on("error", done["throw"].bind(done));                                                                     // 302
        done.wait();                                                                                                   // 303
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 305
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 307
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 308
          return {                                                                                                     // 309
            v: void 0                                                                                                  // 309
          };                                                                                                           // 309
        }                                                                                                              // 310
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 312
        var type = void 0;                                                                                             // 313
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 314
          type = "image/png";                                                                                          // 315
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 316
          type = "image/jpeg";                                                                                         // 317
        } else {                                                                                                       // 318
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 319
          res.end("Image must be PNG or JPEG.");                                                                       // 320
          return {                                                                                                     // 321
            v: void 0                                                                                                  // 321
          };                                                                                                           // 321
        }                                                                                                              // 322
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 324
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 326
          var _identityId = purpose.profilePicture.identityId;                                                         // 327
          var result = Meteor.users.findAndModify({                                                                    // 328
            query: { _id: _identityId },                                                                               // 329
            update: { $set: { "profile.picture": assetId } },                                                          // 330
            fields: { "profile.picture": 1 }                                                                           // 331
          });                                                                                                          // 328
                                                                                                                       //
          if (result.ok) {                                                                                             // 334
            var old = result.value;                                                                                    // 335
            if (old && old.profile && old.profile.picture) {                                                           // 336
              globalDb.unrefStaticAsset(old.profile.picture);                                                          // 337
            }                                                                                                          // 338
          } else {                                                                                                     // 339
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 340
            res.end("Couldn't update profile picture.");                                                               // 341
            return {                                                                                                   // 342
              v: void 0                                                                                                // 342
            };                                                                                                         // 342
          }                                                                                                            // 343
        } else if (purpose.loginLogo) {                                                                                // 344
          var _result = globalDb.collections.settings.findAndModify({                                                  // 345
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 346
            update: {                                                                                                  // 347
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 348
              $set: { value: assetId }                                                                                 // 349
            },                                                                                                         // 347
            upsert: true,                                                                                              // 351
            fields: { value: 1 }                                                                                       // 352
          });                                                                                                          // 345
                                                                                                                       //
          if (_result.ok) {                                                                                            // 355
            var _old = _result.value;                                                                                  // 356
            if (_old && _old.value) {                                                                                  // 357
              globalDb.unrefStaticAsset(_old.value);                                                                   // 358
            }                                                                                                          // 359
          } else {                                                                                                     // 360
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 361
            res.end("Couldn't update login logo.");                                                                    // 362
            return {                                                                                                   // 363
              v: void 0                                                                                                // 363
            };                                                                                                         // 363
          }                                                                                                            // 364
        }                                                                                                              // 365
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 367
        res.end();                                                                                                     // 368
      }();                                                                                                             // 268
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 268
    } else if (req.method === "OPTIONS") {                                                                             // 369
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 370
      if (requestedHeaders) {                                                                                          // 371
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 372
      }                                                                                                                // 373
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 375
        "Access-Control-Allow-Origin": "*",                                                                            // 376
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 377
        "Access-Control-Max-Age": "3600"                                                                               // 378
      });                                                                                                              // 375
      res.end();                                                                                                       // 380
    } else {                                                                                                           // 381
      res.writeHead(405, "Method Not Allowed", {                                                                       // 382
        "Allow": "GET, POST, OPTIONS",                                                                                 // 383
        "Content-Type": "text/plain"                                                                                   // 384
      });                                                                                                              // 382
      res.end("405 Method Not Allowed: " + req.method);                                                                // 386
    }                                                                                                                  // 387
  })["catch"](function (err) {                                                                                         // 388
    writeErrorResponse(res, err);                                                                                      // 389
  });                                                                                                                  // 390
}                                                                                                                      // 391
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 393
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     //
  // redirect.                                                                                                         //
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 396
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      //
  // hostname.                                                                                                         //
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 400
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        //
  // string parameters, if provided.                                                                                   //
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 404
  return targetUrl;                                                                                                    // 405
};                                                                                                                     // 406
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 408
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       //
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       //
  // request directly.                                                                                                 //
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 413
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 415
  // See if the request was for a host in the wildcard.                                                                //
  var id = matchWildcardHost(req.headers.host);                                                                        // 417
  if (id) {                                                                                                            // 418
    // Match!                                                                                                          //
    if (redirectIfInWildcard) {                                                                                        // 420
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 421
      res.end();                                                                                                       // 422
      return;                                                                                                          // 423
    }                                                                                                                  // 424
                                                                                                                       //
    if (id === "static") {                                                                                             // 426
      // Static assets domain.                                                                                         //
      serveStaticAsset(req, res);                                                                                      // 428
      return;                                                                                                          // 429
    }                                                                                                                  // 430
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 432
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       //
      // publishing wildcard hosts.                                                                                    //
      serveSelfTest(req, res);                                                                                         // 435
      return;                                                                                                          // 436
    }                                                                                                                  // 437
                                                                                                                       //
    // Try to route the request to a session.                                                                          //
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 440
      if (handled) {                                                                                                   // 441
        return null;                                                                                                   // 442
      } else {                                                                                                         // 443
        return id;                                                                                                     // 444
      }                                                                                                                // 445
    });                                                                                                                // 446
  } else {                                                                                                             // 447
    // Not a wildcard host. Perhaps it is a custom host.                                                               //
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 449
  }                                                                                                                    // 450
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 452
    if (publicId) {                                                                                                    // 453
      return Promise.resolve(undefined).then(function () {                                                             // 454
        var handler = webPublishingHandlers[publicId];                                                                 // 455
        if (handler) {                                                                                                 // 456
          return handler;                                                                                              // 457
        } else {                                                                                                       // 458
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 //
          return inMeteor(function () {                                                                                // 460
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 461
            if (!grain) {                                                                                              // 462
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 463
            }                                                                                                          // 464
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 466
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 467
          });                                                                                                          // 468
        }                                                                                                              // 469
      }).then(function (handler) {                                                                                     // 470
        handler(req, res);                                                                                             // 471
      });                                                                                                              // 472
    } else {                                                                                                           // 473
      // Already handled by tryProxyRequest above, no further action needed.                                           //
      return Promise.resolve(undefined);                                                                               // 475
    }                                                                                                                  // 476
  })["catch"](function (err) {                                                                                         // 477
    writeErrorResponse(res, err);                                                                                      // 478
  });                                                                                                                  // 479
};                                                                                                                     // 480
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       //
// port.                                                                                                               //
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 484
  handleNonMeteorRequest(req, res, next, false);                                                                       // 485
};                                                                                                                     // 486
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 //
// They are handled as follows:                                                                                        //
//                                                                                                                     //
// * Requests to the shell & grains, we redirect to the main port.                                                     //
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     //
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    //
//                                                                                                                     //
// Alternate ports are bound to FD #5 and higher.                                                                      //
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 496
  var numPorts = process.env.PORT.split(",").length;                                                                   // 497
  var numAlternatePorts = numPorts - 1;                                                                                // 498
  return numAlternatePorts;                                                                                            // 499
};                                                                                                                     // 500
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 502
  try {                                                                                                                // 503
    if (!req.headers.host) {                                                                                           // 504
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 505
      res.end("Missing Host header");                                                                                  // 506
      return;                                                                                                          // 507
    }                                                                                                                  // 508
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 //
    var hostname = req.headers.host.split(":")[0];                                                                     // 511
    if (isSandstormShell(hostname)) {                                                                                  // 512
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 513
      res.end();                                                                                                       // 514
      return;                                                                                                          // 515
    }                                                                                                                  // 516
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 518
  } catch (e) {                                                                                                        // 519
    // This should never be reached, because all the request handlers should be catching                               //
    // exceptions, but you can never be too careful in a top-level request handler.                                    //
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 522
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 523
    res.end("Unhandled exception: " + e.stack);                                                                        // 524
  }                                                                                                                    // 525
};                                                                                                                     // 526
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 528
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 529
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 531
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 532
  }                                                                                                                    // 533
};                                                                                                                     // 534
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 536
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 537
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          //
  var nonMeteorRequestHandler = connect();                                                                             // 540
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 542
    // Have to check with global, because it could be undefined.                                                       //
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 543
  }                                                                                                                    // 544
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 546
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 548
  WebApp.httpServer.on("request", function (req, res) {                                                                // 549
    try {                                                                                                              // 550
      if (!req.headers.host) {                                                                                         // 551
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 552
        res.end("Missing Host header");                                                                                // 553
        return;                                                                                                        // 554
      }                                                                                                                // 555
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0];                                                                   // 557
      if (isSandstormShell(hostname)) {                                                                                // 558
        // If destined for the DDP host or the main host, pass on to Meteor                                            //
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 560
          meteorRequestListeners[i](req, res);                                                                         // 561
        }                                                                                                              // 562
      } else {                                                                                                         // 563
        // Otherwise, dispatch to our own middleware proxy chain.                                                      //
        nonMeteorRequestHandler(req, res);                                                                             // 565
        // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                                   //
        WebApp._timeoutAdjustmentRequestCallback(req, res);                                                            // 567
      }                                                                                                                // 568
    } catch (e) {                                                                                                      // 569
      // This should never be reached, because all the request handlers should be catching                             //
      // exceptions, but you can never be too careful in a top-level request handler.                                  //
      console.err("Unhandled exception in request handler:", e.stack);                                                 // 572
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 573
      res.end("Unhandled exception: " + e.stack);                                                                      // 574
    }                                                                                                                  // 575
  });                                                                                                                  // 576
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 578
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 579
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 581
    Promise.resolve(undefined).then(function () {                                                                      // 582
      if (!req.headers.host) {                                                                                         // 583
        throw new Meteor.Error(400, "Missing Host header");                                                            // 584
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 585
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 587
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 588
        }                                                                                                              // 589
                                                                                                                       //
        return true;                                                                                                   // 591
      } else {                                                                                                         // 592
        var id = matchWildcardHost(req.headers.host);                                                                  // 593
        if (id) {                                                                                                      // 594
          return tryProxyUpgrade(id, req, socket, head);                                                               // 595
        } else {                                                                                                       // 596
          return false;                                                                                                // 597
        }                                                                                                              // 598
      }                                                                                                                // 599
    }).then(function (handled) {                                                                                       // 600
      if (!handled) socket.destroy();                                                                                  // 601
    })["catch"](function (err) {                                                                                       // 602
      console.error("WebSocket event handler failed:", err.stack);                                                     // 603
      socket.destroy();                                                                                                // 604
    });                                                                                                                // 605
  });                                                                                                                  // 606
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 608
});                                                                                                                    // 609
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 611
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 617
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 624
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 638
  if (cache && Date.now() < cache.expiration) {                                                                        // 639
    return Promise.resolve(cache.value);                                                                               // 640
  }                                                                                                                    // 641
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 643
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 644
      if (err) {                                                                                                       // 645
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 646
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 647
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 668
        reject(error);                                                                                                 // 669
      } else if (records.length !== 1) {                                                                               // 670
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 671
      } else {                                                                                                         // 672
        // Under node 0.12+, `records` is an array-of-arrays. Each sub-array contains "chunks" of a                    //
        // record, which should be joined.                                                                             //
        var result = records[0].join("");                                                                              // 675
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 676
        resolve(result);                                                                                               // 677
      }                                                                                                                // 678
    });                                                                                                                // 679
  });                                                                                                                  // 680
}                                                                                                                      // 681
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Crypto = Npm.require("crypto");                                                                                    // 19
var ChildProcess = Npm.require("child_process");                                                                       // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Path = Npm.require("path");                                                                                        // 22
var Future = Npm.require("fibers/future");                                                                             // 23
var Http = Npm.require("http");                                                                                        // 24
var Url = Npm.require("url");                                                                                          // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var Net = Npm.require("net");                                                                                          // 27
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 29
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 30
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 31
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 32
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 33
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 34
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 39
  check(identityId, String);                                                                                           // 40
  check(apiTokenAccountId, String);                                                                                    // 41
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 44
    return;                                                                                                            // 45
  }                                                                                                                    // 46
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 48
  var bobAccountId = accountId;                                                                                        // 49
  var bobIdentityId = identityId;                                                                                      // 50
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 52
    _id: bobAccountId,                                                                                                 // 53
    referredByComplete: { $exists: true }                                                                              // 54
  }).count() > 0) {                                                                                                    // 52
    return;                                                                                                            // 56
  }                                                                                                                    // 57
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 63
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 65
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        //
  if (!db.isReferralEnabled()) {                                                                                       // 81
    return;                                                                                                            // 82
  }                                                                                                                    // 83
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 86
    return;                                                                                                            // 87
  }                                                                                                                    // 88
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 91
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 92
    _id: { $in: bobIdentityIds },                                                                                      // 93
    referredBy: { $exists: true }                                                                                      // 94
  });                                                                                                                  // 92
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 97
    return;                                                                                                            // 98
  }                                                                                                                    // 99
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 101
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 104
  Meteor.users.update({                                                                                                // 105
    _id: bobAccountId,                                                                                                 // 106
    referredByComplete: { $exists: false }                                                                             // 107
  }, {                                                                                                                 // 105
    $set: {                                                                                                            // 109
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 110
      referredCompleteDate: now                                                                                        // 111
    }                                                                                                                  // 109
  });                                                                                                                  // 108
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 116
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 117
  });                                                                                                                  // 116
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 121
    $unset: { referredBy: true }                                                                                       // 122
  });                                                                                                                  // 121
}                                                                                                                      // 124
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 127
    var _this2 = this;                                                                                                 // 127
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 127
                                                                                                                       //
    this._headers = {};                                                                                                // 128
    this._prefixes = [];                                                                                               // 129
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 131
      if (pattern.endsWith("*")) {                                                                                     // 132
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 133
      } else {                                                                                                         // 134
        _this2._headers[pattern] = true;                                                                               // 135
      }                                                                                                                // 136
    });                                                                                                                // 137
  }                                                                                                                    // 138
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function matches(header) {                                                       //
    header = header.toLowerCase();                                                                                     // 141
    if (this._headers[header]) return true;                                                                            // 142
                                                                                                                       //
    for (var i in this._prefixes) {                                                                                    // 144
      if (header.startsWith(this._prefixes[i])) {                                                                      // 145
        return true;                                                                                                   // 146
      }                                                                                                                // 147
    };                                                                                                                 // 148
                                                                                                                       //
    return false;                                                                                                      // 150
  };                                                                                                                   // 151
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 154
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 155
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 170
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 172
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 174
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 175
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 176
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 177
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 181
Meteor.onConnection(function (connection) {                                                                            // 182
  connection.sandstormBackend = globalBackend;                                                                         // 183
});                                                                                                                    // 184
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 193
var disconnectCount = 0;                                                                                               // 194
Meteor.setInterval(function () {                                                                                       // 195
  if (!backendHealthy) {                                                                                               // 196
    if (disconnectCount++ > 2) process.abort();                                                                        // 197
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 198
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 199
    sandstormBackendConnection.close();                                                                                // 200
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 201
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 202
    globalBackend._backendCap = sandstormBackend;                                                                      // 203
  }                                                                                                                    // 204
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 206
  backendHealthy = false;                                                                                              // 207
  var promise = sandstormBackend.ping().then(function () {                                                             // 208
    backendHealthy = true;                                                                                             // 209
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 210
  }, function (err) {                                                                                                  // 211
    console.error("error: Backend ping threw error!", err.stack);                                                      // 212
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 216
                                                                                                                       //
  if (debugLog) {                                                                                                      // 218
    console.log("capnp.js: outer promise:", promise);                                                                  // 219
  }                                                                                                                    // 220
}, 30000);                                                                                                             // 221
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 227
  callback();                                                                                                          // 228
});                                                                                                                    // 229
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 231
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 233
    inMeteorInternal(function () {                                                                                     // 234
      try {                                                                                                            // 235
        resolve(callback());                                                                                           // 236
      } catch (err) {                                                                                                  // 237
        reject(err);                                                                                                   // 238
      }                                                                                                                // 239
    });                                                                                                                // 240
  });                                                                                                                  // 241
};                                                                                                                     // 242
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 244
  var result = new Future();                                                                                           // 245
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 246
  return result;                                                                                                       // 247
};                                                                                                                     // 248
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 250
  return promiseToFuture(promise).wait();                                                                              // 251
};                                                                                                                     // 252
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 257
                                                                                                                       //
Meteor.methods({                                                                                                       // 259
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 260
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 263
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 264
    check(title, String);                                                                                              // 265
    check(identityId, String);                                                                                         // 266
                                                                                                                       //
    if (!this.userId) {                                                                                                // 268
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 269
    }                                                                                                                  // 270
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 272
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 273
    }                                                                                                                  // 274
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 276
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 277
    }                                                                                                                  // 279
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 281
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 282
    }                                                                                                                  // 284
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 286
    var isDev = false;                                                                                                 // 287
    if (!pkg) {                                                                                                        // 288
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 290
      isDev = true;                                                                                                    // 291
    }                                                                                                                  // 292
                                                                                                                       //
    if (!pkg) {                                                                                                        // 294
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 295
    }                                                                                                                  // 296
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 298
    var manifest = pkg.manifest;                                                                                       // 299
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 300
    Grains.insert({                                                                                                    // 301
      _id: grainId,                                                                                                    // 302
      packageId: packageId,                                                                                            // 303
      appId: appId,                                                                                                    // 304
      appVersion: manifest.appVersion,                                                                                 // 305
      userId: this.userId,                                                                                             // 306
      identityId: identityId,                                                                                          // 307
      title: title,                                                                                                    // 308
      "private": true,                                                                                                 // 309
      size: 0                                                                                                          // 310
    });                                                                                                                // 301
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                           // 313
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 314
    return grainId;                                                                                                    // 315
  },                                                                                                                   // 316
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 318
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 322
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 323
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 324
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 326
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 327
    }                                                                                                                  // 328
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 330
    if (!grain) {                                                                                                      // 331
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 332
    } else if (grain.trashed) {                                                                                        // 333
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 334
    }                                                                                                                  // 335
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 337
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 338
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 339
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 341
    }                                                                                                                  // 342
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 344
    var result = opened.methodResult;                                                                                  // 346
    var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 349
    return result;                                                                                                     // 350
  },                                                                                                                   // 351
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt) {                          // 353
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
                                                                                                                       //
    check(params, {                                                                                                    // 357
      token: String,                                                                                                   // 358
      incognito: Boolean                                                                                               // 359
    });                                                                                                                // 357
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 361
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 362
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 364
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 365
    }                                                                                                                  // 366
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 368
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 371
                                                                                                                       //
    var token = params.token;                                                                                          // 373
    var incognito = params.incognito;                                                                                  // 374
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 375
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 376
    validateWebkey(apiToken);                                                                                          // 377
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 378
    if (!grain) {                                                                                                      // 379
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 380
    }                                                                                                                  // 381
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 383
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 384
    }                                                                                                                  // 385
                                                                                                                       //
    var title = void 0;                                                                                                // 387
    if (grain.userId === apiToken.accountId) {                                                                         // 388
      title = grain.title;                                                                                             // 389
    } else {                                                                                                           // 390
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 391
        grainId: apiToken.grainId,                                                                                     // 393
        "owner.user.identityId": apiToken.identityId                                                                   // 394
      }, {                                                                                                             // 392
        sort: {                                                                                                        // 396
          lastUsed: -1                                                                                                 // 397
        }                                                                                                              // 396
      });                                                                                                              // 395
      if (sharerToken) {                                                                                               // 400
        title = sharerToken.owner.user.title;                                                                          // 401
      } else {                                                                                                         // 402
        title = "shared grain";                                                                                        // 403
      }                                                                                                                // 404
    }                                                                                                                  // 405
                                                                                                                       //
    if (this.userId && !incognito) {                                                                                   // 407
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 410
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname || "redeemed webkey", { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 417
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 423
          var parentApiToken = result.parentApiToken;                                                                  // 424
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 425
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 428
        }                                                                                                              // 429
      }                                                                                                                // 430
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 432
    } else {                                                                                                           // 433
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 434
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 435
      }                                                                                                                // 437
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);       // 439
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 442
      var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 446
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 447
      return _result;                                                                                                  // 448
    }                                                                                                                  // 449
  },                                                                                                                   // 450
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 452
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 455
                                                                                                                       //
    var result = Sessions.findAndModify({                                                                              // 457
      query: { _id: sessionId },                                                                                       // 458
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 459
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 460
    });                                                                                                                // 457
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 463
      return false;                                                                                                    // 464
    }                                                                                                                  // 465
                                                                                                                       //
    var session = result.value;                                                                                        // 467
    if (session) {                                                                                                     // 468
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 470
        var grainId = session.grainId;                                                                                 // 471
        var hostId = session.hostId;                                                                                   // 472
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 473
        if (!supervisor) {                                                                                             // 474
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 475
        }                                                                                                              // 476
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 478
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 479
      } catch (err) {                                                                                                  // 480
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 483
          throw err;                                                                                                   // 484
        }                                                                                                              // 485
      }                                                                                                                // 486
                                                                                                                       //
      return true;                                                                                                     // 488
    } else {                                                                                                           // 489
      return false;                                                                                                    // 490
    }                                                                                                                  // 491
  },                                                                                                                   // 492
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 494
    check(grainId, String);                                                                                            // 495
    var grain = Grains.findOne(grainId);                                                                               // 496
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 497
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 498
    }                                                                                                                  // 499
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 501
  }                                                                                                                    // 502
});                                                                                                                    // 259
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 505
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 510
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 511
  }                                                                                                                    // 512
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 514
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 515
  }                                                                                                                    // 516
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 518
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 519
  }                                                                                                                    // 520
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 522
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 523
  }                                                                                                                    // 524
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 526
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 527
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 528
    } else if (refreshedExpiration) {                                                                                  // 529
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 530
    } else {                                                                                                           // 531
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 533
    }                                                                                                                  // 534
  }                                                                                                                    // 535
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 537
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 538
  }                                                                                                                    // 539
};                                                                                                                     // 540
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 542
  var shutdownApp = function shutdownApp(appId) {                                                                      // 543
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 544
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 545
    });                                                                                                                // 546
  };                                                                                                                   // 547
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 549
    removed: function removed(devPackage) {                                                                            // 550
      shutdownApp(devPackage.appId);                                                                                   // 550
    },                                                                                                                 // 550
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 552
      shutdownApp(oldDevPackage.appId);                                                                                // 553
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 554
        shutdownApp(newDevPackage.appId);                                                                              // 555
      }                                                                                                                // 556
    },                                                                                                                 // 557
    added: function added(devPackage) {                                                                                // 559
      shutdownApp(devPackage.appId);                                                                                   // 559
    }                                                                                                                  // 559
  });                                                                                                                  // 549
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 562
    removed: function removed(session) {                                                                               // 563
      var proxy = proxiesByHostId[session.hostId];                                                                     // 564
      delete proxiesByHostId[session.hostId];                                                                          // 565
      if (proxy) {                                                                                                     // 566
        proxy.close();                                                                                                 // 567
      }                                                                                                                // 568
    }                                                                                                                  // 569
  });                                                                                                                  // 562
});                                                                                                                    // 571
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 574
var gcSessions = function gcSessions() {                                                                               // 575
  var now = new Date().getTime();                                                                                      // 576
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 577
};                                                                                                                     // 578
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 580
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 582
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 587
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 589
    var proxy = proxiesByHostId[hostId];                                                                               // 590
    if (proxy) {                                                                                                       // 591
      return proxy;                                                                                                    // 592
    } else {                                                                                                           // 593
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 595
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 597
        var session = Sessions.findOne({ hostId: hostId });                                                            // 598
        if (!session) {                                                                                                // 599
          if (isAlreadyOpened) {                                                                                       // 600
            var _ret = function () {                                                                                   // 600
              var observer = void 0;                                                                                   // 601
              return {                                                                                                 // 602
                v: new Promise(function (resolve, reject) {                                                            // 602
                  var task = Meteor.setTimeout(function () {                                                           // 603
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 609
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 610
                    added: function added() {                                                                          // 611
                      Meteor.clearTimeout(task);                                                                       // 612
                      resolve(getProxyForHostId(hostId, false));                                                       // 613
                    }                                                                                                  // 614
                  });                                                                                                  // 610
                }).then(function (v) {                                                                                 // 616
                  observer.stop();                                                                                     // 617
                  return v;                                                                                            // 618
                }, function (e) {                                                                                      // 619
                  observer.stop();                                                                                     // 620
                  throw e;                                                                                             // 621
                })                                                                                                     // 622
              };                                                                                                       // 602
            }();                                                                                                       // 600
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 600
          } else {                                                                                                     // 623
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 625
          }                                                                                                            // 626
        }                                                                                                              // 627
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 629
        if (session.hashedToken) {                                                                                     // 630
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 631
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 634
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 635
          }                                                                                                            // 636
        }                                                                                                              // 637
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 639
        if (!grain) {                                                                                                  // 640
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 642
        }                                                                                                              // 643
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 650
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 654
          proxiesByHostId[hostId] = proxy;                                                                             // 655
        } else {                                                                                                       // 656
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 657
        }                                                                                                              // 658
                                                                                                                       //
        return proxy;                                                                                                  // 660
      });                                                                                                              // 661
    }                                                                                                                  // 662
  });                                                                                                                  // 663
};                                                                                                                     // 664
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 679
    var _this3 = this;                                                                                                 // 679
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 679
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 680
    this.newBucket = {};                                                                                               // 681
    this.oldBucket = {};                                                                                               // 682
    this.interval = Meteor.setInterval(function () {                                                                   // 683
      for (var oldHashedToken in _this3.oldBucket) {                                                                   // 684
        for (var oldHashedParams in _this3.oldBucket[oldHashedToken]) {                                                // 685
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 686
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 688
          if (oldProxy && !newProxy) {                                                                                 // 689
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 690
              // A client has an open websocket. Keep the proxy around.                                                //
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 692
            } else {                                                                                                   // 693
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 695
            }                                                                                                          // 696
          }                                                                                                            // 697
        }                                                                                                              // 698
      }                                                                                                                // 699
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 701
      _this3.newBucket = {};                                                                                           // 702
    }, intervalMillis);                                                                                                // 703
  }                                                                                                                    // 704
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 707
      return this.newBucket[hashedToken][hashedParams];                                                                // 708
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 709
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 710
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 711
      this.put(hashedToken, hashedParams, proxy);                                                                      // 712
      return proxy;                                                                                                    // 713
    } else {                                                                                                           // 714
      return null;                                                                                                     // 715
    }                                                                                                                  // 716
  };                                                                                                                   // 717
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 720
      this.newBucket[hashedToken] = {};                                                                                // 721
    }                                                                                                                  // 722
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 724
  };                                                                                                                   // 725
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 728
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 729
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 730
      }                                                                                                                // 731
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 733
    }                                                                                                                  // 734
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 736
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 737
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 738
      }                                                                                                                // 739
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 741
    }                                                                                                                  // 742
  };                                                                                                                   // 743
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 746
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 748
  Grains.find().observe({                                                                                              // 749
    changed: function changed(newGrain, oldGrain) {                                                                    // 750
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 751
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 752
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 753
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 754
        });                                                                                                            // 755
      }                                                                                                                // 756
    }                                                                                                                  // 757
  });                                                                                                                  // 749
});                                                                                                                    // 759
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 761
  var params = {};                                                                                                     // 762
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 763
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 764
      return s.trim();                                                                                                 // 766
    });                                                                                                                // 766
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 770
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 774
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 775
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 778
      }                                                                                                                // 779
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 781
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 786
          return parseInt(x, 10);                                                                                      // 787
        }).reduce(function (a, b) {                                                                                    // 787
          return 256 * a + b;                                                                                          // 788
        });                                                                                                            // 788
        params.remoteAddress = {                                                                                       // 789
          lower64: v4Int,                                                                                              // 790
          upper64: 0                                                                                                   // 791
        };                                                                                                             // 789
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 793
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 797
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 800
          groups.shift();                                                                                              // 801
        }                                                                                                              // 802
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 804
          groups.pop();                                                                                                // 805
        }                                                                                                              // 806
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 808
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 811
          groups.pop();                                                                                                // 812
          var quad = lastGroup.split(".").map(function (x) {                                                           // 813
            return parseInt(x, 10);                                                                                    // 813
          });                                                                                                          // 813
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 814
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 815
        }                                                                                                              // 816
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 818
        var emptyGroupIndex = groups.indexOf("");                                                                      // 819
        var cleanGroups = void 0;                                                                                      // 820
        if (emptyGroupIndex !== -1) {                                                                                  // 821
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 822
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 824
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 825
            mid[i] = "0";                                                                                              // 826
          }                                                                                                            // 827
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 829
          cleanGroups = [].concat(head, mid, tail);                                                                    // 830
        } else {                                                                                                       // 831
          cleanGroups = groups;                                                                                        // 832
        }                                                                                                              // 833
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 835
          return parseInt(x, 16);                                                                                      // 835
        });                                                                                                            // 835
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 838
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 839
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 840
        };                                                                                                             // 838
      }                                                                                                                // 842
    }                                                                                                                  // 843
  }                                                                                                                    // 844
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 846
}                                                                                                                      // 847
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 850
  check(token, String);                                                                                                // 851
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 852
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 853
  var serializedParams = getApiSessionParams(request);                                                                 // 855
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 856
  return Promise.resolve(undefined).then(function () {                                                                 // 857
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 858
    if (proxy) {                                                                                                       // 859
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 860
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 861
      }                                                                                                                // 862
                                                                                                                       //
      return proxy;                                                                                                    // 864
    } else {                                                                                                           // 865
      return inMeteor(function () {                                                                                    // 866
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 867
        validateWebkey(tokenInfo);                                                                                     // 868
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 870
        if (!grain) {                                                                                                  // 871
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 873
        }                                                                                                              // 874
                                                                                                                       //
        var proxy = void 0;                                                                                            // 876
        if (tokenInfo.userInfo) {                                                                                      // 877
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 878
        } else {                                                                                                       // 879
          var identityId = null;                                                                                       // 880
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 881
            identityId = tokenInfo.identityId;                                                                         // 882
          }                                                                                                            // 883
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 885
          proxy.apiToken = tokenInfo;                                                                                  // 886
          proxy.apiSessionParams = serializedParams;                                                                   // 887
        }                                                                                                              // 888
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 890
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 892
        }                                                                                                              // 893
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 895
          proxy.expires = tokenInfo.expires;                                                                           // 896
        }                                                                                                              // 897
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 899
                                                                                                                       //
        return proxy;                                                                                                  // 901
      });                                                                                                              // 902
    }                                                                                                                  // 903
  });                                                                                                                  // 904
};                                                                                                                     // 905
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 907
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 915
    return true;                                                                                                       // 916
  }                                                                                                                    // 917
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 928
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 929
};                                                                                                                     // 930
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 932
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 935
  var token = void 0;                                                                                                  // 936
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 937
    token = auth.slice(7).trim();                                                                                      // 938
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 939
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 941
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 942
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 945
    if (parts.length < 2) {                                                                                            // 946
      token = undefined;                                                                                               // 947
    } else {                                                                                                           // 948
      token = parts[1];                                                                                                // 949
      req.url = "/" + parts.slice(2).join("/");                                                                        // 950
      // remove .sandstorm-api-token/$TOKEN from path                                                                  //
    }                                                                                                                  // 952
  } else {                                                                                                             // 953
      token = undefined;                                                                                               // 954
    }                                                                                                                  // 955
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 957
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 959
      token = undefined;                                                                                               // 960
    }                                                                                                                  // 961
  }                                                                                                                    // 962
                                                                                                                       //
  return token;                                                                                                        // 964
};                                                                                                                     // 965
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 972
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 978
    var token = apiTokenForRequest(req, hostId);                                                                       // 979
    if (token) {                                                                                                       // 980
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 981
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 984
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 986
        return true;                                                                                                   // 987
      });                                                                                                              // 988
    } else {                                                                                                           // 989
      return Promise.resolve(false);                                                                                   // 990
    }                                                                                                                  // 991
  } else {                                                                                                             // 992
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 993
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 994
      if (proxy) {                                                                                                     // 995
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 997
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 998
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 999
        }                                                                                                              // 1000
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1004
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1006
        return true;                                                                                                   // 1007
      } else {                                                                                                         // 1008
        return false;                                                                                                  // 1009
      }                                                                                                                // 1010
    });                                                                                                                // 1011
  }                                                                                                                    // 1012
};                                                                                                                     // 1013
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1016
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1022
  if (hostIdHash) {                                                                                                    // 1023
    var _ret2 = function () {                                                                                          // 1023
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1026
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1028
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1045
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1046
          "Access-Control-Max-Age": "3600"                                                                             // 1047
        };                                                                                                             // 1045
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1051
        if (requestedHeaders) {                                                                                        // 1052
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1053
        }                                                                                                              // 1054
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1057
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1058
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1060
        }                                                                                                              // 1061
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1063
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1064
        }                                                                                                              // 1065
      }                                                                                                                // 1066
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1068
        if (err instanceof Meteor.Error) {                                                                             // 1069
          console.log("error: " + err);                                                                                // 1070
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1071
        } else {                                                                                                       // 1072
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1073
        }                                                                                                              // 1074
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1076
      };                                                                                                               // 1077
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1079
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1080
        inMeteor(function () {                                                                                         // 1081
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1082
          check(keepaliveDuration, Match.Integer);                                                                     // 1083
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1084
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1085
        }).then(function () {                                                                                          // 1086
          res.writeHead(200, {});                                                                                      // 1087
          res.end();                                                                                                   // 1088
        }, errorHandler);                                                                                              // 1089
      } else if (token) {                                                                                              // 1090
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1091
          proxy.requestHandler(req, res);                                                                              // 1092
        }, errorHandler);                                                                                              // 1093
      } else {                                                                                                         // 1094
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1096
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1097
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1099
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1102
            if (dav.length > 0) {                                                                                      // 1103
              res.setHeader("DAV", dav.join(", "));                                                                    // 1104
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1105
            }                                                                                                          // 1106
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1108
            res.end();                                                                                                 // 1109
          } else {                                                                                                     // 1110
            var resources = (apiHost || {}).resources || {};                                                           // 1111
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1112
            if (path in resources) {                                                                                   // 1113
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1115
              console.log(path, resources, resource);                                                                  // 1116
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1117
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1118
              res.writeHead(200, {                                                                                     // 1119
                "Content-Type": resource.type                                                                          // 1120
              });                                                                                                      // 1119
              res.end(resource.body);                                                                                  // 1122
            } else {                                                                                                   // 1123
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1124
                res.writeHead(401, {                                                                                   // 1125
                  "Content-Type": "text/plain",                                                                        // 1126
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1127
                });                                                                                                    // 1125
              } else {                                                                                                 // 1129
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1131
              }                                                                                                        // 1132
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1138
          }                                                                                                            // 1139
        }).then(function () {}, errorHandler);                                                                         // 1140
      }                                                                                                                // 1141
                                                                                                                       //
      return {                                                                                                         // 1143
        v: Promise.resolve(true)                                                                                       // 1143
      };                                                                                                               // 1143
    }();                                                                                                               // 1023
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 1023
  } else {                                                                                                             // 1144
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1145
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1146
      if (proxy) {                                                                                                     // 1147
        proxy.requestHandler(req, res);                                                                                // 1148
        return true;                                                                                                   // 1149
      } else {                                                                                                         // 1150
        return false;                                                                                                  // 1151
      }                                                                                                                // 1152
    });                                                                                                                // 1153
  }                                                                                                                    // 1154
};                                                                                                                     // 1155
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1164
    var _this4 = this;                                                                                                 // 1164
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1164
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1165
    this.ownerId = ownerId;                                                                                            // 1166
    this.identityId = identityId;                                                                                      // 1167
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1168
    this.sessionId = sessionId;                                                                                        // 1169
    this.tabId = tabId;                                                                                                // 1170
    this.isApi = isApi;                                                                                                // 1171
    this.hasLoaded = false;                                                                                            // 1172
    this.websockets = {};                                                                                              // 1173
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1174
    if (sessionId) {                                                                                                   // 1175
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1176
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1177
      this.hostId = hostId;                                                                                            // 1178
    } else {                                                                                                           // 1179
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1180
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1181
    }                                                                                                                  // 1182
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1184
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1185
      if (!identity) {                                                                                                 // 1186
        throw new Error("identity not found: " + this.identityId);                                                     // 1187
      }                                                                                                                // 1188
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               //
      var idCapRequirement = {                                                                                         // 1191
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1192
      };                                                                                                               // 1191
                                                                                                                       //
      this.userInfo = {                                                                                                // 1195
        displayName: { defaultText: identity.profile.name },                                                           // 1196
        preferredHandle: identity.profile.handle,                                                                      // 1197
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1198
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1199
      };                                                                                                               // 1195
      if (identity.profile.pictureUrl) {                                                                               // 1201
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1202
      } else {                                                                                                         // 1203
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1207
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1209
    } else {                                                                                                           // 1210
      this.userInfo = {                                                                                                // 1211
        displayName: { defaultText: "Anonymous User" },                                                                // 1212
        preferredHandle: "anonymous"                                                                                   // 1213
      };                                                                                                               // 1211
    }                                                                                                                  // 1215
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1217
      if (_this4.sessionId) {                                                                                          // 1218
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1220
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1221
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1222
          return;                                                                                                      // 1223
        }                                                                                                              // 1224
      }                                                                                                                // 1225
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1227
        var contentLength = request.headers["content-length"];                                                         // 1228
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1232
        } else {                                                                                                       // 1233
          return readAll(request).then(function (data) {                                                               // 1234
            return _this4.handleRequest(request, data, response, 0);                                                   // 1235
          });                                                                                                          // 1236
        }                                                                                                              // 1237
      })["catch"](function (err) {                                                                                     // 1238
        _this4.setHasLoaded();                                                                                         // 1239
                                                                                                                       //
        var body = err.stack;                                                                                          // 1241
        if (err.cppFile) {                                                                                             // 1242
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1243
        }                                                                                                              // 1244
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1246
          body += "\ntype: " + err.kjType;                                                                             // 1247
        }                                                                                                              // 1248
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1250
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1252
          response.end();                                                                                              // 1253
        } else {                                                                                                       // 1254
          if (err instanceof Meteor.Error) {                                                                           // 1255
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1256
          } else {                                                                                                     // 1257
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1258
          }                                                                                                            // 1259
                                                                                                                       //
          response.end(body);                                                                                          // 1261
        }                                                                                                              // 1262
      });                                                                                                              // 1263
    };                                                                                                                 // 1264
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1266
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1267
        console.error("WebSocket setup failed:", err.stack);                                                           // 1268
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1270
      });                                                                                                              // 1271
    };                                                                                                                 // 1272
  }                                                                                                                    // 1273
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var socketIdx in this.websockets) {                                                                           // 1276
      this.websockets[socketIdx].destroy();                                                                            // 1277
    };                                                                                                                 // 1278
                                                                                                                       //
    this.websockets = {};                                                                                              // 1280
                                                                                                                       //
    if (this.session) {                                                                                                // 1282
      this.session.close();                                                                                            // 1283
      delete this.session;                                                                                             // 1284
    }                                                                                                                  // 1285
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1287
      this.uiView.close();                                                                                             // 1288
      delete this.uiView;                                                                                              // 1289
    }                                                                                                                  // 1290
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1292
      this.supervisor.close();                                                                                         // 1293
      delete this.supervisor;                                                                                          // 1294
    }                                                                                                                  // 1295
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1297
      this.permissionsObserver.stop();                                                                                 // 1298
      delete this.permissionsObserver;                                                                                 // 1299
    }                                                                                                                  // 1300
  };                                                                                                                   // 1301
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1304
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1305
      this.uiView = null;                                                                                              // 1306
    }                                                                                                                  // 1307
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1309
      this.uiView = this.supervisor.getMainView().view;                                                                // 1310
    }                                                                                                                  // 1311
  };                                                                                                                   // 1312
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1315
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1316
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1317
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1321
      }) : ["en-US", "en"]                                                                                             // 1321
    });                                                                                                                // 1315
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1327
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this5 = this;                                                                                                 // 1329
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1330
    if (!serializedParams) {                                                                                           // 1331
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1332
    }                                                                                                                  // 1333
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1342
    }, function (err) {                                                                                                // 1343
      return _this5._callNewWebSession(request, userInfo);                                                             // 1344
    });                                                                                                                // 1345
  };                                                                                                                   // 1346
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this6 = this;                                                                                                 // 1348
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1349
    var promise = inMeteor(function () {                                                                               // 1350
      var vertex = void 0;                                                                                             // 1351
      if (_this6.apiToken) {                                                                                           // 1352
        vertex = { token: _this6.apiToken };                                                                           // 1353
      } else {                                                                                                         // 1354
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                    // 1356
      }                                                                                                                // 1357
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1359
        Sessions.remove({ _id: _this6.sessionId });                                                                    // 1360
      };                                                                                                               // 1361
                                                                                                                       //
      if (!_this6.sessionId) {                                                                                         // 1363
        onInvalidated = function onInvalidated() {                                                                     // 1364
          apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                                 // 1365
        };                                                                                                             // 1366
      }                                                                                                                // 1367
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1369
                                                                                                                       //
      if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                               // 1372
      _this6.permissionsObserver = permissions.observeHandle;                                                          // 1373
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1375
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1376
      }                                                                                                                // 1377
                                                                                                                       //
      Sessions.update({                                                                                                // 1379
        _id: _this6.sessionId                                                                                          // 1380
      }, {                                                                                                             // 1379
        $set: {                                                                                                        // 1382
          viewInfo: viewInfo,                                                                                          // 1383
          permissions: permissions.permissions                                                                         // 1384
        }                                                                                                              // 1382
      });                                                                                                              // 1381
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1388
    });                                                                                                                // 1389
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1391
      userInfo.permissions = permissions;                                                                              // 1392
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1394
      var buf = new Buffer(numBytes);                                                                                  // 1395
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1396
        buf[ii] = 0;                                                                                                   // 1397
      }                                                                                                                // 1398
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1400
        var byteNum = Math.floor(_ii / 8);                                                                             // 1401
        var bitNum = _ii % 8;                                                                                          // 1402
        if (permissions[_ii]) {                                                                                        // 1403
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1404
        }                                                                                                              // 1405
      }                                                                                                                // 1406
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1408
                                                                                                                       //
      if (_this6.isApi) {                                                                                              // 1410
        return _this6._callNewApiSession(request, userInfo);                                                           // 1411
      } else {                                                                                                         // 1412
        return _this6._callNewWebSession(request, userInfo);                                                           // 1413
      }                                                                                                                // 1414
    });                                                                                                                // 1415
  };                                                                                                                   // 1416
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this7 = this;                                                                                                 // 1418
                                                                                                                       //
    if (!this.session) {                                                                                               // 1419
      this.getConnection(); // make sure we're connected                                                               // 1420
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1421
        return inMeteor(function () {                                                                                  // 1422
          // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                          //
          var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                              // 1424
          Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                                 // 1425
        }).then(function () {                                                                                          // 1426
          return _this7._callNewSession(request, viewInfo);                                                            // 1427
        });                                                                                                            // 1428
      }, function (error) {                                                                                            // 1429
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1430
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this7._callNewSession(request, {});                                                                  // 1435
        } else {                                                                                                       // 1436
          return Promise.reject(error);                                                                                // 1437
        }                                                                                                              // 1438
      });                                                                                                              // 1439
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1440
    }                                                                                                                  // 1441
                                                                                                                       //
    return this.session;                                                                                               // 1443
  };                                                                                                                   // 1444
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1447
    return this.supervisor.keepAlive();                                                                                // 1448
  };                                                                                                                   // 1449
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1452
      this.session.close();                                                                                            // 1453
      delete this.session;                                                                                             // 1454
    }                                                                                                                  // 1455
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1457
      this.uiView.close();                                                                                             // 1458
      delete this.uiView;                                                                                              // 1459
    }                                                                                                                  // 1460
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1462
      this.supervisor.close();                                                                                         // 1463
      delete this.supervisor;                                                                                          // 1464
    }                                                                                                                  // 1465
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1467
      this.permissionsObserver.stop();                                                                                 // 1468
      delete this.permissionsObserver;                                                                                 // 1469
    }                                                                                                                  // 1470
  };                                                                                                                   // 1471
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this8 = this;                                                                                                 // 1473
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                      // 1478
      this.resetConnection();                                                                                          // 1479
      return inMeteor(function () {                                                                                    // 1480
        _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                    // 1481
      });                                                                                                              // 1482
    } else {                                                                                                           // 1483
      throw error;                                                                                                     // 1484
    }                                                                                                                  // 1485
  };                                                                                                                   // 1486
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1490
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1494
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1495
      response.end("Invalid path supplied.");                                                                          // 1496
      return;                                                                                                          // 1497
    }                                                                                                                  // 1498
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1501
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1503
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1508
    response.end();                                                                                                    // 1509
  };                                                                                                                   // 1510
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1521
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1523
      var parseResult = parseCookies(request);                                                                         // 1524
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1525
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1526
      }                                                                                                                // 1527
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1529
        context.cookies = parseResult.cookies;                                                                         // 1530
      }                                                                                                                // 1531
    } else {                                                                                                           // 1532
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1535
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1537
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1539
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1541
    for (var headerName in request.headers) {                                                                          // 1542
      if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                              // 1543
        context.additionalHeaders.push({                                                                               // 1544
          name: headerName,                                                                                            // 1545
          value: request.headers[headerName]                                                                           // 1546
        });                                                                                                            // 1544
      }                                                                                                                // 1548
    }                                                                                                                  // 1549
                                                                                                                       //
    if (response) {                                                                                                    // 1551
      var promise = new Promise(function (resolve, reject) {                                                           // 1552
        response.resolveResponseStream = resolve;                                                                      // 1553
        response.rejectResponseStream = reject;                                                                        // 1554
      });                                                                                                              // 1555
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1557
                                                                                                                       //
      try {                                                                                                            // 1559
        return callback(context);                                                                                      // 1560
      } finally {                                                                                                      // 1561
        context.responseStream.close();                                                                                // 1562
      }                                                                                                                // 1563
    } else {                                                                                                           // 1564
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1566
    }                                                                                                                  // 1567
  };                                                                                                                   // 1568
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    if (this.hostId) {                                                                                                 // 1571
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1572
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1573
      }                                                                                                                // 1574
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1582
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader("Vary", "Authorization");                                                                   // 1586
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1589
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1593
      }                                                                                                                // 1594
                                                                                                                       //
    if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                   // 1596
      // Add any additional prefixed/whitelisted headers to the response.                                              //
      // We cannot trust that the headers in the RPC response are actually                                             //
      // allowed, so we check if they are prefixed or whitelisted.                                                     //
      rpcResponse.additionalHeaders.forEach(function (header) {                                                        // 1600
        if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                          // 1601
          // If header is prefixed with appHeaderPrefix,                                                               //
          // or if the header name is in whitelist, set it.                                                            //
          response.setHeader(header.name, header.value);                                                               // 1604
        }                                                                                                              // 1605
      });                                                                                                              // 1606
    }                                                                                                                  // 1607
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1610
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ("content" in rpcResponse) {                                                                                    // 1614
      var content = rpcResponse.content;                                                                               // 1615
      var code = successCodes[content.statusCode];                                                                     // 1616
      if (!code) {                                                                                                     // 1617
        throw new Error("Unknown status code: ", content.statusCode);                                                  // 1618
      }                                                                                                                // 1619
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1621
        response.setHeader("Content-Type", content.mimeType);                                                          // 1622
      }                                                                                                                // 1623
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1625
        response.setHeader("Content-Encoding", content.encoding);                                                      // 1626
      }                                                                                                                // 1627
                                                                                                                       //
      if (content.language) {                                                                                          // 1629
        response.setHeader("Content-Language", content.language);                                                      // 1630
      }                                                                                                                // 1631
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1633
        response.setHeader("ETag", composeETag(content.eTag));                                                         // 1634
      }                                                                                                                // 1635
                                                                                                                       //
      if ("disposition" in content && "download" in content.disposition) {                                             // 1637
        response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1640
                                                                                                                       //
      if ("stream" in content.body) {                                                                                  // 1642
        if (request.method === "HEAD") {                                                                               // 1643
          content.body.stream.close();                                                                                 // 1644
          response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                           // 1645
        } else {                                                                                                       // 1646
          var streamHandle = content.body.stream;                                                                      // 1647
          var responseStream = new Capnp.Capability(new ResponseStream(response, code.id, code.title, streamHandle), ByteStream);
          response.resolveResponseStream(responseStream);                                                              // 1651
          return { streamHandle: responseStream };                                                                     // 1652
        }                                                                                                              // 1653
      } else {                                                                                                         // 1654
        response.rejectResponseStream(new Error("Response content body was not a stream."));                           // 1655
                                                                                                                       //
        if ("bytes" in content.body) {                                                                                 // 1658
          response.setHeader("Content-Length", content.body.bytes.length);                                             // 1659
        } else {                                                                                                       // 1660
          throw new Error("Unknown content body type.");                                                               // 1661
        }                                                                                                              // 1662
      }                                                                                                                // 1663
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1665
                                                                                                                       //
      if ("bytes" in content.body && request.method !== "HEAD") {                                                      // 1667
        response.write(content.body.bytes);                                                                            // 1668
      }                                                                                                                // 1669
                                                                                                                       //
      response.end();                                                                                                  // 1671
    } else if ("noContent" in rpcResponse) {                                                                           // 1672
      var noContent = rpcResponse.noContent;                                                                           // 1673
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1674
      if (noContent.eTag) {                                                                                            // 1675
        response.setHeader("ETag", composeETag(noContent.eTag));                                                       // 1676
      }                                                                                                                // 1677
                                                                                                                       //
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1679
      response.end();                                                                                                  // 1680
    } else if ("preconditionFailed" in rpcResponse) {                                                                  // 1681
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1682
      if (request.method === "GET" && "if-none-match" in request.headers) {                                            // 1683
        if (preconditionFailed.matchingETag) {                                                                         // 1684
          response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                    // 1685
        }                                                                                                              // 1686
                                                                                                                       //
        response.writeHead(304, "Not Modified");                                                                       // 1688
      } else {                                                                                                         // 1689
        response.writeHead(412, "Precondition Failed");                                                                // 1690
      }                                                                                                                // 1691
                                                                                                                       //
      response.end();                                                                                                  // 1693
    } else if ("redirect" in rpcResponse) {                                                                            // 1694
      var redirect = rpcResponse.redirect;                                                                             // 1695
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1696
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1697
        "Location": redirect.location                                                                                  // 1698
      });                                                                                                              // 1697
      response.end();                                                                                                  // 1700
    } else if ("clientError" in rpcResponse) {                                                                         // 1701
      var clientError = rpcResponse.clientError;                                                                       // 1702
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1703
      if (!errorCode) {                                                                                                // 1704
        throw new Error("Unknown status code: ", clientError.statusCode);                                              // 1705
      }                                                                                                                // 1706
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1708
        "Content-Type": "text/html"                                                                                    // 1709
      });                                                                                                              // 1708
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1712
        if (clientError.descriptionHtml) {                                                                             // 1713
          response.write(clientError.descriptionHtml);                                                                 // 1714
        } else {                                                                                                       // 1715
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");          // 1717
        }                                                                                                              // 1719
      }                                                                                                                // 1720
                                                                                                                       //
      response.end();                                                                                                  // 1722
    } else if ("serverError" in rpcResponse) {                                                                         // 1723
      response.writeHead(500, "Internal Server Error", {                                                               // 1724
        "Content-Type": "text/html"                                                                                    // 1725
      });                                                                                                              // 1724
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1728
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1729
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1730
        } else {                                                                                                       // 1731
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                             // 1733
        }                                                                                                              // 1734
      }                                                                                                                // 1735
                                                                                                                       //
      response.end();                                                                                                  // 1737
    } else {                                                                                                           // 1738
      throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                  // 1739
    }                                                                                                                  // 1740
                                                                                                                       //
    return {};                                                                                                         // 1742
  };                                                                                                                   // 1743
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this9 = this;                                                                                                 // 1745
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1746
      return _this9.makeContext(request, response, function (context) {                                                // 1747
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1750
        var session = _this9.getSession(request);                                                                      // 1751
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1753
          return {                                                                                                     // 1754
            content: data,                                                                                             // 1755
            encoding: request.headers["content-encoding"],                                                             // 1756
            mimeType: request.headers["content-type"]                                                                  // 1757
          };                                                                                                           // 1754
        };                                                                                                             // 1759
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1761
          var type = request.headers["content-type"] || "application/xml;charset=utf-8";                               // 1762
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1763
          if (!match) {                                                                                                // 1764
            response.writeHead(415, "Unsupported media type.", {                                                       // 1765
              "Content-Type": "text/plain"                                                                             // 1766
            });                                                                                                        // 1765
            response.end("expected XML request body");                                                                 // 1768
            throw new Error("expected XML request body");                                                              // 1769
          }                                                                                                            // 1770
                                                                                                                       //
          var charset = match[2] || "ISO-8859-1";                                                                      // 1772
                                                                                                                       //
          var encoding = request.headers["content-encoding"];                                                          // 1774
          if (encoding && encoding !== "identity") {                                                                   // 1775
            if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                         // 1776
            data = gunzipSync(data);                                                                                   // 1777
          }                                                                                                            // 1778
                                                                                                                       //
          return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                                 // 1780
        };                                                                                                             // 1781
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1783
          var depth = request.headers["depth"];                                                                        // 1784
          return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                          // 1785
        };                                                                                                             // 1788
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1790
          return request.headers["depth"] === "0";                                                                     // 1791
        };                                                                                                             // 1792
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1794
          return (request.headers["overwrite"] || "").toLowerCase() === "f";                                           // 1795
        };                                                                                                             // 1796
                                                                                                                       //
        var destination = function destination() {                                                                     // 1798
          var result = request.headers["destination"];                                                                 // 1799
          if (!result) throw new Error("missing destination");                                                         // 1800
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1801
        };                                                                                                             // 1802
                                                                                                                       //
        if (request.method === "GET" || request.method === "HEAD") {                                                   // 1804
          return session.get(path, context, request.method === "HEAD");                                                // 1805
        } else if (request.method === "POST") {                                                                        // 1806
          return session.post(path, requestContent(), context);                                                        // 1807
        } else if (request.method === "PUT") {                                                                         // 1808
          return session.put(path, requestContent(), context);                                                         // 1809
        } else if (request.method === "PATCH") {                                                                       // 1810
          return session.patch(path, requestContent(), context);                                                       // 1811
        } else if (request.method === "DELETE") {                                                                      // 1812
          return session["delete"](path, context);                                                                     // 1813
        } else if (request.method === "PROPFIND") {                                                                    // 1814
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1815
        } else if (request.method === "PROPPATCH") {                                                                   // 1816
          return session.proppatch(path, xmlContent(), context);                                                       // 1817
        } else if (request.method === "MKCOL") {                                                                       // 1818
          return session.mkcol(path, requestContent(), context);                                                       // 1819
        } else if (request.method === "COPY") {                                                                        // 1820
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1821
        } else if (request.method === "MOVE") {                                                                        // 1822
          return session.move(path, destination(), noOverwrite(), context);                                            // 1823
        } else if (request.method === "LOCK") {                                                                        // 1824
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1825
        } else if (request.method === "UNLOCK") {                                                                      // 1826
          return session.unlock(path, request.headers["lock-token"], context);                                         // 1827
        } else if (request.method === "ACL") {                                                                         // 1828
          return session.acl(path, xmlContent(), context);                                                             // 1829
        } else if (request.method === "REPORT") {                                                                      // 1830
          return session.report(path, requestContent(), context);                                                      // 1831
        } else if (request.method === "OPTIONS") {                                                                     // 1832
          return session.options(path, context).then(function (options) {                                              // 1833
            var dav = [];                                                                                              // 1834
            if (options.davClass1) dav.push("1");                                                                      // 1835
            if (options.davClass2) dav.push("2");                                                                      // 1836
            if (options.davClass3) dav.push("3");                                                                      // 1837
            if (options.davExtensions) {                                                                               // 1838
              options.davExtensions.forEach(function (token) {                                                         // 1839
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1840
                  dav.push(token);                                                                                     // 1841
                }                                                                                                      // 1842
              });                                                                                                      // 1843
            }                                                                                                          // 1844
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1846
              response.setHeader("DAV", dav.join(", "));                                                               // 1847
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1848
            }                                                                                                          // 1849
                                                                                                                       //
            response.end();                                                                                            // 1851
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1853
            if (err.kjType !== "unimplemented") throw err;                                                             // 1854
            response.end();                                                                                            // 1855
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1857
        } else {                                                                                                       // 1858
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 1860
      });                                                                                                              // 1861
    }).then(function (rpcResponse) {                                                                                   // 1862
      if (rpcResponse !== undefined) {                                                                                 // 1863
        // Will be undefined for OPTIONS request.                                                                      //
        return _this9.translateResponse(rpcResponse, response, request);                                               // 1864
      }                                                                                                                // 1865
    })["catch"](function (error) {                                                                                     // 1866
      return _this9.maybeRetryAfterError(error, retryCount).then(function () {                                         // 1867
        return _this9.handleRequest(request, data, response, retryCount + 1);                                          // 1868
      });                                                                                                              // 1869
    });                                                                                                                // 1870
  };                                                                                                                   // 1871
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this10 = this;                                                                                                // 1873
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1874
      var path = request.url.slice(1); // remove leading '/'                                                           // 1875
      var session = _this10.getSession(request);                                                                       // 1876
                                                                                                                       //
      var mimeType = request.headers["content-type"] || "application/octet-stream";                                    // 1878
      var encoding = request.headers["content-encoding"];                                                              // 1879
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1881
      if (request.method === "POST") {                                                                                 // 1882
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1883
      } else if (request.method === "PUT") {                                                                           // 1884
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1885
      } else {                                                                                                         // 1886
        throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                   // 1887
      }                                                                                                                // 1888
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1894
        var requestStream = requestStreamResult.stream;                                                                // 1895
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1898
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1901
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 1910
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 1912
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 1915
            uploadStreamError = err;                                                                                   // 1916
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 1919
            requestStream.close();                                                                                     // 1920
            if (downloadStreamHandle) {                                                                                // 1921
              downloadStreamHandle.close();                                                                            // 1922
            }                                                                                                          // 1923
          }                                                                                                            // 1924
        };                                                                                                             // 1925
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1928
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1929
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== "unimplemented") {                                                                      // 1931
              reportUploadStreamError(err);                                                                            // 1932
            }                                                                                                          // 1933
          });                                                                                                          // 1934
        }                                                                                                              // 1935
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 1938
        var readingPaused = false;                                                                                     // 1939
        request.on("data", function (buf) {                                                                            // 1940
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 1942
            requestStream.write(buf).then(function () {                                                                // 1943
              writesInFlight--;                                                                                        // 1944
              if (readingPaused) {                                                                                     // 1945
                request.resume();                                                                                      // 1946
                readingPaused = false;                                                                                 // 1947
              }                                                                                                        // 1948
            })["catch"](reportUploadStreamError);                                                                      // 1949
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 1951
              request.pause();                                                                                         // 1952
              readingPaused = true;                                                                                    // 1953
            }                                                                                                          // 1954
          }                                                                                                            // 1955
        });                                                                                                            // 1956
                                                                                                                       //
        request.on("end", function () {                                                                                // 1958
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1959
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1962
        });                                                                                                            // 1963
                                                                                                                       //
        request.on("close", function () {                                                                              // 1965
          reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                   // 1966
        });                                                                                                            // 1967
                                                                                                                       //
        request.on("error", function (err) {                                                                           // 1969
          reportUploadStreamError(err);                                                                                // 1970
        });                                                                                                            // 1971
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1973
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1975
          downloadStreamHandle = _this10.translateResponse(rpcResponse, response, request).streamHandle;               // 1976
        });                                                                                                            // 1977
      }, function (err) {                                                                                              // 1978
        if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                                // 1979
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = "unimplemented";                                                                                // 1984
        }                                                                                                              // 1985
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1987
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this10.maybeRetryAfterError(err, retryCount).then(function () {                                      // 1992
            return _this10.handleRequestStreaming(request, response, contentLength, retryCount + 1);                   // 1993
          });                                                                                                          // 1994
        } else if (err.kjType === "unimplemented") {                                                                   // 1995
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 1997
            return _this10.handleRequest(request, data, response, 0);                                                  // 1998
          });                                                                                                          // 1999
        } else {                                                                                                       // 2000
          throw err;                                                                                                   // 2001
        }                                                                                                              // 2002
      });                                                                                                              // 2003
    });                                                                                                                // 2004
  };                                                                                                                   // 2005
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this11 = this;                                                                                                // 2007
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 2008
      return _this11.makeContext(request, undefined, function (context) {                                              // 2009
        var path = request.url.slice(1); // remove leading '/'                                                         // 2010
        var session = _this11.getSession(request);                                                                     // 2011
                                                                                                                       //
        if (!("sec-websocket-key" in request.headers)) {                                                               // 2013
          throw new Error("Missing Sec-WebSocket-Accept header.");                                                     // 2014
        }                                                                                                              // 2015
                                                                                                                       //
        var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                     // 2017
        var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                      // 2018
                                                                                                                       //
        var protocols = [];                                                                                            // 2020
        if ("sec-websocket-protocol" in request.headers) {                                                             // 2021
          protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                          // 2022
            return s.trim();                                                                                           // 2023
          });                                                                                                          // 2023
        }                                                                                                              // 2024
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 2026
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 2028
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 2030
          promise.serverStream.sendBytes(head);                                                                        // 2031
        }                                                                                                              // 2032
                                                                                                                       //
        var socketIdx = _this11.websocketCounter.toString();                                                           // 2034
        _this11.websockets[socketIdx] = socket;                                                                        // 2035
        _this11.websocketCounter += 1;                                                                                 // 2036
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 2037
          delete _this11.websockets[socketIdx];                                                                        // 2037
        });                                                                                                            // 2037
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 2039
          var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2046
            headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                   // 2047
          }                                                                                                            // 2048
                                                                                                                       //
          headers.push("");                                                                                            // 2050
          headers.push("");                                                                                            // 2051
                                                                                                                       //
          socket.write(headers.join("\r\n"));                                                                          // 2053
          receiver.go();                                                                                               // 2054
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2057
      });                                                                                                              // 2058
    })["catch"](function (error) {                                                                                     // 2059
      return _this11.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2060
        return _this11.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2061
      });                                                                                                              // 2062
    });                                                                                                                // 2063
  };                                                                                                                   // 2064
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this12 = this;                                                                                                // 2066
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2067
      (function () {                                                                                                   // 2067
        _this12.hasLoaded = true;                                                                                      // 2068
        var sessionId = _this12.sessionId;                                                                             // 2069
        inMeteor(function () {                                                                                         // 2070
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2071
        });                                                                                                            // 2072
      })();                                                                                                            // 2067
    }                                                                                                                  // 2073
  };                                                                                                                   // 2074
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2077
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2079
  if (Net.isIPv4(address)) {                                                                                           // 2080
    var quad = address.split(".").map(function (x) {                                                                   // 2081
      return parseInt(x, 10);                                                                                          // 2081
    });                                                                                                                // 2081
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2085
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2087
  } else {                                                                                                             // 2088
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2090
  }                                                                                                                    // 2091
};                                                                                                                     // 2092
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2094
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2095
  return num.toString();                                                                                               // 2099
};                                                                                                                     // 2100
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2105
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["cookie"];                                                                              // 2107
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2109
  if (header) {                                                                                                        // 2110
    var reqCookies = header.split(";");                                                                                // 2111
    for (var i in reqCookies) {                                                                                        // 2112
      var reqCookie = reqCookies[i];                                                                                   // 2113
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2114
      var cookie = void 0;                                                                                             // 2115
      if (equalsPos === -1) {                                                                                          // 2116
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2117
      } else {                                                                                                         // 2118
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2119
      }                                                                                                                // 2120
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2122
        if (result.sessionId) {                                                                                        // 2123
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2124
        }                                                                                                              // 2125
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2127
      } else {                                                                                                         // 2128
        result.cookies.push(cookie);                                                                                   // 2129
      }                                                                                                                // 2130
    }                                                                                                                  // 2131
  }                                                                                                                    // 2132
                                                                                                                       //
  return result;                                                                                                       // 2134
};                                                                                                                     // 2135
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2137
  if (request.headers["if-match"]) {                                                                                   // 2138
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2139
      return { exists: null };                                                                                         // 2140
    }                                                                                                                  // 2141
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2143
    if (matches.length > 0) {                                                                                          // 2144
      return { matchesOneOf: matches };                                                                                // 2145
    }                                                                                                                  // 2146
  }                                                                                                                    // 2147
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2149
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2150
      return { doesntExist: null };                                                                                    // 2151
    }                                                                                                                  // 2152
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2154
    if (noneMatches.length > 0) {                                                                                      // 2155
      return { matchesNoneOf: noneMatches };                                                                           // 2156
    }                                                                                                                  // 2157
  }                                                                                                                    // 2158
                                                                                                                       //
  return { none: null };                                                                                               // 2160
};                                                                                                                     // 2161
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2163
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2167
  var results = [];                                                                                                    // 2168
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2170
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2171
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2172
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2174
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2175
  }                                                                                                                    // 2176
                                                                                                                       //
  return results;                                                                                                      // 2178
};                                                                                                                     // 2179
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2181
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2182
  if (tag.weak) result = "W/" + result;                                                                                // 2183
  return result;                                                                                                       // 2184
};                                                                                                                     // 2185
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2187
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept"];                                                                              // 2189
                                                                                                                       //
  var result = [];                                                                                                     // 2191
  if (header) {                                                                                                        // 2192
    var acceptList = header.split(",");                                                                                // 2193
    for (var i in acceptList) {                                                                                        // 2194
      var acceptStr = acceptList[i];                                                                                   // 2195
      var tokensList = acceptStr.split(";");                                                                           // 2196
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2198
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2200
      for (var j in tokensListRest) {                                                                                  // 2201
        var token = tokensListRest[j];                                                                                 // 2202
        var equalsPos = token.indexOf("=");                                                                            // 2203
        if (equalsPos) {                                                                                               // 2204
          var key = token.slice(0, equalsPos).trim();                                                                  // 2205
          var value = token.slice(equalsPos + 1).trim();                                                               // 2206
                                                                                                                       //
          if (key === "q") {                                                                                           // 2208
            temp.qValue = +value;                                                                                      // 2209
          }                                                                                                            // 2210
        }                                                                                                              // 2211
      }                                                                                                                // 2212
                                                                                                                       //
      result.push(temp);                                                                                               // 2214
    }                                                                                                                  // 2215
  }                                                                                                                    // 2216
                                                                                                                       //
  return result;                                                                                                       // 2218
};                                                                                                                     // 2219
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2224
  return new Promise(function (resolve, reject) {                                                                      // 2225
    var buffers = [];                                                                                                  // 2226
    stream.on("data", function (buf) {                                                                                 // 2227
      buffers.push(buf);                                                                                               // 2228
    });                                                                                                                // 2229
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2231
      resolve(Buffer.concat(buffers));                                                                                 // 2232
    });                                                                                                                // 2233
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2235
  });                                                                                                                  // 2236
};                                                                                                                     // 2237
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2239
  var result = [cookie.name, "=", cookie.value];                                                                       // 2240
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2242
    result.push("; Expires=");                                                                                         // 2243
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2244
  } else if ("relative" in cookie.expires) {                                                                           // 2245
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2246
  }                                                                                                                    // 2247
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2249
    result.push("; Path=" + cookie.path);                                                                              // 2250
  }                                                                                                                    // 2251
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2253
    result.push("; HttpOnly");                                                                                         // 2254
  }                                                                                                                    // 2255
                                                                                                                       //
  return result.join("");                                                                                              // 2257
};                                                                                                                     // 2258
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2261
  ok: { id: 200, title: "OK" },                                                                                        // 2262
  created: { id: 201, title: "Created" },                                                                              // 2263
  accepted: { id: 202, title: "Accepted" },                                                                            // 2264
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2265
};                                                                                                                     // 2261
var noContentSuccessCodes = [                                                                                          // 2267
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2269
var redirectCodes = [                                                                                                  // 2272
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2279
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2280
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2281
  notFound: { id: 404, title: "Not Found" },                                                                           // 2282
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2283
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2284
  conflict: { id: 409, title: "Conflict" },                                                                            // 2285
  gone: { id: 410, title: "Gone" },                                                                                    // 2286
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2287
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2288
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2289
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2290
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2291
};                                                                                                                     // 2279
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2294
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle) {                                            // 2297
    var _this13 = this;                                                                                                // 2297
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2297
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2315
    this.httpCode = httpCode;                                                                                          // 2316
    this.httpStatus = httpStatus;                                                                                      // 2317
    this.upstreamHandle = upstreamHandle;                                                                              // 2318
                                                                                                                       //
    this.started = false;                                                                                              // 2320
    this.ended = false;                                                                                                // 2321
    this.waiting = [];                                                                                                 // 2322
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2324
      _this13.waiting.forEach(function (f) {                                                                           // 2325
        return f();                                                                                                    // 2325
      });                                                                                                              // 2325
      _this13.waiting = [];                                                                                            // 2326
    });                                                                                                                // 2327
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2329
      _this13.aborted = true;                                                                                          // 2330
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this13.waiting.forEach(function (f) {                                                                           // 2336
        return f();                                                                                                    // 2336
      });                                                                                                              // 2336
      _this13.waiting = [];                                                                                            // 2337
                                                                                                                       //
      _this13.close();                                                                                                 // 2339
    });                                                                                                                // 2340
  }                                                                                                                    // 2341
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2294
    if (!this.started) {                                                                                               // 2344
      this.started = true;                                                                                             // 2345
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2346
    }                                                                                                                  // 2347
  };                                                                                                                   // 2348
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2294
    var _this14 = this;                                                                                                // 2350
                                                                                                                       //
    if (!this.started) {                                                                                               // 2351
      this.started = true;                                                                                             // 2352
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2353
    }                                                                                                                  // 2354
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2356
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2358
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2362
      } else {                                                                                                         // 2363
        this.alreadyThrew = true;                                                                                      // 2364
        throw new Error("client disconnected");                                                                        // 2365
      }                                                                                                                // 2366
    } else {                                                                                                           // 2367
      if (this.response.write(data)) {                                                                                 // 2368
        // All written.                                                                                                //
        return;                                                                                                        // 2370
      } else {                                                                                                         // 2371
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2373
          _this14.waiting.push(resolve);                                                                               // 2374
        });                                                                                                            // 2375
      }                                                                                                                // 2376
    }                                                                                                                  // 2377
  };                                                                                                                   // 2378
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2294
    if (!this.started) {                                                                                               // 2381
      this.started = true;                                                                                             // 2382
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2383
    }                                                                                                                  // 2384
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2386
      this.ended = true;                                                                                               // 2387
      this.response.end();                                                                                             // 2388
    }                                                                                                                  // 2389
                                                                                                                       //
    this.close();                                                                                                      // 2391
  };                                                                                                                   // 2392
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2294
    if (this.upstreamHandle) {                                                                                         // 2395
      this.upstreamHandle.close();                                                                                     // 2396
    }                                                                                                                  // 2397
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2403
      this.started = true;                                                                                             // 2404
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2405
    }                                                                                                                  // 2407
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2409
      this.ended = true;                                                                                               // 2410
      this.response.end();                                                                                             // 2411
    }                                                                                                                  // 2412
  };                                                                                                                   // 2413
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2294
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2421
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2422
      this.response.end();                                                                                             // 2423
    } else if (this.ended) {                                                                                           // 2424
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2425
    } else {                                                                                                           // 2426
      this.started = true;                                                                                             // 2427
      this.ended = true;                                                                                               // 2428
    }                                                                                                                  // 2429
  };                                                                                                                   // 2430
                                                                                                                       //
  return ResponseStream;                                                                                               // 2294
}();                                                                                                                   // 2294
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require("zlib");                                                                                        // 2434
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2435
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2440
  function WebSocketReceiver(socket) {                                                                                 // 2441
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2441
                                                                                                                       //
    this.socket = socket;                                                                                              // 2442
    this.queue = [];                                                                                                   // 2443
  }                                                                                                                    // 2444
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2440
    for (var i in this.queue) {                                                                                        // 2447
      this.socket.write(this.queue[i]);                                                                                // 2448
    }                                                                                                                  // 2449
                                                                                                                       //
    this.queue = null;                                                                                                 // 2451
  };                                                                                                                   // 2452
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2440
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2456
      this.socket.write(message);                                                                                      // 2457
    } else {                                                                                                           // 2458
      this.queue.push(message);                                                                                        // 2459
    }                                                                                                                  // 2460
  };                                                                                                                   // 2461
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2440
    this.socket.end();                                                                                                 // 2464
  };                                                                                                                   // 2465
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2440
}();                                                                                                                   // 2440
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2468
  var writesInFlight = 0;                                                                                              // 2469
  var readingPaused = false;                                                                                           // 2470
  socket.on("data", function (chunk) {                                                                                 // 2471
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2472
      writesInFlight--;                                                                                                // 2473
      if (readingPaused) {                                                                                             // 2474
        socket.resume();                                                                                               // 2475
        readingPaused = false;                                                                                         // 2476
      }                                                                                                                // 2477
    })["catch"](function (err) {                                                                                       // 2478
      if (err.kjType !== "disconnected") {                                                                             // 2479
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2480
      }                                                                                                                // 2481
                                                                                                                       //
      socket.destroy();                                                                                                // 2483
    });                                                                                                                // 2484
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2486
      socket.pause();                                                                                                  // 2487
      readingPaused = true;                                                                                            // 2488
    }                                                                                                                  // 2489
  });                                                                                                                  // 2490
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2492
    rpcStream.close();                                                                                                 // 2493
  });                                                                                                                  // 2494
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2496
    destructor();                                                                                                      // 2497
  });                                                                                                                  // 2498
};                                                                                                                     // 2499
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2504
  var _this15 = this;                                                                                                  // 2504
                                                                                                                       //
  check(grainId, String);                                                                                              // 2505
  var id = 0;                                                                                                          // 2506
  var grain = Grains.findOne(grainId);                                                                                 // 2507
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2508
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2509
    this.ready();                                                                                                      // 2510
    return;                                                                                                            // 2511
  }                                                                                                                    // 2512
                                                                                                                       //
  var connected = false;                                                                                               // 2514
  var _this = this;                                                                                                    // 2515
                                                                                                                       //
  var receiver = {                                                                                                     // 2517
    write: function write(data) {                                                                                      // 2518
      connected = true;                                                                                                // 2519
      _this.added("grainLog", id++, { text: data.toString("utf8") });                                                  // 2520
    },                                                                                                                 // 2521
    close: function close() {                                                                                          // 2523
      if (connected) {                                                                                                 // 2524
        _this.added("grainLog", id++, {                                                                                // 2525
          text: "*** lost connection to grain (probably because it shut down) ***"                                     // 2526
        });                                                                                                            // 2525
      }                                                                                                                // 2528
    }                                                                                                                  // 2529
  };                                                                                                                   // 2517
                                                                                                                       //
  try {                                                                                                                // 2532
    (function () {                                                                                                     // 2532
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2533
        return supervisor.watchLog(8192, receiver);                                                                    // 2534
      })).handle;                                                                                                      // 2535
      connected = true;                                                                                                // 2536
      _this15.onStop(function () {                                                                                     // 2537
        handle.close();                                                                                                // 2538
      });                                                                                                              // 2539
    })();                                                                                                              // 2532
  } catch (err) {                                                                                                      // 2540
    if (!connected) {                                                                                                  // 2541
      this.added("grainLog", id++, {                                                                                   // 2542
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2543
      });                                                                                                              // 2542
    }                                                                                                                  // 2545
  }                                                                                                                    // 2546
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2549
});                                                                                                                    // 2550
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 28
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 34
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 36
  var responseCallback = function responseCallback(res) {                                                              // 37
    if (res.statusCode === 200) {                                                                                      // 38
      console.log("Successfully updated sandcats IP");                                                                 // 39
    } else {                                                                                                           // 40
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 41
    }                                                                                                                  // 42
  };                                                                                                                   // 43
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 45
    console.error("Couldn't send update sandcats hostname", err);                                                      // 46
  };                                                                                                                   // 47
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 51
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 53
  var socket = dgram.createSocket("udp4");                                                                             // 54
  var secret = Random.secret(16);                                                                                      // 55
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 57
  socket.on("message", function (buf) {                                                                                // 58
    if (buf.toString() === secret) {                                                                                   // 59
      updateSandcatsIp();                                                                                              // 60
    } else {                                                                                                           // 61
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 62
    }                                                                                                                  // 63
  });                                                                                                                  // 64
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 66
    if (err) {                                                                                                         // 67
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 70
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 72
    socket.close();                                                                                                    // 73
  }, 10 * 1000);                                                                                                       // 74
};                                                                                                                     // 75
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 78
    hostname: hostname,                                                                                                // 79
    path: path,                                                                                                        // 80
    method: "POST",                                                                                                    // 81
    agent: false,                                                                                                      // 82
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 83
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 84
    headers: {                                                                                                         // 85
      "X-Sand": "cats",                                                                                                // 86
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 87
    }                                                                                                                  // 85
  };                                                                                                                   // 78
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 91
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 95
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 97
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 98
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 103
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 105
  req.write(newPostData);                                                                                              // 106
  req.end();                                                                                                           // 107
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 109
    req.on("error", errorCallback);                                                                                    // 110
  }                                                                                                                    // 111
                                                                                                                       //
  return req;                                                                                                          // 113
};                                                                                                                     // 114
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 116
  check(commonName, String);                                                                                           // 117
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 122
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 126
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 129
  csr.publicKey = keys.publicKey;                                                                                      // 130
  csr.setSubject([{                                                                                                    // 131
    name: "commonName",                                                                                                // 133
    value: commonName,                                                                                                 // 134
    valueTagClass: asn1.Type.UTF8                                                                                      // 135
  }]);                                                                                                                 // 132
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 141
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 142
  return {                                                                                                             // 143
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 144
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 145
  };                                                                                                                   // 143
};                                                                                                                     // 147
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 149
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 156
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 157
  var csrFilename = keyFilename + ".csr";                                                                              // 158
  var responseFilename = keyFilename + ".response-json";                                                               // 159
  var withWildcard = "*." + hostname;                                                                                  // 160
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 161
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 162
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 164
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 169
    csrFilename: csrFilename,                                                                                          // 170
    keyFilename: keyFilename,                                                                                          // 171
    responseFilename: responseFilename                                                                                 // 172
  };                                                                                                                   // 169
};                                                                                                                     // 174
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 176
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 177
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 178
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 179
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 180
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 182
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 183
    };                                                                                                                 // 184
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 186
      if (res.statusCode == 200) {                                                                                     // 187
        (function () {                                                                                                 // 187
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 190
          res.on("data", function (chunk) {                                                                            // 191
            responseBody += chunk;                                                                                     // 192
          });                                                                                                          // 193
                                                                                                                       //
          res.on("end", function () {                                                                                  // 195
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 198
              JSON.parse(responseBody);                                                                                // 199
            } catch (e) {                                                                                              // 200
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 207
            }                                                                                                          // 208
                                                                                                                       //
            try {                                                                                                      // 210
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 211
            } catch (err) {                                                                                            // 212
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 217
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 221
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 223
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 225
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 227
            }                                                                                                          // 229
          });                                                                                                          // 230
        })();                                                                                                          // 187
      } else {                                                                                                         // 231
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 232
        res.on("data", function (chunk) {                                                                              // 234
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 235
        });                                                                                                            // 236
      }                                                                                                                // 237
    };                                                                                                                 // 238
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 240
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 242
      rawHostname: SANDCATS_NAME,                                                                                      // 243
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 244
    }, errorCallback, responseCallback);                                                                               // 242
  };                                                                                                                   // 246
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 248
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 249
    return renewHttpsCertificate();                                                                                    // 250
  }                                                                                                                    // 251
};                                                                                                                     // 252
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 254
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 255
  if (i < 0) {                                                                                                         // 256
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 259
    var oneMinute = 60 * 1000;                                                                                         // 260
    var oneHour = 60 * oneMinute;                                                                                      // 261
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 262
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 264
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 265
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 267
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 269
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 273
    }                                                                                                                  // 275
  }                                                                                                                    // 276
};                                                                                                                     // 277
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 279
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 280
};                                                                                                                     // 281
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":["/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var staticAssetHost;module.import("/imports/server/constants.js",{"staticAssetHost":function(v){staticAssetHost=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
Meteor.startup(function () {                                                                                           // 37
  var frameSetter = function frameSetter() {                                                                           // 38
    BrowserPolicy.content.disallowFrame(); // This clears all the old rules                                            // 39
    BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                       // 40
    var billingPromptUrl = globalDb.getBillingPromptUrl();                                                             // 41
    if (billingPromptUrl) {                                                                                            // 42
      BrowserPolicy.content.allowFrameOrigin(billingPromptUrl);                                                        // 43
    }                                                                                                                  // 44
  };                                                                                                                   // 45
                                                                                                                       //
  frameSetter(); // Call once on startup                                                                               // 47
  globalDb.collections.settings.find({ _id: "billingPromptUrl" }).observe({                                            // 48
    added: frameSetter,                                                                                                // 49
    changed: frameSetter,                                                                                              // 50
    removed: frameSetter                                                                                               // 51
  });                                                                                                                  // 48
});                                                                                                                    // 53
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
                                                                                                                       // 56
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 57
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 58
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 59
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 60
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 62
  var _this = this;                                                                                                    // 62
                                                                                                                       //
  if (this.userId) {                                                                                                   // 63
    if (globalDb.isQuotaEnabled()) {                                                                                   // 64
      (function () {                                                                                                   // 64
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 69
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 70
          inMeteor(function () {                                                                                       // 71
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 72
          });                                                                                                          // 73
        })["catch"](function (err) {                                                                                   // 74
          if (err.kjType === "unimplemented") {                                                                        // 75
            // Compute based on sum of grain sizes instead.                                                            //
            var total = 0;                                                                                             // 77
            Grains.find({ userId: userId }, { fields: { size: 1 } }).forEach(function (grain) {                        // 78
              return total += grain.size || 0;                                                                         // 79
            });                                                                                                        // 79
            Meteor.users.update(userId, { $set: { storageUsage: total } });                                            // 80
          } else {                                                                                                     // 81
            console.error(err.stack);                                                                                  // 82
          }                                                                                                            // 83
        });                                                                                                            // 84
      })();                                                                                                            // 64
    }                                                                                                                  // 85
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 87
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 93
    return [];                                                                                                         // 94
  }                                                                                                                    // 95
});                                                                                                                    // 96
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 98
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 102
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 103
});                                                                                                                    // 104
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 106
  return DevPackages.find();                                                                                           // 107
});                                                                                                                    // 108
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 110
  var _this2 = this;                                                                                                   // 110
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 114
  if (cursor.count() > 0) {                                                                                            // 115
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 116
  } else {                                                                                                             // 117
    (function () {                                                                                                     // 117
      var handle = cursor.observeChanges({                                                                             // 118
        added: function added(id) {                                                                                    // 119
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 120
          handle.stop();                                                                                               // 121
          handle = null;                                                                                               // 122
        }                                                                                                              // 123
      });                                                                                                              // 118
      _this2.onStop(function () {                                                                                      // 125
        if (handle) handle.stop();                                                                                     // 126
      });                                                                                                              // 127
    })();                                                                                                              // 117
  }                                                                                                                    // 128
                                                                                                                       //
  this.ready();                                                                                                        // 130
});                                                                                                                    // 131
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 133
  var _this3 = this;                                                                                                   // 133
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 142
    return [];                                                                                                         // 143
  }                                                                                                                    // 144
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 152
    referredBy: this.userId,                                                                                           // 153
    "profile.name": { $exists: true }                                                                                  // 154
  }, {                                                                                                                 // 152
    fields: {                                                                                                          // 156
      _id: 1,                                                                                                          // 157
      referredBy: 1,                                                                                                   // 158
      "profile.name": 1                                                                                                // 159
    }                                                                                                                  // 156
  });                                                                                                                  // 155
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 162
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 164
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 165
    },                                                                                                                 // 166
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 169
      _this3.removed("referralInfo", id);                                                                              // 170
    },                                                                                                                 // 171
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 173
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 174
    }                                                                                                                  // 175
  });                                                                                                                  // 162
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 186
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 187
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 188
      stopWatchingIdentity(identityId);                                                                                // 189
    });                                                                                                                // 190
  };                                                                                                                   // 191
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 193
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 194
    if (handleForProfileName) {                                                                                        // 195
      _this3.removed("referralInfo", identityId);                                                                      // 196
      handleForProfileName.stop();                                                                                     // 197
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 199
    }                                                                                                                  // 200
  };                                                                                                                   // 201
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 203
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 204
    if (handleForProfileName) {                                                                                        // 205
      return;                                                                                                          // 206
    }                                                                                                                  // 207
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 209
      _id: identityId                                                                                                  // 210
    }, {                                                                                                               // 209
      fields: {                                                                                                        // 212
        "profile.name": 1                                                                                              // 213
      }                                                                                                                // 212
    }).observeChanges({                                                                                                // 211
      added: function added(id, fields) {                                                                              // 216
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 217
      },                                                                                                               // 218
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 220
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 221
      },                                                                                                               // 222
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 224
        stopWatchingIdentity(id);                                                                                      // 225
      }                                                                                                                // 226
    });                                                                                                                // 215
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 229
  };                                                                                                                   // 230
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 232
    _id: this.userId,                                                                                                  // 233
    referredIdentityIds: { $exists: true }                                                                             // 234
  }, {                                                                                                                 // 232
    fields: {                                                                                                          // 236
      referredIdentityIds: true                                                                                        // 237
    }                                                                                                                  // 236
  }).observeChanges({                                                                                                  // 235
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 241
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 242
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 244
      }                                                                                                                // 246
    },                                                                                                                 // 247
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 250
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 258
      fields.referredIdentityIds.forEach(function (i) {                                                                // 259
        referredIdentityIdsAsObject[i] = true;                                                                         // 259
      });                                                                                                              // 259
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 261
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 264
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 265
          stopWatchingIdentity(identityId);                                                                            // 266
        }                                                                                                              // 267
      });                                                                                                              // 268
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 271
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 273
      }                                                                                                                // 274
    },                                                                                                                 // 275
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 277
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 279
    }                                                                                                                  // 280
  });                                                                                                                  // 239
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 284
    stopWatchingAllIdentities();                                                                                       // 285
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 286
    completedIdentityIdsHandle.stop();                                                                                 // 287
  });                                                                                                                  // 288
                                                                                                                       //
  this.ready();                                                                                                        // 290
});                                                                                                                    // 291
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 293
  var _this4 = this;                                                                                                   // 293
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 294
  var anonCount = 0;                                                                                                   // 295
  var counter = 0;                                                                                                     // 296
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 298
    name = name.trim();                                                                                                // 299
    if (name === "") {                                                                                                 // 300
      ++anonCount;                                                                                                     // 301
    } else {                                                                                                           // 302
      _this4.added("backers", counter++, { name: name });                                                              // 303
    }                                                                                                                  // 304
  });                                                                                                                  // 305
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 308
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 310
                                                                                                                       //
  this.ready();                                                                                                        // 312
});                                                                                                                    // 313
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                // 35
    });                                                                                                                // 36
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var now = new Date();                                                                                                // 168
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 176
    timestamp: now,                                                                                                    // 177
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 178
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 179
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 180
    forever: computeStats(new Date(0)),                                                                                // 181
    plans: planStats                                                                                                   // 182
  };                                                                                                                   // 176
  record.computeTime = Date.now() - now;                                                                               // 184
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 186
  var age = ActivityStats.find().count();                                                                              // 187
  if (age > 3) {                                                                                                       // 188
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 189
    if (!reportSetting) {                                                                                              // 190
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 194
    } else if (reportSetting.value === true) {                                                                         // 195
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 200
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 202
        data: record,                                                                                                  // 203
        headers: {                                                                                                     // 204
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 205
          "Content-Type": "application/json"                                                                           // 206
        }                                                                                                              // 204
      });                                                                                                              // 202
    }                                                                                                                  // 209
  }                                                                                                                    // 210
}                                                                                                                      // 211
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 213
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 216
    Meteor.setInterval(function () {                                                                                   // 217
      recordStats();                                                                                                   // 218
    }, DAY_MS);                                                                                                        // 219
                                                                                                                       //
    recordStats();                                                                                                     // 221
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 222
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 224
    if (StatsTokens.find().count() === 0) {                                                                            // 225
      StatsTokens.remove({});                                                                                          // 226
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 227
    }                                                                                                                  // 228
  });                                                                                                                  // 229
}                                                                                                                      // 230
                                                                                                                       //
Meteor.methods({                                                                                                       // 232
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 233
    if (!isAdmin()) {                                                                                                  // 234
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 235
    }                                                                                                                  // 236
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 238
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 239
    return token._id;                                                                                                  // 240
  }                                                                                                                    // 241
});                                                                                                                    // 232
                                                                                                                       //
Router.map(function () {                                                                                               // 244
  this.route("fetchStats", {                                                                                           // 245
    where: "server",                                                                                                   // 246
    path: "/fetchStats/:tokenId",                                                                                      // 247
    action: function action() {                                                                                        // 248
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 249
                                                                                                                       //
      if (!token) {                                                                                                    // 251
        this.response.writeHead(404, {                                                                                 // 252
          "Content-Type": "text/plain"                                                                                 // 253
        });                                                                                                            // 252
        this.response.write("Token not found");                                                                        // 255
        return this.response.end();                                                                                    // 256
      }                                                                                                                // 257
                                                                                                                       //
      try {                                                                                                            // 259
        var stats = ActivityStats.find().fetch();                                                                      // 260
        var statsString = JSON.stringify(stats);                                                                       // 261
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 263
          "Content-Type": "application/json"                                                                           // 264
        });                                                                                                            // 263
        this.response.write(statsString);                                                                              // 266
      } catch (error) {                                                                                                // 267
        console.error(error.stack);                                                                                    // 268
        this.response.writeHead(500, {                                                                                 // 269
          "Content-Type": "text/plain"                                                                                 // 270
        });                                                                                                            // 269
        this.response.write(error.stack);                                                                              // 272
      }                                                                                                                // 273
                                                                                                                       //
      return this.response.end();                                                                                      // 275
    }                                                                                                                  // 276
  });                                                                                                                  // 245
});                                                                                                                    // 278
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// TODO(someday): split out fields by locus                                                                            //
// isEnabled is available on both client and server                                                                    //
// getLoginId is only used on server                                                                                   //
// initiateLogin and loginTemplate are only used on client                                                             //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 22
  var setting = Settings.findOne({ _id: name });                                                                       // 23
  return setting && !!setting.value;                                                                                   // 24
}                                                                                                                      // 25
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 27
  isEnabled: function isEnabled() {                                                                                    // 28
    return serviceEnabled("github");                                                                                   // 29
  },                                                                                                                   // 30
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 32
    return identity.services.github.username;                                                                          // 33
  },                                                                                                                   // 34
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 36
    Meteor.loginWithGithub();                                                                                          // 37
    return { oneClick: true };                                                                                         // 38
  },                                                                                                                   // 39
                                                                                                                       //
  loginTemplate: {                                                                                                     // 41
    name: "oauthLoginButton",                                                                                          // 42
    priority: 1,                                                                                                       // 43
    data: {                                                                                                            // 44
      method: "loginWithGithub",                                                                                       // 45
      name: "github",                                                                                                  // 46
      displayName: "GitHub",                                                                                           // 47
      linkingNewIdentity: false                                                                                        // 48
    }                                                                                                                  // 44
  }                                                                                                                    // 41
};                                                                                                                     // 27
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 53
  isEnabled: function isEnabled() {                                                                                    // 54
    return serviceEnabled("google");                                                                                   // 55
  },                                                                                                                   // 56
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 58
    return identity.services.google.email;                                                                             // 59
  },                                                                                                                   // 60
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 62
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 63
    return { oneClick: true };                                                                                         // 64
  },                                                                                                                   // 65
                                                                                                                       //
  loginTemplate: {                                                                                                     // 67
    name: "oauthLoginButton",                                                                                          // 68
    priority: 2,                                                                                                       // 69
    data: {                                                                                                            // 70
      method: "loginWithGoogle",                                                                                       // 71
      name: "google",                                                                                                  // 72
      displayName: "Google",                                                                                           // 73
      linkingNewIdentity: false                                                                                        // 74
    }                                                                                                                  // 70
  }                                                                                                                    // 67
};                                                                                                                     // 53
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 79
  isEnabled: function isEnabled() {                                                                                    // 80
    return serviceEnabled("emailToken");                                                                               // 81
  },                                                                                                                   // 82
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 84
    return identity.services.email.email;                                                                              // 85
  },                                                                                                                   // 86
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 88
    return { form: true };                                                                                             // 89
  },                                                                                                                   // 90
                                                                                                                       //
  loginTemplate: {                                                                                                     // 92
    name: "emailLoginForm",                                                                                            // 93
    priority: 10                                                                                                       // 94
  }                                                                                                                    // 92
};                                                                                                                     // 79
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 98
  isEnabled: function isEnabled() {                                                                                    // 99
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 100
  },                                                                                                                   // 101
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 103
    return identity.services.ldap.username;                                                                            // 104
  },                                                                                                                   // 105
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 107
    return { form: true };                                                                                             // 108
  },                                                                                                                   // 109
                                                                                                                       //
  loginTemplate: {                                                                                                     // 111
    name: "ldapLoginForm",                                                                                             // 112
    priority: 21 }                                                                                                     // 113
};                                                                                                                     // 98
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 117
  isEnabled: function isEnabled() {                                                                                    // 118
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 119
  },                                                                                                                   // 120
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 122
    return identity.services.saml.id;                                                                                  // 123
  },                                                                                                                   // 124
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 126
    Meteor.loginWithSaml();                                                                                            // 127
    return { oneClick: true };                                                                                         // 128
  },                                                                                                                   // 129
                                                                                                                       //
  loginTemplate: {                                                                                                     // 131
    name: "samlLoginForm",                                                                                             // 132
    priority: 20 }                                                                                                     // 133
};                                                                                                                     // 117
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 137
  isEnabled: function isEnabled() {                                                                                    // 138
    return false; // You can never authenticate as a demo user.                                                        // 139
  },                                                                                                                   // 140
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 142
    return identity._id;                                                                                               // 143
  },                                                                                                                   // 144
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 146
    return { demoCannotLogin: true };                                                                                  // 147
  },                                                                                                                   // 148
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 150
};                                                                                                                     // 137
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        //
  // potential.                                                                                                        //
  //                                                                                                                   //
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             //
                                                                                                                       //
  markActivityReadByOwner: function markActivityReadByOwner(grainId) {                                                 // 23
    check(grainId, String);                                                                                            // 24
    check(this.userId, String);                                                                                        // 25
                                                                                                                       //
    Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                  // 27
  },                                                                                                                   // 29
                                                                                                                       //
  markActivityRead: function markActivityRead(grainId, identityId) {                                                   // 31
    check(grainId, String);                                                                                            // 32
    check(identityId, String);                                                                                         // 33
                                                                                                                       //
    if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                          // 35
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 36
    }                                                                                                                  // 37
                                                                                                                       //
    ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
  }                                                                                                                    // 41
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        },                                                                                                             // 53
                                                                                                                       //
        fetchAppIndexTest: function fetchAppIndexTest() {                                                              // 55
          globalDb.collections.appIndex.remove({});                                                                    // 56
          SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                         // 57
        }                                                                                                              // 58
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 60
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 62
    Meteor.call("createMockGithubUser", function (err) {                                                               // 63
      if (err) {                                                                                                       // 64
        console.log(err);                                                                                              // 65
      }                                                                                                                // 66
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 68
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 69
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 70
      window.location.reload();                                                                                        // 71
    });                                                                                                                // 72
  };                                                                                                                   // 73
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 75
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 76
      if (err) {                                                                                                       // 77
        console.log(err);                                                                                              // 78
      }                                                                                                                // 79
    });                                                                                                                // 80
  };                                                                                                                   // 81
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 83
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 84
      if (err) {                                                                                                       // 85
        console.log(err);                                                                                              // 86
      }                                                                                                                // 87
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 89
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 90
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 91
      window.location.reload();                                                                                        // 92
    });                                                                                                                // 93
  };                                                                                                                   // 94
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 96
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 97
      if (err) {                                                                                                       // 98
        console.log(err);                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 101
  };                                                                                                                   // 102
}                                                                                                                      // 103
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/accounts/email-token/token-server.js");
require("./server/accounts/identity/identity-server.js");
require("./server/accounts/ldap/ldap-server.js");
require("./server/accounts/saml/saml-server.js");
require("./server/accounts/accounts-server.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/contacts-server.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
